// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <malloc.h>
#include <string.h>
#include <glib.h>
#include <unistd.h>
#include <math.h>

char* pwd;
int current_day;
int current_year;
int NB_JOUR_PLANNING=7;
GData **DB_day;
GSList *DB_day_index;
GString *file_to_save;
GString *plugin_file;
GString *visual_string;
GString *script_file;
gint is_modifying;
int changing_week;

GtkWidget *button_0h[7];
GtkWidget *button_1h[7];
GtkWidget *button_2h[7];
GtkWidget *button_3h[7];
GtkWidget *button_4h[7];
GtkWidget *button_5h[7];
GtkWidget *button_6h[7];
GtkWidget *button_7h[7];
GtkWidget *button_8h[7];
GtkWidget *button_9h[7];
GtkWidget *button_10h[7];
GtkWidget *button_11h[7];
GtkWidget *button_12h[7];
GtkWidget *button_13h[7];
GtkWidget *button_14h[7];
GtkWidget *button_15h[7];
GtkWidget *button_16h[7];
GtkWidget *button_17h[7];
GtkWidget *button_18h[7];
GtkWidget *button_19h[7];
GtkWidget *button_20h[7];
GtkWidget *button_21h[7];
GtkWidget *button_22h[7];
GtkWidget *button_23h[7];
GtkWidget *radio[8];
int multiple_selection;
int selection[7];

struct s_day{
    int day_in_month;
    int day_in_week;
    int month;
    int year;
    int error;
};

typedef struct s_day s_day;

int is_year_bissex(int year,int ref_year)
{
    int bissex=0;

    if(year%400==0)bissex=1;
    else if(year%100==0)bissex=0;
    else if(year%4==0)bissex=1;
    else bissex=0;

    return bissex;
}

int num_month(int day_in_year,int bissex)
{
    int jour_mois[] = {31,28,31,30,31,30,31,31,30,31,30,31};
    int jour_mois_bissex[] = {31,29,31,30,31,30,31,31,30,31,30,31};

    int i=0;

    while(day_in_year>0)
    {
        if(bissex)day_in_year-=jour_mois_bissex[i];
        else day_in_year-=jour_mois[i];

        i++;
    }

    return i;
}

int num_day(int day_in_year,int bissex)
{
    int jour_mois[] = {31,28,31,30,31,30,31,31,30,31,30,31};
    int jour_mois_bissex[] = {31,29,31,30,31,30,31,31,30,31,30,31};

    int i=0,j=0;

    while(day_in_year>0)
    {
        i=day_in_year;
        if(bissex)day_in_year-=jour_mois_bissex[j];
        else day_in_year-=jour_mois[j];
        j++;
    }

    return i;
}

int get_timestamp(char *date)
{
    char jour[20];
    char mois[20];
    char num_jour[10];
    char annee[10];
    int nb_annee=0,nb_jour=0,nb_mois=0;
    int i,j;

//   // printf("date : %s",date);

//   // printf("\ntime:\n");
    for(i=0,j=0;date[i]!=' ';i++,j++)
    {
        jour[j]=date[i];
//       // printf("%c %c,",date[i],jour[j]);
    }
    i++;
    jour[j]='\0';
//   // printf("\nresultat : %s\n",jour);

//   // printf("time:\n");
    for(i=i,j=0;date[i]!=' ';i++,j++)
    {
        num_jour[j]=date[i];
//       // printf("%c %c,",date[i],num_jour[j]);
    }
    i++;
    num_jour[j]='\0';
//   // printf("\nresultat : %s\n",num_jour);

//   // printf("time:\n");
    for(i=i,j=0;date[i]!=' ';i++,j++)
    {
        mois[j]=date[i];
//       // printf("%c %c,",date[i],mois[j]);
    }
    i++;
    mois[j]='\0';
//   // printf("\nresultat : %s\n",mois);

//   // printf("time:\n");
    for(i=i,j=0;date[i]!=' ';i++,j++)
    {
        annee[j]=date[i];
//       // printf("%c %c,",date[i],annee[j]);
    }
    i++;
    annee[j]='\0';
//   // printf("\nresultat : %s\n",annee);

    sscanf(num_jour,"%d",&nb_jour);
    sscanf(annee,"%d",&nb_annee);

    if(strcmp(mois,"Janvier")==0)nb_mois=1;
    if(strcmp(mois,"Février")==0)nb_mois=2;
    if(strcmp(mois,"Mars")==0)nb_mois=3;
    if(strcmp(mois,"Avril")==0)nb_mois=4;
    if(strcmp(mois,"Mai")==0)nb_mois=5;
    if(strcmp(mois,"Juin")==0)nb_mois=6;
    if(strcmp(mois,"Juillet")==0)nb_mois=7;
    if(strcmp(mois,"Août")==0)nb_mois=8;
    if(strcmp(mois,"Septembre")==0)nb_mois=9;
    if(strcmp(mois,"Octobre")==0)nb_mois=10;
    if(strcmp(mois,"Novembre")==0)nb_mois=11;
    if(strcmp(mois,"Décembre")==0)nb_mois=12;

//   // printf("jour %s: %d\n",jour,nb_jour);
//   // printf("mois %s: %d\n",mois,nb_mois);
//   // printf("annee %s: %d\n",annee,nb_annee);

    return nb_annee+nb_mois*10000+nb_jour*1000000;
}

s_day* get_day(int day_in_year,int year,int ref_day,int ref_month, int ref_year,int ref_bissex,int ref_num_day)
{
    /*
    day_in_year : numéro du jour dans l'année désirée
    year : numéro d'année désiré
    ref_day : jour de référence pour les calculs
    ref_month : mois de référence pour les calculs
    ref_year : année de référence pour les calculs
    ref_bissex : année bissextile de référence pour les calculs
    ref_num_day : numéro du jour dans la semaine de référence pour les calculs
    */

    s_day *day;
    int decalage_ref=0;//décalage des jours entre la référence et l'année courante pour un jour donné
    int decalage_mois=0;//décalage entre le mois de référence et le mois demandé
    int i; //variable de calcul
    int calc_day;
    int calc_month;
    int num_day_sem=0;

    int decalages_jour[] = {3,0,3,2,3,2,3,3,2,3,2,3};
    int decalages_jour_bissex[] = {3,1,3,2,3,2,3,3,2,3,2,3};

    day = malloc(sizeof(struct s_day));

   // printf("day_in_year: %d \n year: %d \n ref_day: %d \n ref_month: %d \n ref_year: %d \n ref_bissex: %d \n ref_num_day: %d \n",day_in_year,year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
/*
    if(day_in_year > 366)
    {
        day->error = 1;
        return day;
    }
*/
    if(year < ref_year)
    {
        day->error = 2;
        return day;
    }

    for(i=ref_year;i!=year;i++)
    {
        if(is_year_bissex(i,ref_year))decalage_ref+=2;
        else decalage_ref+=1;
    }
    decalage_ref%=7;

    calc_month = num_month(day_in_year,is_year_bissex(year,ref_year));

    calc_day = num_day(day_in_year,is_year_bissex(year,ref_year));

    decalage_mois = 0;

    if(calc_month>ref_month)
    {
        for(i=ref_month-1;i<calc_month-1;i++)
        {
            if(is_year_bissex(year,ref_year)) decalage_mois += decalages_jour_bissex[i];
            else decalage_mois += decalages_jour[i];
        }
    }

    if(calc_month<ref_month)
    {
        for(i=calc_month-1;i<ref_month-1;i++)
        {
            if(is_year_bissex(year,ref_year)) decalage_mois += decalages_jour_bissex[i];
            else decalage_mois += decalages_jour[i];
        }
    }

    if(calc_month==13)
    {
        calc_month=1;
        year+=1;
    }

    if(ref_day==1)num_day_sem = ref_num_day+decalage_ref;
    if(ref_day>1)num_day_sem = (ref_num_day+decalage_ref) - ((ref_day-1)%7);
    while(num_day_sem<0)num_day_sem+=7;

//    //fprintf(stderr,"num_day_sem: %d\n",num_day_sem);

    num_day_sem += decalage_mois;
    num_day_sem += calc_day-1;
    num_day_sem%=7;
    if(num_day_sem==0)num_day_sem=7;

//    //fprintf(stderr,"décalage_mois: %d\n",decalage_mois);
//    //fprintf(stderr,"num_sem: %d, jour: %d, mois: %d, année: %d\n",num_day_sem,calc_day,calc_month,year);

    day->day_in_month=calc_day;
    day->day_in_week=num_day_sem;
    day->month=calc_month;
    day->year=year;

    return day;

}

void next_w(GtkWidget *button,gpointer user_data)
{
    GSList *list = (GSList*)user_data;
    char* week_string;
    int i,j;
    s_day* day;
    int ref_day = 1;
    int ref_month = 1;
    int ref_year = 2000;
    int ref_bissex = 2000;
    int ref_num_day = 6;
    int size;
    const char *tab_day[] = {"Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi","Dimanche"};
    const char *tab_month[] = {"Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"};
    char chaine_hash[6];

    int time1,time2;
    int quark,quark_in_index=0;
    GString *s_label;
    GSList *DB_planned_days;

    changing_week = 1;

    current_day+=NB_JOUR_PLANNING;


    if(is_year_bissex(current_year,ref_year))
    {
        if(current_day>366)
        {
            current_day-=366;
            current_year+=1;
        }
    }
    else
    {
        if(current_day>365)
        {
            current_day-=365;
            current_year+=1;
        }
    }

    for(i=0;i<NB_JOUR_PLANNING;i++)
    {
        if(is_year_bissex(current_year,ref_year))
        {
            if(current_day+i<1)
            {
                day = get_day(current_day+i+366,current_year-1,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
            }
            else
            {
                if(current_day+i>366)day = get_day(current_day+i-366,current_year+1,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
                else day = get_day(current_day+i,current_year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
            }
        }else{
            if(current_day+i<1)
            {
                day = get_day(current_day+i+365,current_year-1,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
            }
            else
            {
                if(current_day+i>365)
                {
                    day = get_day(current_day+i-365,current_year+1,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
                }
                else
                {
                    day = get_day(current_day+i,current_year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
                }
            }
        }
        //fprintf(stderr,"%d %d\n",current_day+i,current_year);

        if(day->day_in_month<10)
        {
            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);
        }
        else
        {
            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);
        }

        snprintf(week_string,size,"%s %d %s %d ",tab_day[day->day_in_week-1],day->day_in_month,tab_month[day->month-1],day->year);

        //fprintf(stderr,"%s\n",week_string);

        gtk_label_set_text(GTK_LABEL(g_slist_nth_data(list,i)),week_string);
        gtk_combo_box_set_active(GTK_COMBO_BOX(g_slist_nth_data(list,i+1)),day->month-1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(g_slist_nth_data(list,i+2)),day->year);

        free(week_string);
    }

    for(j=0;j<NB_JOUR_PLANNING;j++)
    {
        //fprintf(stderr,"hash 1\n");

        s_label = g_string_new(gtk_label_get_text(g_slist_nth_data(list,j)));
//        sprintf(chaine_hash," %d",current_year);
//        g_string_append(s_label,chaine_hash);
        quark = get_timestamp(s_label->str);//g_string_hash(s_label);
        //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);
        g_free(g_string_free(s_label,TRUE));

        for(i=0;(i<g_slist_length(DB_day_index))&&(quark_in_index==0);i++)
        {
            if(quark==(int)g_slist_nth_data(DB_day_index,i))quark_in_index=1;
        }

        gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NONE);

        if(quark_in_index)
        {
            DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);

            for(i=1;i<g_slist_length(DB_planned_days);i+=2)
            {
                time1 = (int)g_slist_nth_data(DB_planned_days,i);
                time2 = (int)g_slist_nth_data(DB_planned_days,i+1);

                if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                    gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                    gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                    gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                    gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                    gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                    gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                    gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                    gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                    gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                    gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                    gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                    gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                    gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                    gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                    gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                    gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                    gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                    gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                    gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                    gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                    gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                    gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                    gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                    gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NORMAL);

            }
        }
    }
    changing_week = 0;
}

void last_w(GtkWidget *button,gpointer user_data)
{
    GSList *list = (GSList*)user_data;
    char* week_string;
    int i,j;
    s_day* day;
    int ref_day = 1;
    int ref_month = 1;
    int ref_year = 2000;
    int ref_bissex = 2000;
    int ref_num_day = 6;
    int size;
    const char *tab_day[] = {"Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi","Dimanche"};
    const char *tab_month[] = {"Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"};
    char chaine_hash[6];

    int time1,time2;
    int quark,quark_in_index=0;
    GString *s_label;
    GSList *DB_planned_days;

    changing_week = 1;


    //fprintf(stderr,"current day : %d\n",current_day);

    if(current_day>NB_JOUR_PLANNING)
    {
        current_day-=NB_JOUR_PLANNING;
    }
    else
    {
        current_year-=1;
        if(current_year>=ref_year)
        {
            if(is_year_bissex(current_year,ref_year))current_day=366-current_day;
            else current_day=365-current_day;
        }
        else current_year+=1;
    }

    //fprintf(stderr,"new current day : %d\n",current_day);

    day = get_day(current_day,current_year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);

    if(day->day_in_week!=1)current_day=current_day-day->day_in_week+1;

    //fprintf(stderr,"new current day corrected : %d, day_in_week = %d\n",current_day,day->day_in_week);

    for(i=0;i<NB_JOUR_PLANNING;i++)
    {
        if(is_year_bissex(current_year,ref_year))
        {
            if(current_day+i>366)day = get_day(current_day+i-366,current_year+1,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
            else day = get_day(current_day+i,current_year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
        }else{
            if(current_day+i>365)day = get_day(current_day+i-365,current_year+1,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
            else day = get_day(current_day+i,current_year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
        }

        if(day->day_in_month<10)
        {
            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);
        }
        else
        {
            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);
        }

        snprintf(week_string,size,"%s %d %s %d ",tab_day[day->day_in_week-1],day->day_in_month,tab_month[day->month-1],day->year);

        //fprintf(stderr,"%s\n",week_string);

        gtk_label_set_text(GTK_LABEL(g_slist_nth_data(list,i)),week_string);
        gtk_combo_box_set_active(GTK_COMBO_BOX(g_slist_nth_data(list,i+1)),day->month-1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(g_slist_nth_data(list,i+2)),day->year);

        free(week_string);
    }

    for(j=0;j<NB_JOUR_PLANNING;j++)
    {
        //fprintf(stderr,"hash 2\n");

        s_label = g_string_new(gtk_label_get_text(g_slist_nth_data(list,j)));
   //     sprintf(chaine_hash," %d",current_year);
    //    g_string_append(s_label,chaine_hash);
        quark = get_timestamp(s_label->str);//g_string_hash(s_label);
        //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

        g_free(g_string_free(s_label,TRUE));

        for(i=0;(i<g_slist_length(DB_day_index))&&(quark_in_index==0);i++)
        {
            if(quark==g_slist_nth_data(DB_day_index,i))quark_in_index=1;
        }

        gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NONE);
        gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NONE);

        if(quark_in_index)
        {
            DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);

            for(i=1;i<g_slist_length(DB_planned_days);i+=2)
            {
                time1 = g_slist_nth_data(DB_planned_days,i);
                time2 = g_slist_nth_data(DB_planned_days,i+1);

                if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                    gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                    gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                    gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                    gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                    gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                    gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                    gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                    gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                    gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                    gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                    gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                    gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                    gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                    gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                    gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                    gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                    gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                    gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                    gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                    gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                    gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                    gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                    gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                    gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NORMAL);

            }
        }
    }
    changing_week = 0;
}

int get_first_monday(int month,int year)
{
    int ref_day = 1;
    int ref_month = 1;
    int ref_year = 2000;
    int ref_bissex = 2000;
    int ref_num_day = 6;
    int jour_mois[] = {31,28,31,30,31,30,31,31,30,31,30,31};
    int jour_mois_bissex[] = {31,29,31,30,31,30,31,31,30,31,30,31};
    int first_day=1;
    int i,day_sem=0;
    s_day *day;

    if(is_year_bissex(year,ref_year))
    {
        for(i=2;i<=month;i++)
        {
            first_day+=jour_mois_bissex[i-2];
        }
    }
    else
    {
        for(i=2;i<=month;i++)
        {
            first_day+=jour_mois[i-2];
        }
    }

    for(i=first_day;day_sem!=1;i++)
    {
        day = get_day(i,year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
        day_sem = day->day_in_week;
    }
    first_day=i-1;
//    //fprintf(stderr,"............................\n");

    return first_day;
}

void month_changed(GtkComboBox *widget,gpointer user_data)
{
    GSList *list = (GSList*)user_data;
    char* week_string;
    int i,j;
    s_day* day;
    int ref_day = 1;
    int ref_month = 1;
    int ref_year = 2000;
    int ref_bissex = 2000;
    int ref_num_day = 6;
    int size;
    const char *tab_day[] = {"Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi","Dimanche"};
    const char *tab_month[] = {"Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"};
    char chaine_hash[6];
    GString *s_label;
    GSList *DB_planned_days=NULL;
    int quark;
    int time1,time2,quark_in_index=0;
    int month;
    int year;
    int first_day;

    if(changing_week != 1)
    {
        month = gtk_combo_box_get_active(GTK_COMBO_BOX((gpointer)g_slist_nth_data(list,NB_JOUR_PLANNING)));
        year = gtk_spin_button_get_value(GTK_SPIN_BUTTON((gpointer)g_slist_nth_data(list,NB_JOUR_PLANNING+1)));
        first_day = get_first_monday(month+1,year);

        for(i=0;i<NB_JOUR_PLANNING;i++)
        {
            day = get_day(first_day+i,year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);

            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);

            snprintf(week_string,size,"%s %d %s %d ",tab_day[day->day_in_week-1],day->day_in_month,tab_month[day->month-1],day->year);

            //fprintf(stderr,"month changed : %s\n",week_string);

            gtk_label_set_text(GTK_LABEL((gpointer)g_slist_nth_data(list,i)),week_string);

            free(week_string);
        }
        current_day = first_day;
        current_year = year;

       for(j=0;j<NB_JOUR_PLANNING;j++)
        {
            s_label = g_string_new(gtk_label_get_text(g_slist_nth_data(list,j)));
        //    sprintf(chaine_hash," %d",current_year);
        //    g_string_append(s_label,chaine_hash);
            quark = get_timestamp(s_label->str);//g_string_hash(s_label);
            //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);
            g_free(g_string_free(s_label,TRUE));

            for(i=0;(i<g_slist_length(DB_day_index))&&(quark_in_index==0);i++)
            {
                if(quark==(int)g_slist_nth_data(DB_day_index,i))quark_in_index=1;
            }

            gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NONE);

            if(quark_in_index)
            {
                DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);

                for(i=1;i<g_slist_length(DB_planned_days);i+=2)
                {
                    time1 = (int)g_slist_nth_data(DB_planned_days,i);
                    time2 = (int)g_slist_nth_data(DB_planned_days,i+1);

                    if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                        gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                        gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                        gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                        gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                        gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                        gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                        gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                        gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                        gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                        gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                        gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                        gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                        gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                        gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                        gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                        gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                        gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                        gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                        gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                        gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                        gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                        gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                        gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                        gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NORMAL);

                }
            }
        }

    }
}

void year_changed(GtkSpinButton *spinbutton, gpointer user_data)
{
    GSList *list = (GSList*)user_data;
    char* week_string;
    int i,j;
    s_day* day;
    int ref_day = 1;
    int ref_month = 1;
    int ref_year = 2000;
    int ref_bissex = 2000;
    int ref_num_day = 6;
    int size;
    const char *tab_day[] = {"Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi","Dimanche"};
    const char *tab_month[] = {"Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"};
    char chaine_hash[6];
    GString *s_label;
    GSList *DB_planned_days=NULL;
    int quark;
    int time1,time2,quark_in_index=0;

    int month;
    int year;
    int first_day;

    if(changing_week != 1)
    {

        month = gtk_combo_box_get_active(GTK_COMBO_BOX((gpointer)g_slist_nth_data(list,NB_JOUR_PLANNING)));
        year = gtk_spin_button_get_value(GTK_SPIN_BUTTON((gpointer)g_slist_nth_data(list,NB_JOUR_PLANNING+1)));
        first_day = get_first_monday(month+1,year);

        for(i=0;i<NB_JOUR_PLANNING;i++)
        {
            day = get_day(first_day+i,year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);

            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);

            snprintf(week_string,size,"%s %d %s %d ",tab_day[day->day_in_week-1],day->day_in_month,tab_month[day->month-1],day->year);

            //fprintf(stderr,"%s\n",week_string);

            gtk_label_set_text(GTK_LABEL((gpointer)g_slist_nth_data(list,i)),week_string);

            free(week_string);
        }
        current_day = first_day;
        current_year = year;

       for(j=0;j<NB_JOUR_PLANNING;j++)
        {
            s_label = g_string_new(gtk_label_get_text(g_slist_nth_data(list,j)));
        //    sprintf(chaine_hash," %d",current_year);
        //    g_string_append(s_label,chaine_hash);
            quark = get_timestamp(s_label->str);//g_string_hash(s_label);
            //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);
            g_free(g_string_free(s_label,TRUE));

            for(i=0;(i<g_slist_length(DB_day_index))&&(quark_in_index==0);i++)
            {
                if(quark==(int)g_slist_nth_data(DB_day_index,i))quark_in_index=1;
            }

            gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NONE);

            if(quark_in_index)
            {
                DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);

                for(i=1;i<g_slist_length(DB_planned_days);i+=2)
                {
                    time1 = (int)g_slist_nth_data(DB_planned_days,i);
                    time2 = (int)g_slist_nth_data(DB_planned_days,i+1);

                    if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                        gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                        gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                        gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                        gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                        gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                        gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                        gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                        gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                        gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                        gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                        gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                        gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                        gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                        gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                        gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                        gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                        gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                        gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                        gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                        gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                        gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                        gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                        gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                        gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NORMAL);

                }
            }
        }
    }
}

void save_day(int hash,GSList *intervals)
{
    int present=0,i=0;
    GSList *copy_intervals = NULL;

    copy_intervals = g_slist_copy(intervals);

    //fprintf(stderr,"addr 1 : %d, addr 2 : %d\n",intervals,copy_intervals);

    g_datalist_id_set_data(&DB_day,hash,copy_intervals);

    for(i=0;i<g_slist_length(DB_day_index);i++)
    {
        if(g_slist_nth_data(DB_day_index,i)==hash)present=1;
    }
    if(present==0)g_slist_append(DB_day_index,hash);

    //fprintf(stderr,"Modifications appliquées\n");
}

void remove_interval(GtkButton *button, gpointer user_data)
{
    GtkWidget *win = g_slist_nth_data(user_data,0);
    GtkWidget *vbox_planning = g_slist_nth_data(user_data,1);
    GSList *DB_planning = g_slist_nth_data(user_data,2);
    GSList *DB_planning_index = g_slist_nth_data(user_data,3);
    int index = g_array_index((GArray*)g_slist_nth_data(user_data,4),int,0);
    int index_to_remove=0;

    //fprintf(stderr,"index:%d\n",g_array_index((GArray*)g_slist_nth_data(user_data,4),int,0));

    for(index_to_remove=0;(index!=g_slist_nth_data(DB_planning_index,index_to_remove));index_to_remove++);

    //fprintf(stderr,"index to remove:%d\n",index_to_remove);

    gtk_container_remove (vbox_planning,(GtkWidget*)g_slist_nth_data(DB_planning,index*5+1));
    g_slist_remove(DB_planning_index,g_slist_nth_data(DB_planning_index,index_to_remove));
    g_slist_insert(DB_planning_index,-1,index_to_remove);

    gtk_window_resize(GTK_WINDOW(win),300,100);
    gtk_widget_show_all(win);
}

void add_interval(GtkButton *button, gpointer user_data)
{
    GtkWidget *win = g_slist_nth_data(user_data,0);
    GtkWidget *vbox_planning = g_slist_nth_data(user_data,1);
    GSList *DB_planning = g_slist_nth_data(user_data,2);
    GSList *DB_planning_index = g_slist_nth_data(user_data,3);
    GtkWidget *spin_button1_h = g_slist_nth_data(user_data,4);
    GtkWidget *spin_button1_m = g_slist_nth_data(user_data,5);
    GtkWidget *spin_button1_s = g_slist_nth_data(user_data,6);
    GtkWidget *spin_button2_h = g_slist_nth_data(user_data,7);
    GtkWidget *spin_button2_m = g_slist_nth_data(user_data,8);
    GtkWidget *spin_button2_s = g_slist_nth_data(user_data,9);
    GtkWidget *label = NULL;
    GtkWidget *remove = NULL;
    GtkWidget *hbox = NULL;
    GSList *list = NULL;
    GArray *tab_index = NULL;
    int index=0;

    char *chaine[20];


    int h1,h2,m1,m2,s1,s2;

    tab_index = g_array_new(TRUE,TRUE,sizeof(int));

    h1 = gtk_spin_button_get_value(spin_button1_h);
    m1 = gtk_spin_button_get_value(spin_button1_m);
    s1 = gtk_spin_button_get_value(spin_button1_s);
    h2 = gtk_spin_button_get_value(spin_button2_h);
    m2 = gtk_spin_button_get_value(spin_button2_m);
    s2 = gtk_spin_button_get_value(spin_button2_s);

    if((h1*3600+m1*60+s1)<(h2*3600+m2*60+s2))
    {

        snprintf(chaine,20,"%02d:%02d:%02d - %02d:%02d:%02d",h1,m1,s1,h2,m2,s2);
        //fprintf(stderr,"%s\n",chaine);

        label = gtk_label_new(chaine);
        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);

        gtk_container_add(GTK_CONTAINER(vbox_planning),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);

        g_slist_append(DB_planning,(gpointer)hbox);
        g_slist_append(DB_planning,(gpointer)label);
        g_slist_append(DB_planning,(gpointer)remove);
        g_slist_append(DB_planning,h1*3600+m1*60+s1);
        g_slist_append(DB_planning,h2*3600+m2*60+s2);

        if(g_slist_length(DB_planning_index)!=0)
        {
            index = g_slist_length(DB_planning_index)-1;
            g_slist_append(DB_planning_index,g_slist_length(DB_planning_index)-1);
        }

        g_array_append_val(tab_index,index);

        list = g_slist_append(list,(gpointer)win);
        g_slist_append(list,(gpointer)vbox_planning);
        g_slist_append(list,(gpointer)DB_planning);
        g_slist_append(list,(gpointer)DB_planning_index);
        g_slist_append(list,(gpointer)tab_index);

        //fprintf(stderr,"tab_index:%d\n",g_slist_length(list));


        g_signal_connect (remove, "clicked", remove_interval, (gpointer)list);

        gtk_window_resize(GTK_WINDOW(win),300,100);
        gtk_widget_show_all(win);
    }
}

void save_changes(GtkButton *button, gpointer user_data)
{
   gint32 quark;
    GString *s_label;
    GtkWidget *win = g_slist_nth_data(user_data,0);
    GtkWidget *vbox_planning = g_slist_nth_data(user_data,1);
    GSList *DB_planning = g_slist_nth_data(user_data,2);
    GSList *DB_planning_index = g_slist_nth_data(user_data,3);
    GtkWidget *label = g_slist_nth_data(user_data,10);
    GSList *DB_planned_days = g_slist_nth_data(user_data,11);
    GtkWidget *button_planning = g_slist_nth_data(user_data,12);
    int hour = g_slist_nth_data(user_data,13);
    char *chaine = gtk_label_get_label(label);
    char chaine_hash[6];

    int i=0,length,index=-1,time1,time2;

    //fprintf(stderr,"hash 3\n");

    s_label = g_string_new(gtk_label_get_label(label));
  //  sprintf(chaine_hash," %d",current_year);
  //  g_string_append(s_label,chaine_hash);
    quark = get_timestamp(s_label->str);//g_string_hash(s_label);
    //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

    g_free(g_string_free(s_label,TRUE));

    length = g_slist_length(DB_planning_index);

    g_slist_free(DB_planned_days);
    DB_planned_days=NULL;
    DB_planned_days = g_slist_alloc();

    for(i=0;i<length;i++)
    {
        if(g_slist_nth_data(DB_planning_index,i)!=-1)
        {
            g_slist_append(DB_planned_days,g_slist_nth_data(DB_planning,(i-1)*5+4));
            g_slist_append(DB_planned_days,g_slist_nth_data(DB_planning,(i-1)*5+5));
//            //fprintf(stderr,"h1: %d, h2:%d\n",g_slist_nth_data(DB_planning,(i-1)*5+4),g_slist_nth_data(DB_planning,(i-1)*5+5));
        }
    }

    if(chaine[0]=='L')index=0;
    if(chaine[0]=='M'&&chaine[1]=='a')index=1;
    if(chaine[0]=='M'&&chaine[1]=='e')index=2;
    if(chaine[0]=='J')index=3;
    if(chaine[0]=='V')index=4;
    if(chaine[0]=='S')index=5;
    if(chaine[0]=='D')index=6;

    for(i=1;i<g_slist_length(DB_planned_days);i++)
    {
        if((((int)g_slist_nth_data(DB_planned_days,i))/3600)==hour)gtk_button_set_relief(button_planning,GTK_RELIEF_NORMAL);
    }

    gtk_button_set_relief(GTK_BUTTON(button_0h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_1h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_2h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_3h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_4h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_5h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_6h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_7h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_8h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_9h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_10h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_11h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_12h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_13h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_14h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_15h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_16h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_17h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_18h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_19h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_20h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_21h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_22h[index]),GTK_RELIEF_NONE);
    gtk_button_set_relief(GTK_BUTTON(button_23h[index]),GTK_RELIEF_NONE);

    for(i=1;i<g_slist_length(DB_planned_days);i+=2)
    {
        time1 = g_slist_nth_data(DB_planned_days,i);
        time2 = g_slist_nth_data(DB_planned_days,i+1);

        //fprintf(stderr,"time1 : %d\n",time1);
        //fprintf(stderr,"time2 : %d\n",time2);

        if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
            gtk_button_set_relief(GTK_BUTTON(button_0h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
            gtk_button_set_relief(GTK_BUTTON(button_1h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
            gtk_button_set_relief(GTK_BUTTON(button_2h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
            gtk_button_set_relief(GTK_BUTTON(button_3h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
            gtk_button_set_relief(GTK_BUTTON(button_4h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
            gtk_button_set_relief(GTK_BUTTON(button_5h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
            gtk_button_set_relief(GTK_BUTTON(button_6h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
            gtk_button_set_relief(GTK_BUTTON(button_7h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
            gtk_button_set_relief(GTK_BUTTON(button_8h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
            gtk_button_set_relief(GTK_BUTTON(button_9h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
            gtk_button_set_relief(GTK_BUTTON(button_10h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
            gtk_button_set_relief(GTK_BUTTON(button_11h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
            gtk_button_set_relief(GTK_BUTTON(button_12h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
            gtk_button_set_relief(GTK_BUTTON(button_13h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
            gtk_button_set_relief(GTK_BUTTON(button_14h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
            gtk_button_set_relief(GTK_BUTTON(button_15h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
            gtk_button_set_relief(GTK_BUTTON(button_16h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
            gtk_button_set_relief(GTK_BUTTON(button_17h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
            gtk_button_set_relief(GTK_BUTTON(button_18h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
            gtk_button_set_relief(GTK_BUTTON(button_19h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
            gtk_button_set_relief(GTK_BUTTON(button_20h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
            gtk_button_set_relief(GTK_BUTTON(button_21h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
            gtk_button_set_relief(GTK_BUTTON(button_22h[index]),GTK_RELIEF_NORMAL);
        if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
            gtk_button_set_relief(GTK_BUTTON(button_23h[index]),GTK_RELIEF_NORMAL);

    }

    save_day(quark,DB_planned_days);

    g_slist_free(DB_planning);
    g_slist_free(DB_planning_index);

    gtk_widget_destroy(win);

    //fprintf(stderr,"Modifications appliquées\n");
}

int get_lower_time(GSList *DB_planned_days,int ref)
{
    int i=0,lower=90000,lower_index=0,lower_found=-2;

    for(i=1;i<g_slist_length(DB_planned_days);i+=2)
    {
//        //fprintf(stderr,"1:%d , %d\n",g_slist_nth_data(DB_planned_days,i),lower);
//        //fprintf(stderr,"2:%d , %d\n",g_slist_nth_data(DB_planned_days,i),ref);
        if(ref==-1)
        {
            if((g_slist_nth_data(DB_planned_days,i)<lower))
            {
                lower_found=0;
//                //fprintf(stderr,"lower changed: %d\n",g_slist_nth_data(DB_planned_days,i));
                lower=g_slist_nth_data(DB_planned_days,i);
                lower_index=i;
            }
        }
        else
        {
            if((g_slist_nth_data(DB_planned_days,i)<lower)&&(g_slist_nth_data(DB_planned_days,i)>ref))
            {
                lower_found=0;
//                //fprintf(stderr,"lower changed: %d\n",g_slist_nth_data(DB_planned_days,i));
                lower=g_slist_nth_data(DB_planned_days,i);
                lower_index=i;
            }
        }
    }

    if(lower_found==0)return lower_index;
    else return lower_found;
}

void show_window_intervals(GtkButton *button, gpointer user_data)///A la fin de cette fonction ajouter un destructeur pour free des GArray?? si nécessaire (fuites de mémoire)
{
    GtkWidget *win = NULL;
    GtkWidget *label = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GtkWidget *text = NULL;
    GSList *DB_planning;//Permet de stocker dans l'ordre hbox,label,button ces éléments ne sont pas supprimés
    GSList *DB_planning_index = NULL;//Permet de stocker les lignes présentes dans la vbox afin d'accéder aux éléments dans DB_planning

    GSList *DB_planned_days = NULL;//Liste utilisée pour sauvegarder les intervalles avec la fonction save_day

    GtkWidget *spin_button1_h = NULL;
    GtkWidget *spin_button1_m = NULL;
    GtkWidget *spin_button1_s = NULL;

    GtkWidget *spin_button2_h = NULL;
    GtkWidget *spin_button2_m = NULL;
    GtkWidget *spin_button2_s = NULL;

    GtkWidget *day = (GtkWidget*)user_data;
    GtkWidget *frame = NULL;
    GtkWidget *set = NULL;
    GtkWidget *vbox_planning = NULL;
    GtkWidget *valid = NULL;
    GtkWidget *planning_hbox = NULL;
    GtkWidget *planning_label = NULL;
    GtkWidget *planning_remove = NULL;
    GArray *tab_index = NULL;

    GSList *list = NULL;
    GSList *list_remove = NULL;
    char *chaine[20];
    const gchar *selected_hour = ((char*)gtk_button_get_label(button));
    int hour;

    GString *s_label;
    gint32 quark;
    int quark_in_index=0,i=0;
    int lower=-1;

    int index=0;
    int h1;
    int m1;
    int s1;
    int h2;
    int m2;
    int s2;
    int time1;
    int time2;

    char chaine_hash[6];

    if(selected_hour[1]!='h')
    {
        hour = (selected_hour[1]-48);
        hour += (selected_hour[0]-48)*10;
    }
    else
    {
        hour = (selected_hour[0]-48);
    }

    //fprintf(stderr,"hash 4\n");

    s_label = g_string_new(gtk_label_get_label(day));
 //   sprintf(chaine_hash," %d",current_year);
 //   g_string_append(s_label,chaine_hash);
    quark = get_timestamp(s_label->str);//g_string_hash(s_label);
    //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

    g_free(g_string_free(s_label,TRUE));



    for(i=0;(i<g_slist_length(DB_day_index))&&(quark_in_index==0);i++)
    {
        if(quark==g_slist_nth_data(DB_day_index,i))quark_in_index=1;
    }

    if(quark_in_index)DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);
    else DB_planned_days = g_slist_alloc();

    DB_planning = g_slist_alloc();
    DB_planning_index = g_slist_append(DB_planning_index,-1);

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    gtk_window_set_title (GTK_WINDOW (win), "Editeur");
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
    gtk_window_set_default_size(GTK_WINDOW(win),300,100);

    gtk_widget_realize (win);
    g_signal_connect (win, "destroy", gtk_widget_destroy, NULL);

    vbox = gtk_vbox_new(FALSE,6);
    gtk_container_add (GTK_CONTAINER (win), vbox);

    label = gtk_label_new(gtk_label_get_label(day));
    gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);

    frame = gtk_frame_new("Planning");
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

    vbox_planning = gtk_vbox_new(FALSE,6);
    gtk_container_add(frame,vbox_planning);

    hbox = gtk_hbox_new(FALSE,6);
    gtk_container_add(GTK_CONTAINER(vbox),hbox);

    text = gtk_label_new("De : ");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    spin_button1_h = gtk_spin_button_new_with_range(0,23,1);
    gtk_spin_button_set_value(spin_button1_h,hour);
    gtk_box_pack_start (GTK_BOX (hbox), spin_button1_h, FALSE, FALSE, 0);

    text = gtk_label_new(":");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    spin_button1_m = gtk_spin_button_new_with_range(0,59,1);
    gtk_box_pack_start (GTK_BOX (hbox), spin_button1_m, FALSE, FALSE, 0);

    text = gtk_label_new(":");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    spin_button1_s = gtk_spin_button_new_with_range(0,59,1);
    gtk_box_pack_start (GTK_BOX (hbox), spin_button1_s, FALSE, FALSE, 0);

    text = gtk_label_new(" à ");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    spin_button2_h = gtk_spin_button_new_with_range(0,23,1);
    gtk_spin_button_set_value(spin_button2_h,hour);
    gtk_box_pack_start (GTK_BOX (hbox), spin_button2_h, FALSE, FALSE, 0);

    text = gtk_label_new(":");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    spin_button2_m = gtk_spin_button_new_with_range(0,59,1);
    gtk_box_pack_start (GTK_BOX (hbox), spin_button2_m, FALSE, FALSE, 0);

    text = gtk_label_new(":");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    spin_button2_s = gtk_spin_button_new_with_range(0,59,1);
    gtk_box_pack_start (GTK_BOX (hbox), spin_button2_s, FALSE, FALSE, 0);

    list = g_slist_append(list,(gpointer)win);
    g_slist_append(list,(gpointer)vbox_planning);
    g_slist_append(list,(gpointer)DB_planning);
    g_slist_append(list,(gpointer)DB_planning_index);
    g_slist_append(list,(gpointer)spin_button1_h);
    g_slist_append(list,(gpointer)spin_button1_m);
    g_slist_append(list,(gpointer)spin_button1_s);
    g_slist_append(list,(gpointer)spin_button2_h);
    g_slist_append(list,(gpointer)spin_button2_m);
    g_slist_append(list,(gpointer)spin_button2_s);
    g_slist_append(list,(gpointer)label);
    g_slist_append(list,(gpointer)DB_planned_days);
    g_slist_append(list,(gpointer)button);
    g_slist_append(list,(gpointer)hour);

    set = gtk_button_new_with_label(" + ");
    g_signal_connect (set, "clicked", add_interval, (gpointer)list);
    gtk_box_pack_start (GTK_BOX (hbox), set, FALSE, FALSE, 0);

    valid = gtk_button_new_with_label("Valider");
    g_signal_connect (valid, "clicked", save_changes, (gpointer)list);
    gtk_box_pack_start (GTK_BOX (vbox), valid, FALSE, FALSE, 0);

    for(i=0;i<g_slist_length(DB_planned_days);i++)
    {
        //fprintf(stderr,"DB %d = %d\n",i,g_slist_nth_data(DB_planned_days,i));
    }

    while((lower!=-2)&&(g_slist_length(DB_planned_days)>1))
    {
        if(lower!=-1)lower=get_lower_time(DB_planned_days,g_slist_nth_data(DB_planned_days,lower));
        else lower=get_lower_time(DB_planned_days,-1);
//        if(lower>=0)//fprintf(stderr,"lower:%d,%d\n",lower,g_slist_nth_data(DB_planned_days,lower));
//        else //fprintf(stderr,"lower:%d,#\n",lower);

        if(lower!=-2)
        {
            time1 = ((int)g_slist_nth_data(DB_planned_days,lower));
            time2 = ((int)g_slist_nth_data(DB_planned_days,lower+1));

            h1 = time1/3600;
            m1 = (time1-h1*3600)/60;
            s1 = (time1-h1*3600-m1*60);

            h2 = time2/3600;
            m2 = (time2-h2*3600)/60;
            s2 = (time2-h2*3600-m2*60);


            snprintf(chaine,20,"%02d:%02d:%02d - %02d:%02d:%02d",h1,m1,s1,h2,m2,s2);
            //fprintf(stderr,"%s\n",chaine);

            planning_label = gtk_label_new(chaine);
            planning_remove = gtk_button_new_with_label(" - ");
            planning_hbox = gtk_hbox_new(FALSE,6);

            gtk_container_add(GTK_CONTAINER(vbox_planning),planning_hbox);
            gtk_box_pack_start (GTK_BOX (planning_hbox), planning_label, TRUE, TRUE, 0);
            gtk_box_pack_start (GTK_BOX (planning_hbox), planning_remove, FALSE, FALSE, 0);

            g_slist_append(DB_planning,(gpointer)planning_hbox);
            g_slist_append(DB_planning,(gpointer)planning_label);
            g_slist_append(DB_planning,(gpointer)planning_remove);
            g_slist_append(DB_planning,h1*3600+m1*60+s1);
            g_slist_append(DB_planning,h2*3600+m2*60+s2);

            if(g_slist_length(DB_planning_index)!=0)
            {
                index = g_slist_length(DB_planning_index)-1;
                g_slist_append(DB_planning_index,g_slist_length(DB_planning_index)-1);
            }

//            //fprintf(stderr,"index dans liste %d\n",index);

            tab_index = g_array_new(TRUE,TRUE,sizeof(int));
            g_array_append_val(tab_index,index);

//            //fprintf(stderr,"addr dans liste %d\n",tab_index);

           list_remove = g_slist_append(list_remove,(gpointer)win);
            g_slist_append(list_remove,(gpointer)vbox_planning);
            g_slist_append(list_remove,(gpointer)DB_planning);
            g_slist_append(list_remove,(gpointer)DB_planning_index);
            g_slist_append(list_remove,(gpointer)tab_index);

            g_signal_connect (planning_remove, "clicked", remove_interval, (gpointer)list_remove);
        }
    }

    gtk_widget_show_all (win);
}

void copy_selection(GtkButton *button, gpointer user_data)
{
    int i;
    int selected,quark;
    char *date[NB_JOUR_PLANNING];
    GString *s_label;
    char chaine_hash[6];

    for(i=0;i<NB_JOUR_PLANNING;i++)
    {
        date[i] = g_slist_nth_data(user_data,i);
    }

    if(gtk_toggle_button_get_active(radio[0]))i=0;
    else if(gtk_toggle_button_get_active(radio[1]))i=1;
    else if(gtk_toggle_button_get_active(radio[2]))i=2;
    else if(gtk_toggle_button_get_active(radio[3]))i=3;
    else if(gtk_toggle_button_get_active(radio[4]))i=4;
    else if(gtk_toggle_button_get_active(radio[5]))i=5;
    else if(gtk_toggle_button_get_active(radio[6]))i=6;
    else if(gtk_toggle_button_get_active(radio[7]))i=7;

    selected=i;

    if(selected==7)multiple_selection=1;
    else multiple_selection=0;

    if(multiple_selection)
    {
        for(i=0;i<NB_JOUR_PLANNING;i++)
        {
            //fprintf(stderr,"hash 5\n");

            s_label = g_string_new(gtk_label_get_label(date[i]));
      //      sprintf(chaine_hash," %d",current_year);
      //      g_string_append(s_label,chaine_hash);
            quark = get_timestamp(s_label->str);//g_string_hash(s_label);
            //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

            g_free(g_string_free(s_label,TRUE));


            selection[i]=quark;
        }
    }
    else
    {
            //fprintf(stderr,"hash 6\n");

            s_label = g_string_new(gtk_label_get_label(date[selected]));
        //    sprintf(chaine_hash," %d",current_year);
        //    g_string_append(s_label,chaine_hash);
            quark = get_timestamp(s_label->str);//g_string_hash(s_label);
            //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

            g_free(g_string_free(s_label,TRUE));


            selection[0]=quark;
            selection[1]=selected;
    }
}

void paste_selection(GtkButton *button, gpointer user_data)
{
    int i,j,k,choix;
    int time1,time2;
    int quark,paste_quark,quark_in_index=0;
    char *date[NB_JOUR_PLANNING];
    GSList *copy_list=NULL;
    GSList *list_to_copy=NULL;
    GSList *DB_planned_days=NULL;
    GString *s_label;
    GtkWidget *win = g_slist_nth_data(user_data,NB_JOUR_PLANNING+2);
    char chaine_hash[6];

    //fprintf(stderr,"begin paste......................\n");

    for(i=0;i<NB_JOUR_PLANNING;i++)
    {
        date[i] = g_slist_nth_data(user_data,i);
    }

    choix = 7;

    if(!multiple_selection)
    {
        if(gtk_toggle_button_get_active(radio[0]))i=0;
        else if(gtk_toggle_button_get_active(radio[1]))i=1;
        else if(gtk_toggle_button_get_active(radio[2]))i=2;
        else if(gtk_toggle_button_get_active(radio[3]))i=3;
        else if(gtk_toggle_button_get_active(radio[4]))i=4;
        else if(gtk_toggle_button_get_active(radio[5]))i=5;
        else if(gtk_toggle_button_get_active(radio[6]))i=6;
        choix = i;
    }

    if(multiple_selection)
    {
        if(choix==7)
        {
            for(i=0;i<NB_JOUR_PLANNING;i++)
            {
                quark_in_index=0;

                //fprintf(stderr,"hash 6\n");

                s_label = g_string_new(gtk_label_get_label(date[i]));
    //            sprintf(chaine_hash," %d",current_year);
     //           g_string_append(s_label,chaine_hash);
                quark = get_timestamp(s_label->str);//g_string_hash(s_label);
                //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

                g_free(g_string_free(s_label,TRUE));


                for(j=0;(j<g_slist_length(DB_day_index))&&(quark_in_index==0);j++)
                {
                    if(quark==g_slist_nth_data(DB_day_index,j))quark_in_index=1;
                }

                if(quark_in_index)
                {
                    //fprintf(stderr,"selection : %d , quark : %d\n",selection[i],quark);
                    if(selection[i]!=quark)copy_list = (GSList*)g_datalist_id_get_data(&DB_day,quark);
                    g_slist_free(copy_list);

                    list_to_copy = (GSList*)g_datalist_id_get_data(&DB_day,selection[i]);
                    copy_list = g_slist_copy((GSList*)g_datalist_id_get_data(&DB_day,selection[i]));
                    //fprintf(stderr,"multiple in index......................\n");
                }
                else
                {
                    g_slist_append(DB_day_index,quark);
                   // printf("quark %d added\n");
                    copy_list = g_slist_copy((GSList*)g_datalist_id_get_data(&DB_day,selection[i]));
                    //fprintf(stderr,"multiple not in index......................\n");
                }

                if(selection[i]!=quark)g_datalist_id_set_data(&DB_day,quark,copy_list);
            }

            for(j=0;j<NB_JOUR_PLANNING;j++)
            {
                gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NONE);
                gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NONE);

                //fprintf(stderr,"hash 7\n");

                s_label = g_string_new(gtk_label_get_label(date[j]));
    //            sprintf(chaine_hash," %d",current_year);
     //           g_string_append(s_label,chaine_hash);
                quark = get_timestamp(s_label->str);//g_string_hash(s_label);
                //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

                g_free(g_string_free(s_label,TRUE));



                DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);

                for(k=1;k<g_slist_length(DB_planned_days);k+=2)
                {
                    time1 = (int)g_slist_nth_data(DB_planned_days,k);
                    time2 = (int)g_slist_nth_data(DB_planned_days,k+1);

                    //fprintf(stderr,"time1:%d,time2:%d\n",time1,time2);

                    if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                        gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                        gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                        gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                        gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                        gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                        gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                        gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                        gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                        gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                        gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                        gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                        gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                        gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                        gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                        gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                        gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                        gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                        gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                        gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                        gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                        gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                        gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                        gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NORMAL);
                    if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                        gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NORMAL);

                }

            }
        }
    }
    else
    {
        if(choix != 7)
        {
            quark_in_index=0;

            //fprintf(stderr,"hash 8\n");

            s_label = g_string_new(gtk_label_get_label(date[choix]));
    //        sprintf(chaine_hash," %d",current_year);
     //       g_string_append(s_label,chaine_hash);
            quark = get_timestamp(s_label->str);//g_string_hash(s_label);
            //fprintf(stderr,"quark %d, str : %s\n",quark,s_label->str);

            g_free(g_string_free(s_label,TRUE));

            for(j=0;(j<g_slist_length(DB_day_index))&&(quark_in_index==0);j++)
            {
                if(quark==g_slist_nth_data(DB_day_index,j))quark_in_index=1;
            }

            if(quark_in_index)
            {
                if(quark!=selection[0])
                {
                    copy_list = (GSList*)g_datalist_id_get_data(&DB_day,quark);
                    g_slist_free(copy_list);

                    list_to_copy = (GSList*)g_datalist_id_get_data(&DB_day,selection[0]);

                    copy_list = g_slist_copy((GSList*)list_to_copy);

                    //fprintf(stderr,"unique in index......................\n");
                }
            }
            else
            {
                g_slist_append(DB_day_index,quark);
               // printf("quark %d added\n");
                copy_list = g_slist_copy((GSList*)g_datalist_id_get_data(&DB_day,selection[0]));
                //fprintf(stderr,"unique not in index......................\n");
            }


            if(quark!=selection[0])g_datalist_id_set_data(&DB_day,quark,copy_list);

            gtk_button_set_relief(GTK_BUTTON(button_0h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_1h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_2h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_3h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_4h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_5h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_6h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_7h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_8h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_9h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_10h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_11h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_12h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_13h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_14h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_15h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_16h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_17h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_18h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_19h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_20h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_21h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_22h[choix]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_23h[choix]),GTK_RELIEF_NONE);

            DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);

            for(i=1;i<g_slist_length(DB_planned_days);i+=2)
            {
                time1 = (int)g_slist_nth_data(DB_planned_days,i);
                time2 = (int)g_slist_nth_data(DB_planned_days,i+1);

                //fprintf(stderr,"time1:%d,time2:%d\n",time1,time2);

                if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                    gtk_button_set_relief(GTK_BUTTON(button_0h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                    gtk_button_set_relief(GTK_BUTTON(button_1h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                    gtk_button_set_relief(GTK_BUTTON(button_2h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                    gtk_button_set_relief(GTK_BUTTON(button_3h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                    gtk_button_set_relief(GTK_BUTTON(button_4h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                    gtk_button_set_relief(GTK_BUTTON(button_5h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                    gtk_button_set_relief(GTK_BUTTON(button_6h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                    gtk_button_set_relief(GTK_BUTTON(button_7h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                    gtk_button_set_relief(GTK_BUTTON(button_8h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                    gtk_button_set_relief(GTK_BUTTON(button_9h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                    gtk_button_set_relief(GTK_BUTTON(button_10h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                    gtk_button_set_relief(GTK_BUTTON(button_11h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                    gtk_button_set_relief(GTK_BUTTON(button_12h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                    gtk_button_set_relief(GTK_BUTTON(button_13h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                    gtk_button_set_relief(GTK_BUTTON(button_14h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                    gtk_button_set_relief(GTK_BUTTON(button_15h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                    gtk_button_set_relief(GTK_BUTTON(button_16h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                    gtk_button_set_relief(GTK_BUTTON(button_17h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                    gtk_button_set_relief(GTK_BUTTON(button_18h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                    gtk_button_set_relief(GTK_BUTTON(button_19h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                    gtk_button_set_relief(GTK_BUTTON(button_20h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                    gtk_button_set_relief(GTK_BUTTON(button_21h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                    gtk_button_set_relief(GTK_BUTTON(button_22h[choix]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                    gtk_button_set_relief(GTK_BUTTON(button_23h[choix]),GTK_RELIEF_NORMAL);

            }
        }
    }
    //fprintf(stderr,"end paste......................\n");

    gtk_widget_show_all(win);
}

void save_to_file_and_close(GtkButton *button,gpointer user_data)
{
    int i,j,quark;
    FILE *f=NULL;
    GSList *DB_planned_days=NULL;
    GSList *list_to_save=NULL;
    GtkWidget *entry = NULL;
    GtkWidget *entry_p1 = g_slist_nth_data(user_data,0);
    GtkWidget *entry_p2 = g_slist_nth_data(user_data,1);
    GtkWidget *entry_p3 = g_slist_nth_data(user_data,2);
    char *s_quark[20];
    char **s_times = NULL;
    char *spawn[]={script_file->str,file_to_save->str,gtk_entry_get_text(entry_p1),gtk_entry_get_text(entry_p2),gtk_entry_get_text(entry_p3),visual_string->str,NULL};
    pid_t child_pid;
    char *dir,*liststore_line;
    int liststore_line_index=0;

    if(file_to_save!=NULL)
    {
        //fprintf(stderr,"SAVING PARAMS IN FILE %s\n",file_to_save->str);

        f = fopen(file_to_save->str,"w+");
        fclose(f);

        //fprintf(stderr,"Fichier ouvert en écriture\n");

        //fprintf(stderr,"Nb param : %d\n",g_slist_length(user_data));

        for(i=0;i<3;i++)
        {
            entry = g_slist_nth_data(user_data,i);
            list_to_save = NULL;
            list_to_save = g_slist_append(list_to_save,gtk_entry_get_text(entry));

            //fprintf(stderr,"Entry : %s\n",gtk_entry_get_text(entry));

            //fprintf(stderr,"Set %d param\n",g_slist_length(list_to_save));
            set_param(file_to_save->str,"entry",g_slist_length(list_to_save),list_to_save);
            //fprintf(stderr,"End set param\n");

            g_slist_free(list_to_save);
        }

        for(i=1;i<g_slist_length(DB_day_index);i++)
        {
            list_to_save = NULL;
           // printf("1\n");
            //fprintf(stderr,"saving param : %d\n",g_slist_nth_data(DB_day_index,i));
           // printf("2\n");

            quark=g_slist_nth_data(DB_day_index,i);
           // printf("3\n");

            sprintf(s_quark,"%08d",quark);
           // printf("4\n");

            DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);
           // printf("5\n");

            if(DB_planned_days != NULL)
            {
           // printf("6\n");
                if(g_slist_length(DB_planned_days)>=1)
                {
                    s_times = malloc(sizeof(char*)*(g_slist_length(DB_planned_days)-1));

               // printf("7\n");
                    for(j=0;j<(g_slist_length(DB_planned_days)-1);j++)
                    {
               // printf("8\n");
                        s_times[j]=malloc(6*sizeof(char));
               // printf("9\n");
                        sprintf(s_times[j],"%d",g_slist_nth_data(DB_planned_days,j+1));
                    }

               // printf("10\n");
                    for(j=1;j<g_slist_length(DB_planned_days);j++)
                    {
               // printf("11\n");
                        if(j==1)list_to_save = g_slist_append(list_to_save,s_times[j-1]);
                        else g_slist_append(list_to_save,s_times[j-1]);

               // printf("12\n");
                        //fprintf(stderr,"saving element : %s\n",s_times[j-1]);
                    }

                    set_param(file_to_save->str,s_quark,g_slist_length(list_to_save),list_to_save);

                    for(j=0;j<(g_slist_length(DB_planned_days)-1);j++)free(s_times[j]);
                    free(s_times);

                    g_slist_free(list_to_save);
                }
            }
        }
    }

    if(access(script_file->str,X_OK)==0 && is_modifying==0)
    {
        child_pid = fork ();

        if (child_pid == 0)
        {
            execvp (script_file->str,spawn);

            fprintf (stderr, "an error occurred in execvp\n");
            abort ();
        }
        else
        {
            pwd = getenv ("HOME");

            if(pwd!=NULL)
            {
                dir = malloc(strlen(pwd)+sizeof("/.schedio/liststore.tmp"));
                if(dir!=NULL)
                {
                    strcpy(dir,pwd);
                    strcat(dir,"/.schedio/liststore.tmp");

                    liststore_line = malloc(sizeof("0,")+strlen(visual_string->str)+2);
                    strcpy(liststore_line,"0,");
                    strcat(liststore_line,visual_string->str);
                    strcat(liststore_line,"\n");

                    liststore_line_index = get_tree_view_row(dir,liststore_line);

                    if(liststore_line_index!=-1)modify_line(dir,liststore_line_index,child_pid);
                    else perror("Erreur de suivi de plugin");
                }
                else
                {
                    perror("Allocation failure, memory leak?");
                }

                free(liststore_line);
                free(dir);
            }
            else
            {
                perror("Error plugin lost, can't find $HOME");
            }
        }
    }

    gtk_main_quit();
}

int str_to_int(char *str)
{
    int i=0;
    int cpt=0;
    int len=strlen(str)-1;

    for(cpt=0;cpt<=len;cpt++)
    {
        if(str[cpt]==0)break;
        i+=(str[cpt]-48)*pow(10,len-cpt);
    }

    return i;
}

int load_from_save_file(char *file,GtkWidget* param1,GtkWidget* param2,GtkWidget* param3,GSList **db_planned_days)
{
    char buffer[500];
    FILE *f=NULL;
    int len=0,err=0;
    int i,quark,time,quark2;
    int nb_param=0;

    len = get_nb_line(file);

    if(len!=-1)
    {
        //Ouverture du fichier de sauvegarde
        f=fopen(file,"r");
        if(f!=NULL)
        {
            //Chargement du premier paramètre:
            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            for(i=0;i<strlen(buffer);i++)if(buffer[i]=='\n')buffer[i]=0;
            gtk_entry_set_text(param1,buffer);
            //Chargement du second paramètre:
            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            for(i=0;i<strlen(buffer);i++)if(buffer[i]=='\n')buffer[i]=0;
            gtk_entry_set_text(param2,buffer);
            //Chargement du troisième paramètre:
            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            for(i=0;i<strlen(buffer);i++)if(buffer[i]=='\n')buffer[i]=0;
            gtk_entry_set_text(param3,buffer);

            len-=6;

            if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
            len-=1;

            if(buffer[0]=='[')
            {
                for(i=0;i<strlen(buffer);i++)
                {
                    buffer[i]=buffer[i+1];
                    if(buffer[i]==']')buffer[i]=0;
                }
                quark = str_to_int(buffer);
                quark2=quark;
            }

            while(len>0)
            {
                quark=quark2;

                while(len>0 && quark==quark2)
                {
                    if(fgets(buffer,500,f)==NULL)perror("Erreur lors de la lecture du fichier de sauvegarde");
                    len-=1;
                    if(buffer[0]!='[')
                    {
                        for(i=0;i<strlen(buffer);i++)if(buffer[i]=='\n')buffer[i]=0;
                        time = str_to_int(buffer);
                        g_slist_append(db_planned_days[nb_param],time);
                    }
                    else
                    {
                        for(i=0;i<strlen(buffer);i++)
                        {
                            buffer[i]=buffer[i+1];
                            if(buffer[i]==']')buffer[i]=0;
                        }
                        quark2 = str_to_int(buffer);
                    }
                }

                g_datalist_id_set_data(&DB_day,quark,(gpointer)db_planned_days[nb_param]);
                g_slist_append(DB_day_index,quark);
                nb_param++;
            }

            fclose(f);
        }
        else
        {
            perror("Fichier de sauvegarde inexistant ou corrompu");
            err=-1;
        }
    }
    else
    {
        perror("Erreur lors de la lecture du fichier de sauvegarde");
        err=-1;
    }

    return err;
}

GdkPixbuf *create_pixbuf(const gchar * filename)
{
   GdkPixbuf *pixbuf;
   GError *error = NULL;
   pixbuf = gdk_pixbuf_new_from_file(filename, &error);
   if(!pixbuf) {
      fprintf(stderr, "%s\n", error->message);
      g_error_free(error);
   }

   return pixbuf;
}

int main (int argc, char *argv[])
{
    struct timeval tv;
    struct tm* ptm;
    GtkWidget *button = NULL;
    GtkWidget *label = NULL;
    GtkWidget *win = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GtkWidget *hbox1 = NULL;
    GtkWidget *month = NULL;
    GtkWidget *year = NULL;
    GtkWidget *frame = NULL;
    GtkWidget *table = NULL;

    //Gestion du calendrier

    int ref_day = 1;
    int ref_month = 1;
    int ref_year = 2000;
    int ref_bissex = 2000;
    int ref_num_day = 6;
    s_day* day;
    int num_day_in_year;
    int num_day_in_week;
    char* week_string;
    int size=0;
    int nb_param=0;
    GtkWidget *next_week = NULL;
    GtkWidget *last_week = NULL;
    GSList *list=NULL;
    GSList *list_entry_param = NULL;

    //Objets de la table
    GtkWidget *date[NB_JOUR_PLANNING];
    GtkWidget *semaine;
    GtkWidget *valid;
    GtkWidget *param_label;
    GtkWidget *param1;
    GtkWidget *param2;
    GtkWidget *param3;
    GtkWidget *hbox_param1;
    GtkWidget *hbox_param2;
    GtkWidget *hbox_param3;
    GtkWidget *separator;

    GtkWidget *copy;
    GtkWidget *paste;

    char **param=NULL;
    char *name=NULL;
    GSList *DB_planned_days = NULL;
    int time,quark,time1,time2;
    GString *s_label = NULL;
    FILE *file = NULL;
    char *line[1000];
    char chaine[200];
    int day_temp=0;
    GString *string = NULL;
    GString *s_param = NULL;
    char chaine_hash[6];
    GSList **list_days_from_save=NULL;

    int i,j,k;
    char year1[5];

    const char *tab_day[] = {"Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi","Dimanche"};
    const char *tab_month[] = {"Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"};

    changing_week = 0;

   // printf("args :\n");
//    if(argc>=2)printf("arg1 : %s\n",argv[1]);
//    if(argc>=3)printf("arg2 : %s\n",argv[2]);
//    if(argc>=4)printf("arg3 : %s\n",argv[3]);
    if(argc>=5)
    {
        if(argv[4][0]=='1') is_modifying=1;
        else is_modifying=0;
    }
//    if(argc>=6)printf("arg5 : %s\n",argv[5]);
//    if(argc>=7)printf("arg6 : %s\n",argv[6]);
//    if(argc>=8)printf("arg7 : %s\n",argv[7]);
//    if(argc>=9)printf("arg8 : %s\n",argv[8]);


    if(argc>=6)visual_string = g_string_new(argv[5]);
    if(argc>=7)script_file = g_string_new(argv[6]);

    /* Initialize Database */

    g_datalist_init(&DB_day);
    DB_day_index = g_slist_alloc();


    /* Initialize GTK+ */
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
    gtk_init (&argc, &argv);
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

    /* Create the main window */
    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    gtk_window_set_title (GTK_WINDOW (win), "Scheduler");
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
    gtk_window_set_icon(GTK_WINDOW(win), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
//    gtk_window_set_default_size(GTK_WINDOW(win),800,1000);

    gtk_widget_realize (win);
    g_signal_connect (win, "destroy", gtk_main_quit, NULL);

    /* Create a vertical box with buttons */
    vbox = gtk_vbox_new (FALSE, 20);
    gtk_container_add (GTK_CONTAINER (win), vbox);

    hbox = gtk_hbox_new (TRUE, 6);
    gtk_container_add (GTK_CONTAINER (vbox), hbox);

    label = gtk_label_new("Mois à programmer : ");
    gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);

    month = gtk_combo_box_new_text();
    for(i=0;i<12;i++)
    {
        gtk_combo_box_append_text(GTK_COMBO_BOX(month),(const char*)tab_month[i]);
    }
    gtk_combo_box_set_active(GTK_COMBO_BOX(month),0);
    gtk_box_pack_start (GTK_BOX (hbox), month, TRUE, TRUE, 1);

    gettimeofday (&tv, NULL);
    ptm = localtime (&tv.tv_sec);
    num_day_in_year=ptm->tm_yday + 1;
    num_day_in_week=ptm->tm_wday;

    current_year = ptm->tm_year+1900;

    year = gtk_spin_button_new_with_range(ref_year,9999,1);

    gtk_box_pack_start (GTK_BOX (hbox), year, TRUE, TRUE, 2);

    // Création de la table

    frame = gtk_aspect_frame_new("Planning",0.5,0.5,1,TRUE);

    table = gtk_table_new(10,26,FALSE);

    current_day = num_day_in_year-(num_day_in_week-1);

   // printf("début de la configuration du calendrier\n");

    for(i=0;i<NB_JOUR_PLANNING;i++)
    {
       // printf("get_day()\n");
        day_temp = (num_day_in_year+i-(num_day_in_week-1));
        day = get_day(day_temp,current_year,ref_day,ref_month,ref_year,ref_bissex,ref_num_day);
       // printf("fin get_day()\n");

        if(day->day_in_month<10)
        {
            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);
        }
        else
        {
            size = strlen(tab_day[day->day_in_week-1])+strlen(tab_month[day->month-1])+20;
            week_string = malloc(size);
        }

        snprintf(week_string,size,"%s %d %s %d ",tab_day[day->day_in_week-1],day->day_in_month,tab_month[day->month-1],day->year);

        //fprintf(stderr,"%s\n",week_string);

        if(i==0) radio[i] = gtk_radio_button_new(NULL);
        else radio[i] = gtk_radio_button_new_from_widget (radio[0]);
        gtk_table_attach(table,radio[i],0,2,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        date[i] = gtk_label_new(week_string);
//        gtk_label_set_width_chars(GTK_LABEL(date[i]),25);
//        gtk_label_set_justify(GTK_LABEL(date[i]),GTK_JUSTIFY_FILL);
//        gtk_table_attach(table,date[i],0,2,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);
        gtk_container_add (GTK_CONTAINER (radio[i]), date[i]);

        free(week_string);

        button_0h[i] = gtk_button_new_with_label("0h");
        g_signal_connect (button_0h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_0h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_0h[i],2,3,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_1h[i] = gtk_button_new_with_label("1h");
        g_signal_connect (button_1h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_1h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_1h[i],3,4,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_2h[i] = gtk_button_new_with_label("2h");
        g_signal_connect (button_2h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_2h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_2h[i],4,5,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_3h[i] = gtk_button_new_with_label("3h");
        g_signal_connect (button_3h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_3h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_3h[i],5,6,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_4h[i] = gtk_button_new_with_label("4h");
        g_signal_connect (button_4h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_4h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_4h[i],6,7,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_5h[i] = gtk_button_new_with_label("5h");
        g_signal_connect (button_5h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_5h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_5h[i],7,8,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_6h[i] = gtk_button_new_with_label("6h");
        g_signal_connect (button_6h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_6h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_6h[i],8,9,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_7h[i] = gtk_button_new_with_label("7h");
        g_signal_connect (button_7h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_7h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_7h[i],9,10,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_8h[i] = gtk_button_new_with_label("8h");
        g_signal_connect (button_8h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_8h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_8h[i],10,11,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_9h[i] = gtk_button_new_with_label("9h");
        g_signal_connect (button_9h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_9h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_9h[i],11,12,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_10h[i] = gtk_button_new_with_label("10h");
        g_signal_connect (button_10h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_10h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_10h[i],12,13,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_11h[i] = gtk_button_new_with_label("11h");
        g_signal_connect (button_11h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_11h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_11h[i],13,14,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_12h[i] = gtk_button_new_with_label("12h");
        g_signal_connect (button_12h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_12h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_12h[i],14,15,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_13h[i] = gtk_button_new_with_label("13h");
        g_signal_connect (button_13h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_13h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_13h[i],15,16,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_14h[i] = gtk_button_new_with_label("14h");
        g_signal_connect (button_14h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_14h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_14h[i],16,17,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_15h[i] = gtk_button_new_with_label("15h");
        g_signal_connect (button_15h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_15h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_15h[i],17,18,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_16h[i] = gtk_button_new_with_label("16h");
        g_signal_connect (button_16h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_16h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_16h[i],18,19,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_17h[i] = gtk_button_new_with_label("17h");
        g_signal_connect (button_17h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_17h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_17h[i],19,20,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_18h[i] = gtk_button_new_with_label("18h");
        g_signal_connect (button_18h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_18h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_18h[i],20,21,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_19h[i] = gtk_button_new_with_label("19h");
        g_signal_connect (button_19h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_19h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_19h[i],21,22,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_20h[i] = gtk_button_new_with_label("20h");
        g_signal_connect (button_20h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_20h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_20h[i],22,23,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_21h[i] = gtk_button_new_with_label("21h");
        g_signal_connect (button_21h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_21h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_21h[i],23,24,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_22h[i] = gtk_button_new_with_label("22h");
        g_signal_connect (button_22h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_22h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_22h[i],24,25,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

        button_23h[i] = gtk_button_new_with_label("23h");
        g_signal_connect (button_23h[i], "clicked", show_window_intervals, (gpointer)date[i]);
        gtk_button_set_relief(button_23h[i],GTK_RELIEF_NONE);
        gtk_table_attach(table,button_23h[i],25,26,i,i+1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

    }

   // printf("fin de la configuration du calendrier\n");

    list = g_slist_append(list,(gpointer)date[0]);

    for(i=1;i<NB_JOUR_PLANNING;i++)
    {
        g_slist_append(list,(gpointer)date[i]);
    }
    g_slist_append(list,(gpointer)month);
    g_slist_append(list,(gpointer)year);
    g_slist_append(list,(gpointer)win);

    radio[i] = gtk_radio_button_new_from_widget (radio[0]);
    semaine = gtk_label_new("Sélectionner la semaine");
    gtk_container_add (GTK_CONTAINER (radio[i]),semaine);
    gtk_table_attach(table,radio[i],0,2,i,i+2,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,8);

    separator =gtk_hseparator_new();
    gtk_table_attach(table,separator,0,26,i+2,i+3,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

    copy = gtk_button_new_with_label("Copier la sélection");
    g_signal_connect (copy, "clicked", copy_selection,(gpointer)list);
    gtk_table_attach(table,copy,6,12,i+3,i+4,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

    paste = gtk_button_new_with_label("Coller la sélection");
    g_signal_connect (paste, "clicked", paste_selection,(gpointer)list);
    gtk_table_attach(table,paste,14,19,i+3,i+4,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0.5,0.5);

    gtk_container_add(frame,table);

    gtk_box_pack_start(GTK_BOX (vbox), frame, FALSE, FALSE, 1);

    gtk_combo_box_set_active(GTK_COMBO_BOX(month),day->month-1);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(year),day->year);

    // Fin de la déclaration des colonnes

    hbox1 = gtk_hbox_new (TRUE, 700);
    gtk_container_add (GTK_CONTAINER (vbox), hbox1);

    g_signal_connect (month, "changed",month_changed,(gpointer)list);
    g_signal_connect (year, "value-changed", year_changed,(gpointer)list);

    last_week = gtk_button_new_with_label ("Semaine précédente");
    g_signal_connect (last_week, "clicked", last_w, (gpointer)list);
    gtk_box_pack_start (GTK_BOX (hbox1), last_week, FALSE, FALSE, 1);

    next_week = gtk_button_new_with_label ("Semaine suivante");
    g_signal_connect (next_week, "clicked", next_w,(gpointer)list);
    gtk_box_pack_start (GTK_BOX (hbox1), next_week, FALSE, FALSE, 1);

    hbox_param1 = gtk_hbox_new (TRUE, 6);
    gtk_container_add (GTK_CONTAINER (vbox), hbox_param1);

    //fprintf(stderr,"WINDOW GENERATED\nGOING TO PLUGIN.CONF...\n");

    if(argc >=2 && (fopen(argv[1],"r")!=NULL))
    {
        file = fopen(argv[1],"r");
        //fprintf(stderr,"PLUGIN.CONF : \"%s\" OPENED...\n",file);

        fgets(line,1000,file);
        //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");

        fclose(file);

        //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");
        string = keep_name(line);

        //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");

        if(!strcmp(string->str,"window"))
        {
            //fprintf(stderr,"debut PARAM1 IN PLUGIN.CONF...\n");
            //fprintf(stderr,"Reading params...\n");

            //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");
            string = keep_param(line);

            //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");
            //fprintf(stderr,"params : %s\n",string->str);

            //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");
            s_param = param_extract(string->str,1);
        }

        //fprintf(stderr,"fin PARAM1 IN PLUGIN.CONF...\n");
        param_label = gtk_label_new(s_param->str);
        //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");
        gtk_box_pack_start (GTK_BOX (hbox_param1), param_label, TRUE, TRUE, 0);
    }
    else
    {
        param_label = gtk_label_new("non utilisé :");
        gtk_box_pack_start (GTK_BOX (hbox_param1), param_label, TRUE, TRUE, 0);
    }

    param1 = gtk_entry_new();
    gtk_box_pack_start (GTK_BOX (hbox_param1), param1, TRUE, TRUE, 0);

    hbox_param2 = gtk_hbox_new (TRUE, 6);
    gtk_container_add (GTK_CONTAINER (vbox), hbox_param2);

    //fprintf(stderr,"PARAM1 IN PLUGIN.CONF...\n");

    if(argc >=2 && (fopen(argv[1],"r")!=NULL))
    {
        s_param = param_extract(string->str,2);

        param_label = gtk_label_new(s_param->str);
        gtk_box_pack_start (GTK_BOX (hbox_param2), param_label, TRUE, TRUE, 0);
    }
    else
    {
        param_label = gtk_label_new("non utilisé :");
        gtk_box_pack_start (GTK_BOX (hbox_param2), param_label, TRUE, TRUE, 0);
    }
    param2 = gtk_entry_new();
    gtk_box_pack_start (GTK_BOX (hbox_param2), param2, TRUE, TRUE, 0);

    hbox_param3 = gtk_hbox_new (TRUE, 6);
    gtk_container_add (GTK_CONTAINER (vbox), hbox_param3);

    //fprintf(stderr,"PARAM2 IN PLUGIN.CONF...\n");

    if(argc >=2 && (fopen(argv[1],"r")!=NULL))
    {
        s_param = param_extract(string->str,3);

        param_label = gtk_label_new(s_param->str);
        gtk_box_pack_start (GTK_BOX (hbox_param3), param_label, TRUE, TRUE, 0);
    }
    else
    {
        param_label = gtk_label_new("non utilisé :");
        gtk_box_pack_start (GTK_BOX (hbox_param3), param_label, TRUE, TRUE, 0);
    }

    //fprintf(stderr,"PARAM3 IN PLUGIN.CONF...\n");

    param3 = gtk_entry_new();
    gtk_box_pack_start (GTK_BOX (hbox_param3), param3, TRUE, TRUE, 0);

    list_entry_param = g_slist_append(list_entry_param,param1);
    g_slist_append(list_entry_param,param2);
    g_slist_append(list_entry_param,param3);

    valid = gtk_button_new_with_label ("Valider le planning");
    g_signal_connect (valid, "clicked", save_to_file_and_close, list_entry_param);
    gtk_box_pack_start (GTK_BOX (vbox), valid, FALSE, FALSE, 1);

    button = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
    g_signal_connect (button, "clicked", gtk_main_quit, NULL);
    gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 1);

    //fprintf(stderr,"PLUGIN.CONF LOADED...\n");

    //chargement du fichier de sauvegarde si existant

    if(argv[2]!=NULL)file_to_save = g_string_new(argv[2]);

    if((argc >= 2) && (fopen(argv[2],"r")!=NULL) && !strcmp(argv[3],"old"))
    {
        //fprintf(stderr,"LOADING SAVE FILE : %s\n",argv[2]);

        nb_param = get_nb_param(argv[2]);
        list_days_from_save = malloc(nb_param*sizeof(GSList*));
        for(j=0;j<nb_param;j++)list_days_from_save[j]=g_slist_alloc();

        if(load_from_save_file(argv[2],param1,param2,param3,list_days_from_save)==-1)perror("Echec du chargement du fichier de sauvegarde");

        for(j=0;j<NB_JOUR_PLANNING;j++)
        {
            gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NONE);
            gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NONE);

            //fprintf(stderr,"hash 9\n");

            s_label = g_string_new(gtk_label_get_label(date[j]));
//            sprintf(chaine_hash," %d",current_year);
//            g_string_append(s_label,chaine_hash);
            quark = get_timestamp(s_label->str);//g_string_hash(s_label);
            //fprintf(stderr,"quark %d, str : %s...\n",quark,s_label->str);

            //fprintf(stderr,"%d\n",quark);
            g_free(g_string_free(s_label,TRUE));

            DB_planned_days=(GSList*)g_datalist_id_get_data(&DB_day,quark);
           // printf("\nDB add : %d\n",DB_planned_days);

            //fprintf(stderr,"length : %d\n",g_slist_length(DB_planned_days));

            for(k=1;k<g_slist_length(DB_planned_days);k+=2)
            {
                time1 = (int)g_slist_nth_data(DB_planned_days,k);
                time2 = (int)g_slist_nth_data(DB_planned_days,k+1);

                //fprintf(stderr,"time1:%d,time2:%d\n",time1,time2);

                if(((time1/3600)==0)||((time2/3600)==0)||(((time1/3600)<0)&&(time2/3600)>0))
                    gtk_button_set_relief(GTK_BUTTON(button_0h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==1)||((time2/3600)==1)||(((time1/3600)<1)&&(time2/3600)>1))
                    gtk_button_set_relief(GTK_BUTTON(button_1h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==2)||((time2/3600)==2)||(((time1/3600)<2)&&(time2/3600)>2))
                    gtk_button_set_relief(GTK_BUTTON(button_2h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==3)||((time2/3600)==3)||(((time1/3600)<3)&&(time2/3600)>3))
                    gtk_button_set_relief(GTK_BUTTON(button_3h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==4)||((time2/3600)==4)||(((time1/3600)<4)&&(time2/3600)>4))
                    gtk_button_set_relief(GTK_BUTTON(button_4h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==5)||((time2/3600)==5)||(((time1/3600)<5)&&(time2/3600)>5))
                    gtk_button_set_relief(GTK_BUTTON(button_5h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==6)||((time2/3600)==6)||(((time1/3600)<6)&&(time2/3600)>6))
                    gtk_button_set_relief(GTK_BUTTON(button_6h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==7)||((time2/3600)==7)||(((time1/3600)<7)&&(time2/3600)>7))
                    gtk_button_set_relief(GTK_BUTTON(button_7h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==8)||((time2/3600)==8)||(((time1/3600)<8)&&(time2/3600)>8))
                    gtk_button_set_relief(GTK_BUTTON(button_8h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==9)||((time2/3600)==9)||(((time1/3600)<9)&&(time2/3600)>9))
                    gtk_button_set_relief(GTK_BUTTON(button_9h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==10)||((time2/3600)==10)||(((time1/3600)<10)&&(time2/3600)>10))
                    gtk_button_set_relief(GTK_BUTTON(button_10h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==11)||((time2/3600)==11)||(((time1/3600)<11)&&(time2/3600)>11))
                    gtk_button_set_relief(GTK_BUTTON(button_11h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==12)||((time2/3600)==12)||(((time1/3600)<12)&&(time2/3600)>12))
                    gtk_button_set_relief(GTK_BUTTON(button_12h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==13)||((time2/3600)==13)||(((time1/3600)<13)&&(time2/3600)>13))
                    gtk_button_set_relief(GTK_BUTTON(button_13h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==14)||((time2/3600)==14)||(((time1/3600)<14)&&(time2/3600)>14))
                    gtk_button_set_relief(GTK_BUTTON(button_14h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==15)||((time2/3600)==15)||(((time1/3600)<15)&&(time2/3600)>15))
                    gtk_button_set_relief(GTK_BUTTON(button_15h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==16)||((time2/3600)==16)||(((time1/3600)<16)&&(time2/3600)>16))
                    gtk_button_set_relief(GTK_BUTTON(button_16h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==17)||((time2/3600)==17)||(((time1/3600)<17)&&(time2/3600)>17))
                    gtk_button_set_relief(GTK_BUTTON(button_17h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==18)||((time2/3600)==18)||(((time1/3600)<18)&&(time2/3600)>18))
                    gtk_button_set_relief(GTK_BUTTON(button_18h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==19)||((time2/3600)==19)||(((time1/3600)<19)&&(time2/3600)>19))
                    gtk_button_set_relief(GTK_BUTTON(button_19h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==20)||((time2/3600)==20)||(((time1/3600)<20)&&(time2/3600)>20))
                    gtk_button_set_relief(GTK_BUTTON(button_20h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==21)||((time2/3600)==21)||(((time1/3600)<21)&&(time2/3600)>21))
                    gtk_button_set_relief(GTK_BUTTON(button_21h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==22)||((time2/3600)==22)||(((time1/3600)<22)&&(time2/3600)>22))
                    gtk_button_set_relief(GTK_BUTTON(button_22h[j]),GTK_RELIEF_NORMAL);
                if(((time1/3600)==23)||((time2/3600)==23)||(((time1/3600)<23)&&(time2/3600)>23))
                    gtk_button_set_relief(GTK_BUTTON(button_23h[j]),GTK_RELIEF_NORMAL);
            }
        }
    }

    free(list_days_from_save);

    /* Enter the main loop */
    gtk_widget_show_all (win);
    gtk_main ();
    return 0;
}
