#include <stdio.h>
#include <stdlib.h>
#include "planning.h"
#include <signal.h>
#include <unistd.h>
#include "exec.h"
#include <sys/types.h>
#include "pthread.h"
#include "file.h"
//argv[2] = nom de l'application

#define UPDATE_TIME 30

struct reload_args
{
    char *filename;
    char command[500];
    planning *p;
};
typedef struct reload_args reload_args;

void handler (int signal_number);
void* reload_on_modify(void *args);

sig_atomic_t sig_term = 0;
pthread_mutex_t job_queue_mutex = PTHREAD_MUTEX_INITIALIZER;

void handler (int signal_number)
{
    ++sig_term;
}

void* reload_on_modify(void *args)
{
    reload_args *th_args = (reload_args*)args;
    FILE *f=NULL;
    char buffer[500];
    char day[500];
    char hour1[500];
    char hour2[500];
    int lines=0;
    int cpt=0,i=0;

    pthread_setcanceltype (PTHREAD_CANCEL_DISABLE, NULL);

    while(sig_term == 0)
    {
        sleep(1);
        cpt++;

        if(cpt==UPDATE_TIME)
        {
            pthread_mutex_lock (&job_queue_mutex);

            planning_reinit(th_args->p);

            lines = get_nb_param(th_args->filename);

            f = fopen(th_args->filename,"r");

            if(f!=NULL)
            {
                //passage des paramètres des champs d'entrée

                if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                for(i=0;buffer[i]!='\0';i++)
                {
                    if(buffer[i]=='\n')
                    {
                        buffer[i]=0;
                        break;
                    }
                }
                strcpy(th_args->command,buffer);
                if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");

                lines-=6;

                //récupération des jours
                while(!feof(f) && lines>0)
                {
                    if(!feof(f) && lines>0)
                    {
                        if(fgets(day,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                        if(fgets(hour1,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                        if(fgets(hour2,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                        lines-=3;

                        planning_add_day(th_args->p,day,hour1,hour2);
                    }
                }

                fclose(f);
            }
            pthread_mutex_unlock (&job_queue_mutex);
            cpt=0;
        }
    }

    return NULL;
}

int main(int argc, char *argv[])
{
    FILE *f = NULL, *f_visual = NULL;
    char buffer[500];
    char day[500];
    char hour1[500];
    char hour2[500];
    planning *p = NULL;
    int launched=0,nb_launch=0;
    pid_t child_pid=0;
    int lines = 0,i=0;
    reload_args th_args;

    struct timeval tv;
    struct tm *ptm;

    //thread for updating datas
    pthread_t thread_id;

    //handles SIGTERM signal
    struct sigaction sa;
    memset (&sa, 0, sizeof (sa));
    sa.sa_handler = &handler;
    sigaction (SIGTERM, &sa, NULL);

    p = planning_alloc();
    planning_init(p);

    th_args.filename = argv[1];
    th_args.p = p;

    lines = get_nb_param(argv[1]);

    f = fopen(argv[1],"r");
    if(f!=NULL)
    {
        //passage des paramètres des champs d'entrée

        if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
        if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
        for(i=0;buffer[i]!='\0';i++)
        {
            if(buffer[i]=='\n')
            {
                buffer[i]=0;
                break;
            }
        }
        strcpy(th_args.command,buffer);
        if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
        if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
        if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
        if(fgets(buffer,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");

        lines-=6;

        //récupération des jours
        while(!feof(f) && lines>0)
        {
            if(!feof(f) && lines>0)
            {
                if(fgets(day,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                if(fgets(hour1,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                if(fgets(hour2,500,f)==NULL)perror("Erreur de lecture du fichier de paramètres...");
                lines-=3;
                planning_add_day(p,day,hour1,hour2);
            }
        }
        fclose(f);

        pthread_create (&thread_id, NULL, &reload_on_modify,&th_args);

        while(sig_term==0)
        {
            pthread_mutex_lock (&job_queue_mutex);

            if(planning_is_activated(p) && launched==0)
            {
                launched=1;
                nb_launch++;
                child_pid=0;
                child_pid = spawn(th_args.command);
            }
            else
            {
                if(!planning_is_activated(p) && launched==1)
                {
                    kill(child_pid,SIGTERM);
                    launched=0;
                }
            }

            pthread_mutex_unlock (&job_queue_mutex);

            gettimeofday (&tv, NULL);
            ptm = localtime (&tv.tv_sec);

            f_visual=fopen(argv[5],"w+");

            fprintf(f_visual,"État:Actif\n");
            fprintf(f_visual,"Application:%s\n",th_args.command);
            fprintf(f_visual,"Mise à jour à: %02d:%02d:%02d\n",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);
            fprintf(f_visual,"Nombre de lancements:%d\n",nb_launch);
            if(launched==1)
            {
                fprintf(f_visual,"Logiciel activé: oui");
            }
            else
            {
                fprintf(f_visual,"Logiciel activé: non");
            }


            fclose(f_visual);
            sleep(1);

        }
    }
    else
    {
        perror("Fichier de paramètres invalide ou inexistant...");
    }

    pthread_join(thread_id,NULL);

    planning_free(p);

    return 0;
}
