#include "planning.h"

planning* planning_alloc()
{
    return malloc(sizeof(planning));
}

int planning_init(planning *p)
{
    int err = 0;

    p->day = malloc(10*sizeof(int));
    p->month = malloc(10*sizeof(int));
    p->year = malloc(10*sizeof(int));
    p->start = malloc(10*sizeof(day_time));
    p->end = malloc(10*sizeof(day_time));
    p->nb_elem = 0;
    p->len = 10;

    if(p->day==NULL || p->month==NULL || p->year==NULL || p->start==NULL || p->end==NULL)err=-1;

    return err;
}

int planning_add_day(planning *p,char *day, char *hour1, char *hour2)
{
    char tmp[10];
    int time=0;
    int err=0;

    if(p->nb_elem<p->len-1)
    {
        p->len+=10;
        p->day = realloc(p->day,p->len*sizeof(int));
        p->month = realloc(p->month,p->len*sizeof(int));
        p->year = realloc(p->year,p->len*sizeof(int));
        p->start =realloc(p->start,p->len*sizeof(day_time));
        p->end =realloc(p->end,p->len*sizeof(day_time));
    }

    if(strlen(day)==11)
    {
        tmp[0] = day[1];
        tmp[1] = day[2];
        tmp[2] = 0;
        sscanf(tmp,"%d",&p->day[p->nb_elem]);

        tmp[0] = day[3];
        tmp[1] = day[4];
        tmp[2] = 0;
        sscanf(tmp,"%d",&p->month[p->nb_elem]);

        tmp[0] = day[5];
        tmp[1] = day[6];
        tmp[2] = day[7];
        tmp[3] = day[8];
        tmp[4] = 0;
        sscanf(tmp,"%d",&p->year[p->nb_elem]);

        if(strlen(hour1)<=6)
        {
            sscanf(hour1,"%d",&time);
//            printf("time : %d\n",time);
            p->start[p->nb_elem].hour=time/3600;
            p->start[p->nb_elem].minute=(time/60)%60;
            p->start[p->nb_elem].second=time%60;
        }
        else
        {
            err=-1;
        }

        if(strlen(hour2)<=6)
        {
            sscanf(hour2,"%d",&time);
            p->end[p->nb_elem].hour=time/3600;
            p->end[p->nb_elem].minute=(time/60)%60;
            p->end[p->nb_elem].second=time%60;
        }
        else
        {
            err=-1;
        }

        p->nb_elem++;
    }
    else
    {
        err=-1;
    }

    return err;
}

int planning_is_activated(planning *p)
{
    struct timeval tv;
    struct tm *ptm;
    int i=0;
    int result=0;

    int stamp_tm=0;
    int stamp_start=0;
    int stamp_end=0;

    gettimeofday (&tv, NULL);
    ptm = localtime (&tv.tv_sec);

    stamp_tm = ptm->tm_hour*3600+ptm->tm_min*60+ptm->tm_sec;

    for(i=0;i<planning_get_length(p);i++)
    {
        if((p->year[i]==ptm->tm_year+1900) && (p->month[i]==ptm->tm_mon+1) && (p->day[i]==ptm->tm_mday))
        {
            stamp_start = p->start[i].hour*3600+p->start[i].minute*60+p->start[i].second;
            stamp_end = p->end[i].hour*3600+p->end[i].minute*60+p->end[i].second;

            if(stamp_tm>=stamp_start && stamp_tm<=stamp_end)
            {
                result=1;
                break;
            }
        }
    }

    return result;
}

int planning_get_length(planning *p)
{
    return p->nb_elem;
}

void planning_reinit(planning *p)
{
    free(p->day);
    free(p->month);
    free(p->year);
    free(p->start);
    free(p->end);
    planning_init(p);
}

void planning_free(planning *p)
{
    free(p->day);
    free(p->month);
    free(p->year);
    free(p->start);
    free(p->end);
    free(p);
}

