#include <stdlib.h>
#include <gtk/gtk.h>

struct simple{
    int *start;
    int *end;
    char **fsim;
    int nb;
    int *on;
};
typedef struct simple simple;

struct rcal{
    double **start;
    double **end;
    char **fsim;
    int nb;
    int *nbrs;
    int *on;
};
typedef struct rcal rcal;

enum {
  COLUMN_NAME,
  N_COLUMNS,
};

enum {
  COLUMN_NAME1,
  COLUMN_HST,
  COLUMN_HEND,
  COLUMN_STATE,
  N_COLUMNS1
};

enum {
  COLUMN_NAME2,
  COLUMN_HST2,
  COLUMN_HEND2,
  COLUMN_STATE2,
  N_COLUMNS2
};

/** Functions **/

void maj_simple();
void maj_rcal();

/** END FUNC **/

/** GLOBAL VARS **/

char user[1000];
int nb_strict;
gboolean user_state;
gboolean script_on;
char** profil_strict=NULL;
simple profil_simple;
rcal profil_rcal;

GtkWidget* window;
GtkWidget* notebook;
GtkWidget* tablabel;
GtkWidget* vbox;
GtkWidget* label;
GtkWidget* bouton;

GtkTreeView *treeview;
GtkTreeIter treeiter;
GtkCellRenderer *renderer;
GtkTreeViewColumn *column;
GtkListStore *liststore;
GtkWidget* scrollbar;

GtkWidget* tablabel1;
GtkTreeView *treeview1;
GtkTreeIter treeiter1;
GtkCellRenderer *renderer1;
GtkTreeViewColumn *column1;
GtkListStore *liststore1;
GtkWidget* scrollbar1;

GtkWidget* tablabel2;
GtkTreeView *treeview2;
GtkTreeIter treeiter2;
GtkCellRenderer *renderer2;
GtkTreeViewColumn *column2;
GtkListStore *liststore2;
GtkWidget* scrollbar2;

GdkPixbuf* on;
GdkPixbuf* off;


/** END **/

GdkPixbuf *create_pixbuf(const gchar * filename)
{
   GdkPixbuf *pixbuf;
   GError *error = NULL;
   pixbuf = gdk_pixbuf_new_from_file(filename, &error);
   if(!pixbuf) {
      fprintf(stderr, "%s\n", error->message);
      g_error_free(error);
   }

   return pixbuf;
}

int get_nb_param(char* file)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;
    int* nb_car;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb_car=fgets(line,1000,f);
        eof= feof(f);

        while(eof!=1)
        {
            i++;
            fgets(line,1000,f);
            eof= feof(f);
        }
        fclose(f);
    }
    else i=-1;
    if (nb_car==NULL) i=-1;

    return i;
}

int main (int argc, char *argv[])
{
    FILE* f=NULL;
    char line[1000];
    int i,j;
    char filename[1000];
    int nb,k,l;
    char cmd_tmp[1000],line_tmp[1000];
    FILE *frcal=NULL;
    double dt;
    char hst[20];
    char hend[20];

    char hst2[100];
    char hend2[100];

    int hour,min,sec;

    struct timeval tv;
    struct tm* ptm;
    int actual_time;
    double actual_rcal;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    actual_time=10000*(ptm->tm_hour)+100*(ptm->tm_min)+(ptm->tm_sec);
    actual_rcal=(double)(ptm->tm_hour)*3600+(ptm->tm_min)*60+(ptm->tm_sec)+100000*((double)ptm->tm_mday)+10000000*((double)ptm->tm_mon+1)+1000000000*((double)ptm->tm_year+1900);

    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
    gtk_init (&argc, &argv);
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

    if(argc!=2)
    {
        f=fopen("/tmp/childvisu_users.tmp","w+");
        fclose(f);

        system("users >> /tmp/childvisu_users.tmp");

        f=fopen("/tmp/childvisu_users.tmp","r");
        fgets(line,1000,f);
        fclose(f);

        system("rm /tmp/childvisu_users.tmp");

        i=0;
        while(i<strlen(line))
        {
            if(line[i]==' ')
            {
                line[i]='\0';
                break;
            }
            i++;
        }
        strcpy(user,line);
    }
    else strcpy(user,argv[1]);

    // Vérif de non bck n
    i=0;
    while(i<strlen(user))
    {
        if(user[i]=='\n')
        {
            user[i]='\0';
        }
        i++;
    }

    printf("Load\nUser:%s\nArgc=%d\n",user,argc);

    /** VERIFY ON/OFF AND SCRIPT **/

    strcpy(line,"/usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(line,user);
    strcat(line,"/on");

    f=NULL;
    f=fopen(line,"r");
    if(f!=NULL) user_state=TRUE;
    else user_state=FALSE;

    f=fopen("/tmp/childvisu_schedio_restrict.tmp","w+");
    fclose(f);

    system("ps -aux | grep schedio_restrict >> /tmp/childvisu_schedio_restrict.tmp");

    if(get_nb_param("/tmp/childvisu_schedio_restrict.tmp")>2) script_on=TRUE;
    else script_on=FALSE;

    system("rm /tmp/childvisu_schedio_restrict.tmp");

    /** END **/

    /** LOAD STRICT **/

    strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(filename,user);
    strcat(filename,"/");
    strcat(filename,user);
    nb_strict=get_nb_param(filename);

    printf("Nb_strict:%d\n",nb_strict);


    f=NULL;
    f=fopen(filename,"r");
    if(f!=NULL)
    {
        printf("filename exists\n");
        profil_strict=malloc(sizeof(char*)*nb_strict);
        i=0;
        while(i<nb_strict)
        {
            profil_strict[i]=malloc(sizeof(char)*1000);
            fgets(line,1000,f);
            strcpy(profil_strict[i],line);
            profil_strict[i][strlen(profil_strict[i])-1]='\0';
            printf("Strict:%s\n",profil_strict[i]);
            i++;
        }
    fclose(f);
    }

    /** END OF STRICT **/

    /** LOAD SIMPLE **/

    strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(filename,user);
    strcat(filename,"/simple.s");
    (profil_simple).nb=get_nb_param(filename);
    ((profil_simple).nb)/=3;

    printf("filename:%s:%d\n",filename,(profil_simple).nb);

    nb=(profil_simple).nb;

    f=NULL;
    f=fopen(filename,"r");
    if(f!=NULL)
    {
        printf("filename exists\n");
        (profil_simple).fsim=malloc(sizeof(char*)*nb);
        (profil_simple).start=malloc(sizeof(int)*nb);
        (profil_simple).end=malloc(sizeof(int)*nb);
        (profil_simple).on=malloc(sizeof(int)*nb);

        j=0;
        while(j<((profil_simple).nb))
        {
            ((profil_simple).fsim)[j]=malloc(sizeof(char)*1000);
            fgets(line,1000,f);

            strcpy(((profil_simple).fsim)[j],line);
            ((profil_simple).fsim)[j][strlen(((profil_simple).fsim)[j])-1]='\0';

            fgets(line,1000,f);
            sscanf(line,"%d",&(((profil_simple).start)[j]));

            fgets(line,1000,f);
            sscanf(line,"%d",&(((profil_simple).end)[j]));

            (profil_simple).on[j]=0;

            printf("Simple:%s %d %d\n",((profil_simple).fsim)[j],((profil_simple).start)[j],((profil_simple).end)[j]);
            j++;
        }
        fclose(f);
    }

    /** END OF SIMPLE **/

    /** LOAD RCAL **/

    strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(filename,user);
    strcat(filename,"/calendrier/calendrier.conf");
    (profil_rcal).nb=get_nb_param(filename);

    printf("Profil_rcal_nb=%d\n",(profil_rcal).nb);

    nb=(profil_rcal).nb;

    f=NULL;
    f=fopen(filename,"r");
    if(f!=NULL)
    {
        printf("filename exists\n");
        (profil_rcal).fsim=malloc(sizeof(char*)*nb);
        (profil_rcal).start=malloc(sizeof(double*)*nb);
        (profil_rcal).end=malloc(sizeof(double*)*nb);
        (profil_rcal).on=malloc(sizeof(int)*nb);
        (profil_rcal).nbrs=malloc(sizeof(int)*nb);

        j=0;
        while(j<((profil_rcal).nb))
        {
            ((profil_rcal).fsim)[j]=malloc(sizeof(char)*1000);
            fgets(line,1000,f);

            strcpy(((profil_rcal).fsim)[j],line);
            ((profil_rcal).fsim)[j][strlen(((profil_rcal).fsim)[j])-1]='\0';

            (profil_rcal).on[j]=0;

            printf("Rcal:%s\n",((profil_rcal).fsim)[j]);

            strcpy(cmd_tmp,(profil_rcal).fsim[j]);
            l=0;
            k=0;
            while(((profil_rcal).fsim[j][l])!='\0')
            {
                if((profil_rcal).fsim[j][l]=='/') k=-1;
                else cmd_tmp[k]=(profil_rcal).fsim[j][l];
                l++;
                k++;
            }
            cmd_tmp[k]='\0';

            strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
            strcat(filename,user);
            strcat(filename,"/calendrier/");
            strcat(filename,cmd_tmp);
            nb=get_nb_param(filename);

            nb-=6;
            nb/=3;

            if(nb<0) nb=0;

            printf("File:%s %d\n",cmd_tmp,nb);

            if(nb>0)
            {
                (profil_rcal).start[j]=malloc(sizeof(double)*nb);
                (profil_rcal).end[j]=malloc(sizeof(double)*nb);
            }
            (profil_rcal).nbrs[j]=nb;

            frcal=NULL;
            frcal=fopen(filename,"r");
            if(frcal!=NULL)
            {
                k=0;
                while(k<6)
                {
                    fgets(line,1000,frcal);
                    k++;
                }
                k=0;
                while(k<nb)
                {
                    (profil_rcal).start[j][k]=0;

                    fgets(line,1000,frcal);

                    line_tmp[0]=line[1];
                    line_tmp[1]=line[2];
                    line_tmp[2]='\0';

                    sscanf(line_tmp,"%lf",&dt);
                    dt*=100000;
                    (profil_rcal).start[j][k]+=dt;
                    (profil_rcal).end[j][k]+=dt;

                    line_tmp[0]=line[3];
                    line_tmp[1]=line[4];
                    line_tmp[2]='\0';

                    sscanf(line_tmp,"%lf",&dt);
                    dt*=10000000;
                    (profil_rcal).start[j][k]+=dt;
                    (profil_rcal).end[j][k]+=dt;

                    line_tmp[0]=line[5];
                    line_tmp[1]=line[6];
                    line_tmp[2]=line[7];
                    line_tmp[3]=line[8];
                    line_tmp[4]='\0';

                    sscanf(line_tmp,"%lf",&dt);
                    dt*=1000000000;
                    (profil_rcal).start[j][k]+=dt;
                    (profil_rcal).end[j][k]+=dt;

                    fgets(line,1000,frcal);
                    line[strlen(line)-1]='\0';
                    sscanf(line,"%d",&l);

                    (profil_rcal).start[j][k]+=l;

                    fgets(line,1000,frcal);
                    line[strlen(line)-1]='\0';
                    sscanf(line,"%d",&l);

                    (profil_rcal).end[j][k]+=l;

                    printf("Found:%lf to %lf\n",(profil_rcal).start[j][k],(profil_rcal).end[j][k]);
                    k++;
                }
            }

            j++;
        }
        fclose(f);
    }

    strcpy(line,"Childvisu de ");
    strcat(line,user);

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (window),2);
    gtk_window_set_title (GTK_WINDOW (window), line);
    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_window_resize(GTK_WINDOW(window),800,500);
    gtk_window_set_icon(GTK_WINDOW(window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
    g_signal_connect (window, "destroy", gtk_main_quit, NULL);

    on=create_pixbuf("/usr/share/schedio/on.png");
    off=create_pixbuf("/usr/share/schedio/off.png");

    notebook = gtk_notebook_new();
    gtk_notebook_set_scrollable(GTK_NOTEBOOK(notebook), TRUE);
    gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);

    gtk_container_add(GTK_CONTAINER(window), notebook);

    tablabel = gtk_label_new("Restrictions strictes");

    vbox=gtk_vbox_new(FALSE,0);

    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox, tablabel);

    if(nb_strict>0)
    {
        i=0;
        if(script_on)
        {
            if(user_state)label=gtk_label_new("État global: Profil Actif");
            else label=gtk_label_new("État global: Profil Désactivé");
        }
        else
        {
            label=gtk_label_new("État global: Script non lancé");
        }
        gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE,0);
        liststore = gtk_list_store_new(N_COLUMNS, G_TYPE_STRING);
        treeview = gtk_tree_view_new_with_model (GTK_TREE_MODEL(liststore));
        renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes ("Nom",
                                                           renderer,
                                                           "text",COLUMN_NAME,
                                                           NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);

        scrollbar=gtk_scrolled_window_new(NULL,NULL);
        gtk_scrolled_window_set_policy(scrollbar,GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
        gtk_container_add(GTK_CONTAINER(scrollbar),treeview);

        gtk_box_pack_start(GTK_BOX(vbox), scrollbar, TRUE, TRUE,0);

        while(i<nb_strict)
        {
            // Add an entry in the list
            gtk_list_store_append(liststore,&treeiter);
            gtk_list_store_set (liststore, &treeiter,COLUMN_NAME, profil_strict[i],-1);
            i++;
        }
    }
    else
    {
        label=gtk_label_new("Aucune restrictions n'est enregistrée.");
        gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE,0);
    }

    tablabel = gtk_label_new("Restrictions temporelles simples");

    vbox=gtk_vbox_new(FALSE,0);

    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox, tablabel);


    if(profil_simple.nb>0)
    {
        i=0;
        if(script_on)
        {
            if(user_state)label=gtk_label_new("État global: Profil Actif");
            else label=gtk_label_new("État global: Profil Désactivé");
        }
        else
        {
            label=gtk_label_new("État global: Script non lancé");
        }
        gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE,0);
        liststore1 = gtk_list_store_new(N_COLUMNS1, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, GDK_TYPE_PIXBUF);
        treeview1 = gtk_tree_view_new_with_model (GTK_TREE_MODEL(liststore1));

        renderer1 = gtk_cell_renderer_text_new ();
        column1 = gtk_tree_view_column_new_with_attributes ("Nom",renderer1,"text",COLUMN_NAME1,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), column1);

        renderer1 = gtk_cell_renderer_text_new ();
        column1 = gtk_tree_view_column_new_with_attributes ("Heure de départ",renderer1,"text",COLUMN_HST,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), column1);

        renderer1 = gtk_cell_renderer_text_new ();
        column1 = gtk_tree_view_column_new_with_attributes ("Heure de fin",renderer1,"text",COLUMN_HEND,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), column1);

        renderer1 = gtk_cell_renderer_pixbuf_new ();
        column1 = gtk_tree_view_column_new_with_attributes ("État",renderer1,"pixbuf",COLUMN_STATE,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), column1);

        scrollbar1=gtk_scrolled_window_new(NULL,NULL);
        gtk_scrolled_window_set_policy(scrollbar1,GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
        gtk_container_add(GTK_CONTAINER(scrollbar1),treeview1);

        gtk_box_pack_start(GTK_BOX(vbox), scrollbar1, TRUE, TRUE,0);

        bouton = gtk_button_new_with_label("Rafraîchir");
        gtk_signal_connect_object(GTK_OBJECT(bouton), "clicked", GTK_SIGNAL_FUNC(maj_simple), NULL);
        gtk_box_pack_start (GTK_BOX (vbox), bouton, FALSE, FALSE, 0);

        while(i<profil_simple.nb)
        {
            sprintf(hst,"%d",(profil_simple.start)[i]);
            sprintf(hend,"%d",(profil_simple.end)[i]);

            strcpy(line,hst);
            hst[0]=line[0];
            hst[1]=line[1];
            hst[2]=':';
            hst[3]=line[2];
            hst[4]=line[3];
            hst[5]=':';
            hst[6]=line[4];
            hst[7]=line[5];
            hst[8]='\0';

            strcpy(line,hend);
            hend[0]=line[0];
            hend[1]=line[1];
            hend[2]=':';
            hend[3]=line[2];
            hend[4]=line[3];
            hend[5]=':';
            hend[6]=line[4];
            hend[7]=line[5];
            hend[8]='\0';

            // Add an entry in the list
            gtk_list_store_append(liststore1,&treeiter1);
            if(actual_time>(profil_simple.start)[i] && actual_time<(profil_simple.end)[i]) gtk_list_store_set (liststore1, &treeiter1,COLUMN_NAME, (profil_simple.fsim)[i],COLUMN_HST,hst,COLUMN_HEND,hend,COLUMN_STATE,on,-1);
            else gtk_list_store_set (liststore1, &treeiter1,COLUMN_NAME, (profil_simple.fsim)[i],COLUMN_HST,hst,COLUMN_HEND,hend,COLUMN_STATE,off,-1);
            i++;
        }
    }
    else
    {
        label=gtk_label_new("Aucune restrictions n'est enregistrée.");
        gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE,0);
    }

    tablabel = gtk_label_new("Restrictions par calendrier");

    vbox=gtk_vbox_new(FALSE,0);

    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox, tablabel);

    if(profil_rcal.nb>0)
    {
        i=0;
        if(script_on)
        {
            if(user_state)label=gtk_label_new("État global: Profil Actif");
            else label=gtk_label_new("État global: Profil Désactivé");
        }
        else
        {
            label=gtk_label_new("État global: Script non lancé");
        }
        gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE,0);

        liststore2 = gtk_list_store_new(N_COLUMNS2, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, GDK_TYPE_PIXBUF);
        treeview2 = gtk_tree_view_new_with_model (GTK_TREE_MODEL(liststore2));

        renderer2 = gtk_cell_renderer_text_new ();
        column2 = gtk_tree_view_column_new_with_attributes ("Nom",renderer2,"text",COLUMN_NAME2,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview2), column2);

        renderer2 = gtk_cell_renderer_text_new ();
        column2 = gtk_tree_view_column_new_with_attributes ("Date de départ",renderer2,"text",COLUMN_HST2,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview2), column2);

        renderer2 = gtk_cell_renderer_text_new ();
        column2 = gtk_tree_view_column_new_with_attributes ("Date de fin",renderer2,"text",COLUMN_HEND2,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview2), column2);

        renderer2 = gtk_cell_renderer_pixbuf_new ();
        column2 = gtk_tree_view_column_new_with_attributes ("État",renderer2,"pixbuf",COLUMN_STATE2,NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview2), column2);

        scrollbar2=gtk_scrolled_window_new(NULL,NULL);
        gtk_scrolled_window_set_policy(scrollbar2,GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
        gtk_container_add(GTK_CONTAINER(scrollbar2),treeview2);

        gtk_box_pack_start(GTK_BOX(vbox), scrollbar2, TRUE, TRUE,0);

        bouton = gtk_button_new_with_label("Rafraîchir");
        gtk_signal_connect_object(GTK_OBJECT(bouton), "clicked", GTK_SIGNAL_FUNC(maj_rcal), NULL);
        gtk_box_pack_start (GTK_BOX (vbox), bouton, FALSE, FALSE, 0);

        while(i<profil_rcal.nb)
        {
            j=0;
            while(j<(profil_rcal.nbrs)[i])
            {
                if(actual_rcal<profil_rcal.end[i][j])
                {
                    gtk_list_store_append(liststore2,&treeiter2);

                    sprintf(hst2,"%.0lf",(profil_rcal.start)[i][j]);
                    sprintf(hend2,"%.0lf",(profil_rcal.end)[i][j]);

                    strcpy(line,hst2);
                    hst2[0]=line[6];
                    hst2[1]=line[7];
                    hst2[2]='/';
                    hst2[3]=line[4];
                    hst2[4]=line[5];
                    hst2[5]='/';
                    hst2[6]=line[0];
                    hst2[7]=line[1];
                    hst2[8]=line[2];
                    hst2[9]=line[3];
                    hst2[10]=' ';
                    hst2[11]='\0';
                    line[0]=line[8];
                    line[1]=line[9];
                    line[2]=line[10];
                    line[3]=line[11];
                    line[4]=line[12];
                    line[5]='\0';
                    sscanf(line,"%d",&k);
                    hour=k/3600;
                    k-=hour*3600;
                    min=k/60;
                    k-=min*60;
                    sec=k;
                    sprintf(line,"%02d:%02d:%02d",hour,min,sec);
                    strcat(hst2,line);

                    strcpy(line,hend2);
                    hend2[0]=line[6];
                    hend2[1]=line[7];
                    hend2[2]='/';
                    hend2[3]=line[4];
                    hend2[4]=line[5];
                    hend2[5]='/';
                    hend2[6]=line[0];
                    hend2[7]=line[1];
                    hend2[8]=line[2];
                    hend2[9]=line[3];
                    hend2[10]=' ';
                    hend2[11]='\0';
                    line[0]=line[8];
                    line[1]=line[9];
                    line[2]=line[10];
                    line[3]=line[11];
                    line[4]=line[12];
                    line[5]='\0';
                    sscanf(line,"%d",&k);
                    hour=k/3600;
                    k-=hour*3600;
                    min=k/60;
                    k-=min*60;
                    sec=k;
                    sprintf(line,"%02d:%02d:%02d",hour,min,sec);
                    strcat(hend2,line);

                    if(actual_rcal>((profil_rcal.start[i])[j]) && actual_rcal<((profil_rcal.end[i])[j])) gtk_list_store_set (liststore2, &treeiter2,COLUMN_NAME2, (profil_rcal.fsim)[i],COLUMN_HST2,hst2,COLUMN_HEND2,hend2,COLUMN_STATE2,on,-1);
                    else gtk_list_store_set (liststore2, &treeiter2,COLUMN_NAME2, (profil_rcal.fsim)[i],COLUMN_HST2,hst2,COLUMN_HEND2,hend2,COLUMN_STATE2,off,-1);
                }

                j++;
            }
            i++;
        }
    }
    else
    {
        label=gtk_label_new("Aucune restrictions n'est enregistrée.");
        gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE,0);
    }

    gtk_widget_show_all(window);

    gtk_main ();

    return 0;
}

void maj_simple()
{
    int i;
    char line[1000];
    char hst[20],hend[20];
    struct timeval tv;
    struct tm* ptm;
    int actual_time;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    actual_time=10000*(ptm->tm_hour)+100*(ptm->tm_min)+(ptm->tm_sec);

    if(profil_simple.nb>0)gtk_list_store_clear(liststore1);

    while(i<profil_simple.nb)
        {
            sprintf(hst,"%d",(profil_simple.start)[i]);
            sprintf(hend,"%d",(profil_simple.end)[i]);

            strcpy(line,hst);
            hst[0]=line[0];
            hst[1]=line[1];
            hst[2]=':';
            hst[3]=line[2];
            hst[4]=line[3];
            hst[5]=':';
            hst[6]=line[4];
            hst[7]=line[5];
            hst[8]='\0';

            strcpy(line,hend);
            hend[0]=line[0];
            hend[1]=line[1];
            hend[2]=':';
            hend[3]=line[2];
            hend[4]=line[3];
            hend[5]=':';
            hend[6]=line[4];
            hend[7]=line[5];
            hend[8]='\0';

            // Add an entry in the list
            gtk_list_store_append(liststore1,&treeiter1);
            if(actual_time>(profil_simple.start)[i] && actual_time<(profil_simple.end)[i]) gtk_list_store_set (liststore1, &treeiter1,COLUMN_NAME, (profil_simple.fsim)[i],COLUMN_HST,hst,COLUMN_HEND,hend,COLUMN_STATE,on,-1);
            else gtk_list_store_set (liststore1, &treeiter1,COLUMN_NAME, (profil_simple.fsim)[i],COLUMN_HST,hst,COLUMN_HEND,hend,COLUMN_STATE,off,-1);
            i++;
        }
}

void maj_rcal()
{
    struct timeval tv;
    struct tm* ptm;
    double actual_rcal;
    int i,j,hour,min,sec;
    char line[1000];
    char hst2[20],hend2[20];
    int k;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    actual_rcal=(double)(ptm->tm_hour)*3600+(ptm->tm_min)*60+(ptm->tm_sec)+100000*((double)ptm->tm_mday)+10000000*((double)ptm->tm_mon+1)+1000000000*((double)ptm->tm_year+1900);

    if(profil_rcal.nb>0)gtk_list_store_clear(liststore2);
    while(i<profil_rcal.nb)
        {
            j=0;
            while(j<(profil_rcal.nbrs)[i])
            {
                if(actual_rcal<profil_rcal.end[i][j])
                {
                    gtk_list_store_append(liststore2,&treeiter2);

                    sprintf(hst2,"%.0lf",(profil_rcal.start)[i][j]);
                    sprintf(hend2,"%.0lf",(profil_rcal.end)[i][j]);

                    strcpy(line,hst2);
                    hst2[0]=line[6];
                    hst2[1]=line[7];
                    hst2[2]='/';
                    hst2[3]=line[4];
                    hst2[4]=line[5];
                    hst2[5]='/';
                    hst2[6]=line[0];
                    hst2[7]=line[1];
                    hst2[8]=line[2];
                    hst2[9]=line[3];
                    hst2[10]=' ';
                    hst2[11]='\0';
                    line[0]=line[8];
                    line[1]=line[9];
                    line[2]=line[10];
                    line[3]=line[11];
                    line[4]=line[12];
                    line[5]='\0';
                    sscanf(line,"%d",&k);
                    hour=k/3600;
                    k-=hour*3600;
                    min=k/60;
                    k-=min*60;
                    sec=k;
                    sprintf(line,"%02d:%02d:%02d",hour,min,sec);
                    strcat(hst2,line);

                    strcpy(line,hend2);
                    hend2[0]=line[6];
                    hend2[1]=line[7];
                    hend2[2]='/';
                    hend2[3]=line[4];
                    hend2[4]=line[5];
                    hend2[5]='/';
                    hend2[6]=line[0];
                    hend2[7]=line[1];
                    hend2[8]=line[2];
                    hend2[9]=line[3];
                    hend2[10]=' ';
                    hend2[11]='\0';
                    line[0]=line[8];
                    line[1]=line[9];
                    line[2]=line[10];
                    line[3]=line[11];
                    line[4]=line[12];
                    line[5]='\0';
                    sscanf(line,"%d",&k);
                    hour=k/3600;
                    k-=hour*3600;
                    min=k/60;
                    k-=min*60;
                    sec=k;
                    sprintf(line,"%02d:%02d:%02d",hour,min,sec);
                    strcat(hend2,line);

                    if(actual_rcal>((profil_rcal.start[i])[j]) && actual_rcal<((profil_rcal.end[i])[j])) gtk_list_store_set (liststore2, &treeiter2,COLUMN_NAME2, (profil_rcal.fsim)[i],COLUMN_HST2,hst2,COLUMN_HEND2,hend2,COLUMN_STATE2,on,-1);
                    else gtk_list_store_set (liststore2, &treeiter2,COLUMN_NAME2, (profil_rcal.fsim)[i],COLUMN_HST2,hst2,COLUMN_HEND2,hend2,COLUMN_STATE2,off,-1);
                }

                j++;
            }
            i++;
        }
}
