// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <time.h>

int cpt_block(char* name)
{
    int nb=0;
    int i=0;
    int quot_block=0;
    int normal_block=0;
    int db_quot_block=0;

    while(i<strlen(name))
    {
        if(!quot_block && !normal_block && !db_quot_block)
        {
            if(name[i]=='\'') quot_block=1;
            else if(name[i]=='\"') db_quot_block=1;
            else if(name[i]!=' ') normal_block=1;
        }
        else if(quot_block)
        {
            while(name[i]!='\'' && i<strlen(name))i++;
            nb++;
            quot_block=0;
        }
        else if(db_quot_block)
        {
            while(name[i]!='\"' && i<strlen(name))i++;
            nb++;
            db_quot_block=0;
        }
        else if(normal_block)
        {
            while(name[i]!=' ' && i<strlen(name)) i++;
            nb++;
            normal_block=0;
        }
        i++;
    }
    return nb;
}

void give_block(char* name,char* block,int num)
{
    int nb=0;
    int i=0;
    int j=0;
    int quot_block=0;
    int normal_block=0;
    int db_quot_block=0;
    char tmp[1000];

    while(i<strlen(name))
    {
        if(!quot_block && !normal_block && !db_quot_block)
        {
            if(name[i]=='\'') quot_block=1;
            else if(name[i]=='\"') db_quot_block=1;
            else if(name[i]!=' ') normal_block=1;
        }
        else if(quot_block)
        {
            j=0;
            while(name[i]!='\'' && name[i]!='\0')
            {
                tmp[j]=name[i];
                i++;
                j++;
            }
            tmp[j]='\0';
            nb++;
            quot_block=0;
        }
        else if(db_quot_block)
        {
            j=0;
            while(name[i]!='\"' && name[i]!='\0')
            {
                tmp[j]=name[i];
                j++;
                i++;
            }
            tmp[j]='\0';
            nb++;
            db_quot_block=0;
        }
        else if(normal_block)
        {
            j=0;
            while(name[i]!=' ' && name[i]!='\0')
            {
                tmp[j]=name[i-1];
                j++;
                i++;
            }
            tmp[j]=name[i-1];
            j++;
            tmp[j]='\0';
            nb++;
            normal_block=0;
        }
        if(nb==num)
        {
            strcpy(block,tmp);
            break;
        }
        i++;
    }
}

int spawn (char* name)
{
    pid_t child_pid;
    int nb_block;
    int i=0;
    char **spawn;

    nb_block=cpt_block(name);
    spawn=malloc(sizeof(char*)*(nb_block+1));
    spawn[nb_block]=NULL;

    while(i<nb_block)
    {
        spawn[i]=malloc(sizeof(char)*1000);
        i++;
    }

    i=0;
    while(i<nb_block)
    {
        give_block(name,spawn[i],i+1);
        i++;
    }

    // Duplicate this process.
    child_pid = fork ();

    if (child_pid != 0)
    {
        i=0;
        while(i<nb_block)
        {
            free(spawn[i]);
            i++;
        }
        free(spawn);
        // This is the parent process.
        return child_pid;
    }
    else {
    // Now execute PROGRAM, searching for it in the path.
    execvp(spawn[0],spawn);
    // The execvp function returns only if an error occurs.
    fprintf (stderr, "Program is close, or an error occurred in execvp\n");
    abort ();
    }
}

int main(int argc, char *argv[])
{
    FILE* f_visual=NULL;
    FILE* f_save=NULL;

    int is_launch=0;
    int is_first=0;

    int nb_launch=0;

    int hour,min,sec;
    int hour1,min1,sec1;
    int days[7];
    int close_activ;
    int days_activ;
    int today;
    char name[1000];
    char name_killall[1000];

    int timestamp_start;
    int timestamp_current;
    int timestamp_stop;

    int kill_activ;
    int killall_activ;

    int pid;
    char pid_ch[100];

    char line[1000];

    struct timeval tv;
    struct tm* ptm;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    /** FIRST TEST **/

    printf("ARGC=%d\n",argc);
    if(argc==3)
    {
        f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Actif\n");
        fprintf(f_visual,"Application:----\n");
        fprintf(f_visual,"Nombre de lancements:--/--\n");
        fprintf(f_visual,"Heure d'ouverture:--:--:--\n");
        fprintf(f_visual,"Heure de fermeture:--:--:--\n");
        fprintf(f_visual,"Méthode de fermeture:--:--:--\n");
        fprintf(f_visual,"Jours d'activité activé:---\n");
        fprintf(f_visual,"Jours d'activité:---");

        fclose(f_visual);

        /** MAIN LOOP **/

        while(1)
        {
            /** INIT **/

            gettimeofday(&tv,NULL);
            ptm=localtime(&tv.tv_sec);

            f_save=fopen(argv[2],"r");

            fgets(name,1000,f_save);

            fgets(name,1000,f_save);
            name[strlen(name)-1]='\0';

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&hour);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&min);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&sec);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&close_activ);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&hour1);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&min1);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&sec1);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&kill_activ);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&killall_activ);

            if(kill_activ==0 && killall_activ==0) kill_activ=1;

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days_activ);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[0]);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[1]);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[2]);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[3]);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[4]);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[5]);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&days[6]);

            timestamp_start=sec;
            timestamp_start+=min*100;
            timestamp_start+=hour*10000;

            timestamp_stop=sec1;
            timestamp_stop+=min1*100;
            timestamp_stop+=hour1*10000;

            timestamp_current=ptm->tm_sec;
            timestamp_current+=(ptm->tm_min)*100;
            timestamp_current+=(ptm->tm_hour)*10000;

            f_visual=fopen(argv[1],"w+");

            fprintf(f_visual,"État:Actif\n");
            fprintf(f_visual,"Application:%s\n",name);
            fprintf(f_visual,"Mise à jour à: %02d:%02d:%02d\n",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);
            fprintf(f_visual,"Nombre de lancements:%d\n",nb_launch);
            fprintf(f_visual,"Heure d'ouverture:%02d:%02d:%02d\n",hour,min,sec);
            if(close_activ==1)fprintf(f_visual,"Heure de fermeture:%02d:%02d:%02d\n",hour1,min1,sec1);
            else fprintf(f_visual,"Heure de fermeture:aucune\n");
            if(kill_activ==1 && killall_activ==0)fprintf(f_visual,"Méthode de fermeture: Kill\n");
            else if(kill_activ==0 && killall_activ==1) fprintf(f_visual,"Méthode de fermeture:Killall\n");
            else fprintf(f_visual,"Méthode de fermeture:Kill et Killall\n");
            if(days_activ==1)fprintf(f_visual,"Jours d'activité activé:Oui\n");
            else fprintf(f_visual,"Jours d'activité activé:Non\n");

            is_first=0;
            if(days[0]==0 && days[1]==0 && days[2]==0 && days[3]==0 && days[4]==0 && days[5]==0 && days[6]==0)fprintf(f_visual,"Jours d'activité:Aucun");
            else fprintf(f_visual,"Jours d'activité:");
            if(days[0]==1)
            {
                is_first=1;
                fprintf(f_visual,"Lundi");
            }
            if(days[1]==1)
            {
                if(is_first==1) fprintf(f_visual,", ");
                fprintf(f_visual,"Mardi");
                is_first=1;
            }
            if(days[2]==1)
            {
                if(is_first==1) fprintf(f_visual,", ");
                fprintf(f_visual,"Mercredi");
                is_first=1;
            }
            if(days[3]==1)
            {
                if(is_first==1) fprintf(f_visual,", ");
                fprintf(f_visual,"Jeudi");
                is_first=1;
            }
            if(days[4]==1)
            {
                if(is_first==1) fprintf(f_visual,", ");
                fprintf(f_visual,"Vendredi");
                is_first=1;
            }
            if(days[5]==1)
            {
                if(is_first==1) fprintf(f_visual,", ");
                fprintf(f_visual,"Samedi");
                is_first=1;
            }
            if(days[6]==1)
            {
                if(is_first==1) fprintf(f_visual,", ");
                fprintf(f_visual,"Dimanche");
                is_first=1;
            }

            fclose(f_visual);

            /** VERIFYING **/

            today=ptm->tm_wday;
            if(today==0) today=7;

            if(is_launch==0)
            {
                if(days[today-1]==1 || days_activ==0)
                {
                    pid=0;
                    if(timestamp_current==timestamp_start)
                    {
                        pid=spawn(name);
                        nb_launch++;
                        is_launch=1;
                    }
                }
            }
            else if(close_activ==1)
            {
                if(timestamp_current==timestamp_stop)
                {
                    if(kill_activ==1)
                    {
                        sprintf(pid_ch,"%d",pid);
                        strcpy(line,"kill -15 ");
                        strcat(line,pid_ch);
                        system(line);
                    }
                    if(killall_activ)
                    {
                        give_block(name,name_killall,1);
                        strcpy(line,"killall ");
                        strcat(line,name_killall);
                        system(line);
                    }

                    pid=0;
                    is_launch=0;
                }
            }

            if(close_activ==0) is_launch=0;

            sleep(1);
        }
    }
    return 0;
}
