// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <time.h>
#include <libnotify/notification.h>
#include <glib.h>

int spawn (char* name)
{
    pid_t child_pid;
    char *spawn[]={name,NULL};

    /* Duplicate this process. */
    child_pid = fork ();

    if (child_pid != 0)
    {
        /* This is the parent process. */
        return child_pid;
    }
    else {
    /* Now execute PROGRAM, searching for it in the path. */
    execvp(name,spawn);
    /* The execvp function returns only if an error occurs. */
    fprintf (stderr, "Program is close, or an error occurred in execvp\n");
    abort ();
    }
}

void launch_notif(char sum[20],char mess[200],char icon[1000])
{
    NotifyNotification* notif;
    GError** error;
    notif=notify_notification_new(sum,mess,icon,NULL);
    notify_notification_show(notif,error);
}

int main(int argc, char *argv[])
{
    FILE* f_visual=NULL;
    FILE* f_save=NULL;

    int day,month,year;
    int remind_to_launch;
    int to_launch_end=0;
    int remind_interval;
    int interval;
    int remind_special_day;
    int special_day;
    char short_name[20];
    char name[110];
    char icon[1000];
    char message[200];
    int icon_activ;

    int to_notif=0;
    int date_end=0;
    int day_end=0;
    int interval_end=0;

    double current_date=0;
    double waiting_date=0;
    int current_wday;

    char line[1000];

    struct timeval tv;
    struct tm* ptm;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    /** FIRST TEST **/

    printf("ARGC=%d\n",argc);
    if(argc==3)
    {
        f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Actif\n");
        fprintf(f_visual,"Titre:----\n");
        fprintf(f_visual,"Date:--/--\n");
        fprintf(f_visual,"Rappel à chaque lancement:---\n");
        fprintf(f_visual,"Intervale de rappel:---\n");
        fprintf(f_visual,"Jour de rappel:---\n");
        fprintf(f_visual,"Icône:---\n");
        fprintf(f_visual,"Dernière vérification:--:--:--");

        fclose(f_visual);

        /** MAIN LOOP **/

        notify_init("schedio-reminder-pre");

        while(current_date<=waiting_date)
        {
            /** INIT **/

            gettimeofday(&tv,NULL);
            ptm=localtime(&tv.tv_sec);

            f_save=fopen(argv[2],"r");

            fgets(short_name,1000,f_save);

            fgets(short_name,1000,f_save);
            short_name[strlen(short_name)-1]='\0';

            fgets(name,1000,f_save);
            name[strlen(name)-1]='\0';

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&day);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&month);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&year);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&remind_to_launch);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&remind_interval);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&interval);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&remind_special_day);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&special_day);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&icon_activ);

            fgets(icon,1000,f_save);
            icon[strlen(icon)-1]='\0';

            current_date=ptm->tm_mday;
            current_date+=(ptm->tm_mon+1)*100;
            current_date+=(ptm->tm_year+1900)*10000;

            waiting_date=day;
            waiting_date+=(month+1)*100;
            waiting_date+=year*10000;

            current_wday=ptm->tm_wday-1;
            if(current_wday==-1) current_wday=6;

            f_visual=fopen(argv[1],"w+");

            fprintf(f_visual,"État:Actif (période de 5 minutes)\n");
            fprintf(f_visual,"Titre:%s\n",short_name);

            fprintf(f_visual,"Date:Le %02d ",day);
            if(month==0)fprintf(f_visual,"Janvier");
            if(month==1)fprintf(f_visual,"Février");
            if(month==2)fprintf(f_visual,"Mars");
            if(month==3)fprintf(f_visual,"Avril");
            if(month==4)fprintf(f_visual,"Mai");
            if(month==5)fprintf(f_visual,"Juin");
            if(month==6)fprintf(f_visual,"Juillet");
            if(month==7)fprintf(f_visual,"Aout");
            if(month==8)fprintf(f_visual,"Septembre");
            if(month==9)fprintf(f_visual,"Octobre");
            if(month==10)fprintf(f_visual,"Novembre");
            if(month==11)fprintf(f_visual,"Décembre");
            fprintf(f_visual," %d\n",year);

            if(remind_to_launch)fprintf(f_visual,"Rappel à chaque lancement:Oui\n");
            else fprintf(f_visual,"Rappel à chaque lancement:Non\n");

            if(remind_interval)fprintf(f_visual,"Intervale de rappel:%d jours\n",interval);
            else fprintf(f_visual,"Intervale de rappel:Aucun\n");
            if(remind_special_day)
            {
                fprintf(f_visual,"Jour de rappel:");
                if(special_day==0)fprintf(f_visual,"Lundi");
                if(special_day==1)fprintf(f_visual,"Mardi");
                if(special_day==2)fprintf(f_visual,"Mercredi");
                if(special_day==3)fprintf(f_visual,"Jeudi");
                if(special_day==4)fprintf(f_visual,"Vendredi");
                if(special_day==5)fprintf(f_visual,"Samedi");
                if(special_day==6)fprintf(f_visual,"Dimanche");
                fprintf(f_visual,"\n");
            }
            else fprintf(f_visual,"Jour de rappel:Aucun\n");
            if(icon_activ)fprintf(f_visual,"Icône:%s\n",icon);
            else fprintf(f_visual,"Icône:Par défaut\n");
            fprintf(f_visual,"Dernière vérification:%02d:%02d:%02d",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);

            fclose(f_visual);


            /** VERIFYING **/

            if(remind_to_launch && to_launch_end==0)
            {
                to_notif=1;
                to_launch_end=1;
            }

            if(waiting_date==current_date && date_end==0)
            {
                to_notif=1;
                date_end=1;
            }
            else if(waiting_date!=current_date) date_end=0;

            if(remind_special_day && day_end==0 && special_day==current_wday)
            {
                to_notif=1;
                day_end=1;
            }
            else if(special_day!=current_wday) day_end=0;

            if(remind_interval && ((ptm->tm_mday)%interval)==0 && interval_end==0)
            {
                interval_end=1;
                to_notif=1;
            }
            else if(((ptm->tm_mday)%interval)!=0) interval_end=0;



            if(to_notif && current_date<=waiting_date)
            {
                sprintf(message,"Date: %02d/%02d/%02d\n",day,month+1,year);
                strcat(message,name);
                if(icon_activ)launch_notif(short_name,message,icon);
                else launch_notif(short_name,message,"/usr/share/pixmaps/s_schedio.png");
                to_notif=0;
            }

            sleep(300);
        }
    }

    f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Terminé\n");
        fprintf(f_visual,"Titre:----\n");
        fprintf(f_visual,"Date:--/--\n");
        fprintf(f_visual,"Rappel à chaque lancement:---\n");
        fprintf(f_visual,"Intervale de rappel:---\n");
        fprintf(f_visual,"Jour de rappel:---\n");
        fprintf(f_visual,"Icône:---\n");
        fprintf(f_visual,"Dernière vérification:--:--:--");

    fclose(f_visual);

    notify_uninit();

    return 0;
}
