// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <time.h>
#include <libnotify/notification.h>
#include <glib.h>

int spawn (char* name)
{
    pid_t child_pid;
    char *spawn[]={name,NULL};

    /* Duplicate this process. */
    child_pid = fork ();

    if (child_pid != 0)
    {
        /* This is the parent process. */
        return child_pid;
    }
    else {
    /* Now execute PROGRAM, searching for it in the path. */
    execvp(name,spawn);
    /* The execvp function returns only if an error occurs. */
    fprintf (stderr, "Program is close, or an error occurred in execvp\n");
    abort ();
    }
}

void launch_notif(char sum[20],char mess[200],char icon[1000])
{
    NotifyNotification* notif;
    GError** error;
    notif=notify_notification_new(sum,mess,icon,NULL);
    notify_notification_show(notif,error);
}

int main(int argc, char *argv[])
{
    FILE* f_visual=NULL;
    FILE* f_save=NULL;

    int nb_remind=0;

    int day,month,year;
    int date_inactiv;
    int hour,min,sec;
    int min1,sec1;
    int remind_activ;
    int remind_infinite;
    int remind_max;
    char short_name[20];
    char name[110];
    char icon[1000];
    int icon_activ;
    char message[200];

    int timestamp_start;
    int timestamp_current;
    int time_to_wait;
    int time_to_wait_tmp;
    int current_wait=0;
    double current_date;
    double waiting_date;

    char line[1000];

    struct timeval tv;
    struct tm* ptm;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    /** FIRST TEST **/

    printf("ARGC=%d\n",argc);
    if(argc==3)
    {
        f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Actif\n");
        fprintf(f_visual,"Titre:----\n");
        fprintf(f_visual,"Date:--/--\n");
        fprintf(f_visual,"Heure:--:--:--\n");
        fprintf(f_visual,"Intervale de rappel:--:--:--\n");
        fprintf(f_visual,"Nombre de rappels:---\n");
        fprintf(f_visual,"Nombre maximum de rappels:---\n");
        fprintf(f_visual,"Icône:---\n");
        fprintf(f_visual,"Dernière vérification:--:--:--");

        fclose(f_visual);

        /** MAIN LOOP **/

        notify_init("schedio-reminder");

        launch_notif("Schedio","Le plugin de rappel vient d'être lancé.","/usr/share/pixmaps/s_schedio.png");

        while(1)
        {
            /** INIT **/

            gettimeofday(&tv,NULL);
            ptm=localtime(&tv.tv_sec);

            f_save=fopen(argv[2],"r");

            fgets(short_name,1000,f_save);

            fgets(short_name,1000,f_save);
            short_name[strlen(short_name)-1]='\0';

            fgets(name,1000,f_save);
            name[strlen(name)-1]='\0';

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&day);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&month);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&year);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&date_inactiv);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&hour);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&min);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&sec);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&remind_activ);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&min1);
            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&sec1);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&remind_max);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&remind_infinite);

            fgets(line,1000,f_save);
            line[strlen(line)-1]='\0';
            sscanf(line,"%d",&icon_activ);

            fgets(icon,1000,f_save);
            icon[strlen(icon)-1]='\0';

            timestamp_start=sec;
            timestamp_start+=min*100;
            timestamp_start+=hour*10000;

            time_to_wait=sec1;
            time_to_wait+=min1*100;

            if(time_to_wait<15)
            {
                time_to_wait=15;
                sec1=15;
            }

            if(time_to_wait!=time_to_wait_tmp) current_wait=0;

            timestamp_current=ptm->tm_sec;
            timestamp_current+=(ptm->tm_min)*100;
            timestamp_current+=(ptm->tm_hour)*10000;

            current_date=ptm->tm_mday;
            current_date+=(ptm->tm_mon+1)*100;
            current_date+=(ptm->tm_year+1900)*10000;

            waiting_date=day;
            waiting_date+=(month+1)*100;
            waiting_date+=year*10000;

            f_visual=fopen(argv[1],"w+");

            fprintf(f_visual,"État:Actif\n");
            fprintf(f_visual,"Titre:%s\n",short_name);
            if(!date_inactiv)
            {
                fprintf(f_visual,"Date:Le %02d ",day);
                if(month==0)fprintf(f_visual,"Janvier");
                if(month==1)fprintf(f_visual,"Février");
                if(month==2)fprintf(f_visual,"Mars");
                if(month==3)fprintf(f_visual,"Avril");
                if(month==4)fprintf(f_visual,"Mai");
                if(month==5)fprintf(f_visual,"Juin");
                if(month==6)fprintf(f_visual,"Juillet");
                if(month==7)fprintf(f_visual,"Aout");
                if(month==8)fprintf(f_visual,"Septembre");
                if(month==9)fprintf(f_visual,"Octobre");
                if(month==10)fprintf(f_visual,"Novembre");
                if(month==11)fprintf(f_visual,"Décembre");
                fprintf(f_visual," %d\n",year);
            }
            else fprintf(f_visual,"Date:Non active\n");
            fprintf(f_visual,"Heure:%02d:%02d:%02d\n",hour,min,sec);
            if(remind_activ)fprintf(f_visual,"Intervale de rappel:%02d:%02d\n",min1,sec1);
            else fprintf(f_visual,"Intervale de rappel:Pas de rappel\n");
            fprintf(f_visual,"Nombre de rappels:%d\n",nb_remind);
            if(remind_activ && !remind_infinite)fprintf(f_visual,"Nombre maximum de rappels:%d\n",remind_max);
            else if(remind_infinite)fprintf(f_visual,"Nombre maximum de rappels:Infini\n");
            else fprintf(f_visual,"Nombre maximum de rappels:Pas de rappel\n");
            if(icon_activ)fprintf(f_visual,"Icône:%s\n",icon);
            else fprintf(f_visual,"Icône:Par défaut\n");
            fprintf(f_visual,"Dernière vérification:%02d:%02d:%02d",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);

            fclose(f_visual);


            /** VERIFYING **/

            if((current_date>=waiting_date) || date_inactiv==1)
            {
                if((timestamp_current>=timestamp_start) || (current_date>waiting_date && date_inactiv==0))
                {
                    if(current_wait==0 && (nb_remind<remind_max || remind_infinite))
                    {
                        nb_remind++;
                        sprintf(message,"Horaire: %02d:%02d:%02d\n",hour,min,sec);
                        strcat(message,name);
                        if(icon_activ==1) launch_notif(short_name,message,icon);
                        else launch_notif(short_name,message,"/usr/share/pixmaps/s_schedio.png");
                        if(remind_activ)
                        {
                            current_wait=min1*60+sec1;
                            current_wait--;
                        }
                    }
                    else if(remind_activ) current_wait--;

                    if(nb_remind==remind_max && !remind_infinite || (nb_remind==1 && remind_activ==0))
                    {
                        f_visual=fopen(argv[1],"w+");

                        fprintf(f_visual,"État:Terminé\n");
                        fprintf(f_visual,"Titre:----\n");
                        fprintf(f_visual,"Date:--/--\n");
                        fprintf(f_visual,"Heure:--:--:--\n");
                        fprintf(f_visual,"Intervale de rappel:--:--:--\n");
                        fprintf(f_visual,"Nombre de rappels:---\n");
                        fprintf(f_visual,"Nombre maximum de rappels:Atteint(%d)\n",remind_max);
                        fprintf(f_visual,"Icône:---\n");
                        fprintf(f_visual,"Dernière vérification:--:--:--");

                        fclose(f_visual);

                        notify_uninit();
                        break;
                    }
                }
            }
            else
            {
                current_wait=0;
                nb_remind=0;
            }

            time_to_wait_tmp=time_to_wait;

            if(current_wait>=15)
            {
                sleep(10);
                current_wait-=9;
            }
            else
            {
                sleep(1);
            }
        }
    }
    return 0;
}
