#include <stdlib.h>
#include "configure.h"

void config_parcourir(GtkWidget *entry)
{
    GtkWidget *parcourir = NULL;
    char *filename;

    parcourir = gtk_file_chooser_dialog_new_with_backend ("Sélection du fichier de configuration",NULL,GTK_FILE_CHOOSER_ACTION_OPEN,".conf",GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, "Sélectionner", GTK_RESPONSE_ACCEPT,NULL);

    if (gtk_dialog_run (GTK_DIALOG (parcourir)) == GTK_RESPONSE_ACCEPT)
      {
        filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (parcourir));

        fprintf(stderr,"%s\n",filename);

        gtk_entry_set_text(entry,filename);

        g_free (filename);
      }
    gtk_widget_destroy (parcourir);
}

int get_nb_param(char* file)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;
    int* nb_car;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb_car=fgets(line,1000,f);
        eof= feof(f);

        while(eof!=1)
        {
            i++;
            fgets(line,1000,f);
            eof= feof(f);
        }
        fclose(f);
    }
    else i=-1;
    if (nb_car==NULL) i=-1;

    return i;
}

char* modifying_text(gint is_modifying)
{
    if(is_modifying)return "1";
    else return "0";
}

void fork_scheduler(GString *script_file,GString *plugin_file,GString *mode,GString *save_file,GString* visual_string,gint is_modifying)
{
    pid_t child_pid;
    FILE* f=NULL;
    short end=0;
    char line[500];
    char extract[200];
    char extract_param[100];
    char name[200];
    char param[200];

    char *spawn[]={"Default_scheduler",plugin_file->str,save_file->str,mode->str,modifying_text(is_modifying),visual_string->str,script_file->str,NULL};

    fprintf(stderr,"spawn %s...\n",spawn[5]);
    fprintf(stderr,"spawn %s...\n",spawn[6]);

    child_pid = fork ();

    if (child_pid == 0)
    {
        execvp("/usr/share/schedio/Default_scheduler",spawn);

        abort ();
    }

}

void modify_calendar(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *hbox = g_slist_nth_data(list,2);
    GtkWidget *label = g_slist_nth_data(list,3);
    GtkWidget *remove = g_slist_nth_data(list,4);
    GtkWidget *modify = g_slist_nth_data(list,5);
    GSList *data = g_slist_nth_data(list,6);

    GString *script_file = NULL;
    GString *plugin_file = NULL;
    GString *mode = NULL;
    GString *save_file = NULL;
    GString* visual_string = NULL;
    gint is_modifying;
    char *dir=NULL;
    char app[40];

    script_file = g_string_new("script_file");
    plugin_file = g_string_new("plugin_file");
    mode = g_string_new("old");
    visual_string = g_string_new("visual_string");
    is_modifying = 1;

    /*test du nom de fichier à donner*/

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/calendrier/")+strlen(name)+10);
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/calendrier/");
    get_app_name(gtk_label_get_text(label),app);
    strcat(dir,app);

    printf("dir %s\n",dir);

    save_file = g_string_new(dir);

    printf("name :%s\n",dir);

    fork_scheduler(script_file,plugin_file,mode,save_file,visual_string,is_modifying);
}

void save_item_and_spins(GSList *list)
{
    GSList *win = g_slist_nth_data(list,0);
    GSList *data = g_slist_nth_data(list,9);

    GString *entry = NULL;
    GString *s_h1 = NULL;
    GString *s_m1 = NULL;
    GString *s_s1 = NULL;
    GString *s_h2 = NULL;
    GString *s_m2 = NULL;
    GString *s_s2 = NULL;

    int i = 1;

    FILE *f = NULL;

    char *dir =  NULL;

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/")+2*strlen(name)+2);
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/");
    strcat(dir,"simple.s");

    f = fopen(dir,"w");

    fprintf(stderr,"list_length : %d\n",g_slist_length(data));

    for(i=1;(i+7)<=g_slist_length(data);i+=8)
    {
        fprintf(stderr,"item_to_save : %d\n",i);

        entry = g_slist_nth_data(data,i+1);
        s_h1 = g_slist_nth_data(data,i+2);
        s_m1 = g_slist_nth_data(data,i+3);
        s_s1 = g_slist_nth_data(data,i+4);
        s_h2 = g_slist_nth_data(data,i+5);
        s_m2 = g_slist_nth_data(data,i+6);
        s_s2 = g_slist_nth_data(data,i+7);

        fprintf(stderr,"item_to_save : %s\n",entry->str);
        fprintf(f,"%s\n",entry->str);
        fprintf(f,"%s",s_h1->str);
        fprintf(f,"%s",s_m1->str);
        fprintf(f,"%s\n",s_s1->str);
        fprintf(f,"%s",s_h2->str);
        fprintf(f,"%s",s_m2->str);
        fprintf(f,"%s\n",s_s2->str);
    }

    fclose(f);

    g_slist_free(data);
    g_slist_free(list);

    gtk_widget_destroy(win);
}

void save_one_item(GSList *list)
{
    GSList *win = g_slist_nth_data(list,0);
    GSList *data = g_slist_nth_data(list,3);

    GString *entry = NULL;

    int i = 1;

    FILE *f = NULL;

    char *dir =  NULL;

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/")+2*strlen(name)+2);
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/");
    strcat(dir,name);

    f = fopen(dir,"w");

    fprintf(stderr,"list_length : %d\n",g_slist_length(data));

    for(i=1;(i+1)<=g_slist_length(data);i+=2)
    {
        fprintf(stderr,"item_to_save : %d\n",i);

        entry = g_slist_nth_data(data,i+1);

        fprintf(stderr,"item_to_save : %s\n",entry->str);
        fprintf(f,"%s\n",entry->str);
    }

    fclose(f);

    g_slist_free(data);
    g_slist_free(list);

    gtk_widget_destroy(win);
}

void save_calendar_item(GSList *list)
{
    GSList *win = g_slist_nth_data(list,0);
    GSList *data = g_slist_nth_data(list,3);

    GString *entry = NULL;

    int i = 1;

    FILE *f = NULL;

    char *dir =  NULL;

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/")+strlen(name)+2+sizeof("/calendrier/calendrier.conf"));
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/calendrier/calendrier.conf");

    f = fopen(dir,"w");

    fprintf(stderr,"list_length : %d\n",g_slist_length(data));

    for(i=1;(i+1)<=g_slist_length(data);i+=2)
    {
        fprintf(stderr,"item_to_save : %d\n",i);

        entry = g_slist_nth_data(data,i+1);

        fprintf(stderr,"item_to_save : %s\n",entry->str);
        fprintf(f,"%s\n",entry->str);
    }

    fclose(f);

    g_slist_free(data);
    g_slist_free(list);

    gtk_widget_destroy(win);
}

void remove_item_and_spins(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *hbox = g_slist_nth_data(list,2);
    GtkWidget *label = g_slist_nth_data(list,3);
    GtkWidget *remove = g_slist_nth_data(list,4);
    GSList *data = g_slist_nth_data(list,5);
    int index;
    GSList *data1=NULL,*data2=NULL,*data3=NULL,*data4=NULL,*data5=NULL,*data6=NULL,*data7=NULL;

    fprintf(stderr,"******************* hbox is at %x ********************\n",hbox);
    gtk_container_remove(vbox,hbox);
    fprintf(stderr,"******************* label is at %x ********************\n",label);
    gtk_container_remove(hbox,label);
    fprintf(stderr,"******************* remove is at %x ********************\n",remove);
    gtk_container_remove(hbox,remove);

    index = g_slist_index(data,label);

    data1 = g_slist_nth_data(data,index+1);
    data2 = g_slist_nth_data(data,index+2);
    data3 = g_slist_nth_data(data,index+3);
    data4 = g_slist_nth_data(data,index+4);
    data5 = g_slist_nth_data(data,index+5);
    data6 = g_slist_nth_data(data,index+6);
    data7 = g_slist_nth_data(data,index+7);

    fprintf(stderr,"******************* index is %d ********************\n\n\n",index);

    if(index!=-1)
    {
        fprintf(stderr,"removing item and spins...\n");
        g_slist_remove(data,label);
        g_slist_remove(data,data1);
        g_slist_remove(data,data2);
        g_slist_remove(data,data3);
        g_slist_remove(data,data4);
        g_slist_remove(data,data5);
        g_slist_remove(data,data6);
        g_slist_remove(data,data7);
        fprintf(stderr,"list_length : %d\n",g_slist_length(data));
    }



    gtk_window_resize(GTK_WINDOW(win),300,100);
    gtk_widget_show_all(win);
}

void remove_one_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *hbox = g_slist_nth_data(list,2);
    GtkWidget *label = g_slist_nth_data(list,3);
    GtkWidget *remove = g_slist_nth_data(list,4);
    GSList *data = g_slist_nth_data(list,5);
    int index;
    GSList *data1=NULL;

    fprintf(stderr,"******************* hbox is at %x ********************\n",hbox);
    gtk_container_remove(vbox,hbox);
    fprintf(stderr,"******************* label is at %x ********************\n",label);
    gtk_container_remove(hbox,label);
    fprintf(stderr,"******************* remove is at %x ********************\n",remove);
    gtk_container_remove(hbox,remove);

    index = g_slist_index(data,label);

    data1 = g_slist_nth_data(data,index+1);

    fprintf(stderr,"******************* index is %d ********************\n\n\n",index);

    if(index!=-1)
    {
        fprintf(stderr,"removing...\n");
        g_slist_remove(data,label);
        g_slist_remove(data,data1);
    }

    gtk_window_resize(GTK_WINDOW(win),300,100);
    gtk_widget_show_all(win);
}

void remove_calendar_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *hbox = g_slist_nth_data(list,2);
    GtkWidget *label = g_slist_nth_data(list,3);
    GtkWidget *remove = g_slist_nth_data(list,4);
    GtkWidget *modify = g_slist_nth_data(list,5);
    GSList *data = g_slist_nth_data(list,6);
    int index;
    GSList *data1=NULL;

    fprintf(stderr,"******************* hbox is at %x ********************\n",hbox);
    gtk_container_remove(vbox,hbox);
    fprintf(stderr,"******************* label is at %x ********************\n",label);
    gtk_container_remove(hbox,label);
    fprintf(stderr,"******************* remove is at %x ********************\n",remove);
    gtk_container_remove(hbox,remove);
    gtk_container_remove(hbox,modify);

    index = g_slist_index(data,label);

    data1 = g_slist_nth_data(data,index+1);

    fprintf(stderr,"******************* index is %d ********************\n\n\n",index);

    if(index!=-1)
    {
        fprintf(stderr,"removing...\n");
        g_slist_remove(data,label);
        g_slist_remove(data,data1);
    }

    gtk_window_resize(GTK_WINDOW(win),300,100);
    gtk_widget_show_all(win);
}

void add_item_and_spins(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *config = g_slist_nth_data(list,2);
    GtkWidget *h1 = g_slist_nth_data(list,3);
    GtkWidget *m1 = g_slist_nth_data(list,4);
    GtkWidget *s1 = g_slist_nth_data(list,5);
    GtkWidget *h2 = g_slist_nth_data(list,6);
    GtkWidget *m2 = g_slist_nth_data(list,7);
    GtkWidget *s2 = g_slist_nth_data(list,8);
    GSList *data = g_slist_nth_data(list,9);

    GString *s_plugin=NULL;
    GString *s_entry=NULL;
    GString *s_h1=NULL;
    GString *s_m1=NULL;
    GString *s_s1=NULL;
    GString *s_h2=NULL;
    GString *s_m2=NULL;
    GString *s_s2=NULL;
    char value[3]={0};

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    s_entry = g_string_new(gtk_entry_get_text(config));

    sprintf(value,"%02d",gtk_spin_button_get_value_as_int(h1));
    s_h1 = g_string_new(value);
    sprintf(value,"%02d",gtk_spin_button_get_value_as_int(m1));
    s_m1 = g_string_new(value);
    sprintf(value,"%02d",gtk_spin_button_get_value_as_int(s1));
    s_s1 = g_string_new(value);
    sprintf(value,"%02d",gtk_spin_button_get_value_as_int(h2));
    s_h2 = g_string_new(value);
    sprintf(value,"%02d",gtk_spin_button_get_value_as_int(m2));
    s_m2 = g_string_new(value);
    sprintf(value,"%02d",gtk_spin_button_get_value_as_int(s2));
    s_s2 = g_string_new(value);

    if(strlen(s_entry->str)>2)
    {
        s_plugin = g_string_new(gtk_entry_get_text(config));
        g_string_append(s_plugin," : ");
        g_string_append(s_plugin,s_h1->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_m1->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_s1->str);
        g_string_append(s_plugin," - ");
        g_string_append(s_plugin,s_h2->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_m2->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_s2->str);

        label = gtk_label_new(s_plugin->str);

        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);

        g_slist_append(data,label);
        g_slist_append(data,s_entry);
        g_slist_append(data,s_h1);
        g_slist_append(data,s_m1);
        g_slist_append(data,s_s1);
        g_slist_append(data,s_h2);
        g_slist_append(data,s_m2);
        g_slist_append(data,s_s2);

        fprintf(stderr,"list_length (add) : %d\n",g_slist_length(data));


        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_item_and_spins, list_remove);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_item_and_spins, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);


        gtk_window_resize(GTK_WINDOW(win),300,100);
        gtk_widget_show_all(win);
    }
}

void get_app_name(char *dir, char *result)
{
    int i=0,j=0;

    while(dir[i]!='\n' && dir[i]!='\0')
    {
        if(dir[i]=='/') j=-1;
        else result[j]=dir[i];
        j++;
        i++;
    }
    result[j]='\0';

}

void add_one_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *config = g_slist_nth_data(list,2);
    GSList *data = g_slist_nth_data(list,3);

    GString *s_plugin=NULL;

    GString *s_entry=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    GString *script_file;
    GString *plugin_file;
    GString *mode;
    GString *save_file;
    GString* visual_string;
    gint is_modifying;
    char *dir=NULL;
    char app[40];

    s_plugin = g_string_new(gtk_entry_get_text(config));

    s_entry = g_string_new(gtk_entry_get_text(config));

    if(strlen(s_entry->str)>2)
    {
        label = gtk_label_new(s_plugin->str);
        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);

        g_slist_append(data,label);
        g_slist_append(data,s_entry);

        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_one_item, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);


        gtk_window_resize(GTK_WINDOW(win),300,100);
        gtk_widget_show_all(win);

    }
}

void add_calendar_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *config = g_slist_nth_data(list,2);
    GSList *data = g_slist_nth_data(list,3);

    GString *s_plugin=NULL;

    GString *s_entry=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *modify=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    GString *script_file;
    GString *plugin_file;
    GString *mode;
    GString *save_file;
    GString* visual_string;
    gint is_modifying;
    char *dir=NULL;
    char app[40];

    s_plugin = g_string_new(gtk_entry_get_text(config));

    s_entry = g_string_new(gtk_entry_get_text(config));

    if(strlen(s_entry->str)>2)
    {
        label = gtk_label_new(s_plugin->str);
        remove = gtk_button_new_with_label(" - ");
        modify = gtk_button_new_with_label(" Modifier ");
        hbox = gtk_hbox_new(FALSE,6);

        g_slist_append(data,label);
        g_slist_append(data,s_entry);

        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,modify);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(modify), "clicked", modify_calendar, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), modify, FALSE, FALSE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_calendar_item, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);

        gtk_window_resize(GTK_WINDOW(win),300,100);
        gtk_widget_show_all(win);

        printf("si current_step==2 alors open scheduler ici : %d\n",current_step);

        script_file = g_string_new("script_file");
        plugin_file = g_string_new("plugin_file");
        mode = g_string_new("mode");
        visual_string = g_string_new("visual_string");
        is_modifying = 0;

        /*test du nom de fichier à donner*/

        dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/calendrier/")+strlen(name)+10);
        strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
        strcat(dir,name);
        strcat(dir,"/calendrier/");
        get_app_name(s_entry->str,app);
        strcat(dir,app);

        printf("dir %s\n",dir);

        save_file = g_string_new(dir);

        printf("name :%s\n",dir);

        fork_scheduler(script_file,plugin_file,mode,save_file,visual_string,is_modifying);

    }
}

int get_char_pos(char *string,char c)
{
    int i=0;

    while(string[i]!=c && string[i]!='\0')i++;
    if((string[i]=='\0'))i=-1;

    return i;
}

void load_file_item_and_spins(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *config = g_slist_nth_data(list,2);
    GSList *data = g_slist_nth_data(list,9);

    GString *s_plugin=NULL;

    GString *s_entry=NULL;
    GString *s_line=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *hbox=NULL;

    GString *s_h1=NULL;
    GString *s_m1=NULL;
    GString *s_s1=NULL;
    GString *s_h2=NULL;
    GString *s_m2=NULL;
    GString *s_s2=NULL;
    char value[3]={0};

    GSList *list_remove = NULL;

    int i = 1,eof=0;

    FILE *f = NULL;

    char *dir =  NULL;
    char *line = NULL,*line2 = NULL, *line3 = NULL;

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/")+2*strlen(name)+2);
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/");
    strcat(dir,"simple.s");

    fprintf(stderr,"dir : %s\n",dir);

    f = fopen(dir,"r");
    fprintf(stderr,"File %x open...\n",f);
    if(f!=NULL)eof=feof(f);
    fprintf(stderr,"Feof ok...\n");

    while((f!=NULL)&&(!eof))
    {
        fprintf(stderr,"Enter while()...\n");
        s_entry=NULL;

        line = malloc(500*sizeof(char));
        if(fgets(line, 500, f)==NULL)break;

        line2 = malloc(500*sizeof(char));
        if(fgets(line2, 500, f)==NULL)break;

        line3 = malloc(500*sizeof(char));
        if(fgets(line3, 500, f)==NULL)break;

        fprintf(stderr,"chaine lue : %s\n",line);
        fprintf(stderr,"chaine lue : %s\n",line2);
        fprintf(stderr,"chaine lue : %s\n",line3);

        if(get_char_pos(line,'\n')!=-1)line[get_char_pos(line,'\n')]='\0';

        value[0] = line2[0];
        value[1] = line2[1];
        value[2] = '\0';

        s_h1 = NULL;
        s_h1 = g_string_new(value);

        value[0] = line2[2];
        value[1] = line2[3];
        value[2] = '\0';

        s_m1 = NULL;
        s_m1 = g_string_new(value);

        value[0] = line2[4];
        value[1] = line2[5];
        value[2] = '\0';

        s_s1 = NULL;
        s_s1 = g_string_new(value);

        value[0] = line3[0];
        value[1] = line3[1];
        value[2] = '\0';

        s_h2 = NULL;
        s_h2 = g_string_new(value);

        value[0] = line3[2];
        value[1] = line3[3];
        value[2] = '\0';

        s_m2 = NULL;
        s_m2 = g_string_new(value);

        value[0] = line3[4];
        value[1] = line3[5];
        value[2] = '\0';

        s_s2 = NULL;
        s_s2 = g_string_new(value);

        s_entry = g_string_new(line);

        s_plugin = g_string_new(s_entry->str);
        g_string_append(s_plugin," : ");
        g_string_append(s_plugin,s_h1->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_m1->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_s1->str);
        g_string_append(s_plugin," - ");
        g_string_append(s_plugin,s_h2->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_m2->str);
        g_string_append(s_plugin,":");
        g_string_append(s_plugin,s_s2->str);

        label = NULL;
        remove = NULL;
        hbox = NULL;

        label = gtk_label_new(s_plugin->str);
        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);
        list_remove = NULL;

        g_slist_append(data,label);
        g_slist_append(data,s_entry);
        g_slist_append(data,s_h1);
        g_slist_append(data,s_m1);
        g_slist_append(data,s_s1);
        g_slist_append(data,s_h2);
        g_slist_append(data,s_m2);
        g_slist_append(data,s_s2);

        fprintf(stderr,"list_length (load) : %d\n",g_slist_length(data));

        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_item_and_spins, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);

        eof=feof(f);

        free(line);
    }

    if(f!=NULL)fclose(f);

}

void load_file_one_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *config = g_slist_nth_data(list,2);
    GSList *data = g_slist_nth_data(list,3);

    GString *s_plugin=NULL;

    GString *s_entry=NULL;
    GString *s_line=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    int i = 1,eof=0;

    FILE *f = NULL;

    char *dir =  NULL;
    char *line = NULL;

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/")+2*strlen(name)+2);
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/");
    strcat(dir,name);

    fprintf(stderr,"dir : %s\n",dir);

    f = fopen(dir,"r");
    if(f!=NULL)eof=feof(f);

    while((f!=NULL)&&(!eof))
    {
        s_entry=NULL;

        line = malloc(500*sizeof(char));
        if(fgets(line, 500, f)==NULL)break;

        fprintf(stderr,"chaine lue : %s\n",line);

        if(get_char_pos(line,'\n')!=-1)line[get_char_pos(line,'\n')]='\0';

        s_entry = g_string_new(line);

        s_plugin = g_string_new(s_entry->str);

        label = NULL;
        remove = NULL;
        hbox = NULL;

        label = gtk_label_new(s_plugin->str);
        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);
        list_remove = NULL;

        g_slist_append(data,label);
        g_slist_append(data,s_entry);

        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_one_item, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);

        eof=feof(f);

        free(line);
    }

    if(f!=NULL)fclose(f);

}

void load_file_calendar_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *config = g_slist_nth_data(list,2);
    GSList *data = g_slist_nth_data(list,3);

    GString *s_plugin=NULL;

    GString *s_entry=NULL;
    GString *s_line=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *modify=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    int i = 1,eof=0;

    FILE *f = NULL;

    char *dir =  NULL;
    char *line = NULL;

    dir = malloc(sizeof("/usr/share/schedio/plugin_ncy/restriction/tmp/config/")+strlen(name)+2+sizeof("/calendrier/calendrier.conf"));
    strcpy(dir,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(dir,name);
    strcat(dir,"/calendrier/calendrier.conf");

    fprintf(stderr,"dir : %s\n",dir);

    f = fopen(dir,"r");
    if(f!=NULL)eof=feof(f);

    while((f!=NULL)&&(!eof))
    {
        s_entry=NULL;

        line = malloc(500*sizeof(char));
        if(fgets(line, 500, f)==NULL)break;

        fprintf(stderr,"chaine lue : %s\n",line);

        if(get_char_pos(line,'\n')!=-1)line[get_char_pos(line,'\n')]='\0';

        s_entry = g_string_new(line);

        s_plugin = g_string_new(s_entry->str);

        label = NULL;
        remove = NULL;
        modify = NULL;
        hbox = NULL;

        label = gtk_label_new(s_plugin->str);
        modify = gtk_button_new_with_label(" Modifier ");
        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);
        list_remove = NULL;

        g_slist_append(data,label);
        g_slist_append(data,s_entry);

        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,modify);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(modify), "clicked", modify_calendar, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), modify, FALSE, FALSE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_calendar_item, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);

        eof=feof(f);

        free(line);
    }

    if(f!=NULL)fclose(f);

}

void configure()
{
    GtkWidget *win = NULL;
    GtkWidget *label = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GtkWidget *text = NULL;
    GtkWidget *combobox = NULL;

    GtkWidget *plugin_name = NULL;
    GtkWidget *config_file = NULL;

    GtkWidget *plugin_combo = NULL;
    GtkWidget *config_entry = NULL;

    GtkWidget *frame = NULL;
    GtkWidget *set = NULL;
    GtkWidget *vbox_plugins = NULL;
    GtkWidget *valid = NULL;
    GtkWidget *planning_hbox = NULL;
    GtkWidget *planning_label = NULL;
    GtkWidget *planning_remove = NULL;
    GtkWidget *parcourir = NULL;

    GtkWidget *h1 = NULL;
    GtkWidget *m1 = NULL;
    GtkWidget *s1 = NULL;
    GtkWidget *h2 = NULL;
    GtkWidget *m2 = NULL;
    GtkWidget *s2 = NULL;

    int i=0,j=0,eof=0;

    GSList *list = NULL;
    GSList *data = g_slist_alloc();

    fprintf(stderr,"Entering configure...\n");

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    gtk_window_set_title (GTK_WINDOW (win), "Editeur");
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
    gtk_window_set_default_size(GTK_WINDOW(win),300,100);

    gtk_widget_realize (win);
    g_signal_connect (win, "destroy", gtk_widget_destroy, NULL);

    vbox = gtk_vbox_new(FALSE,6);
    gtk_container_add (GTK_CONTAINER (win), vbox);

    frame = gtk_frame_new("Programmes gérés ");
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

    vbox_plugins = gtk_vbox_new(FALSE,6);
    gtk_container_add(frame,vbox_plugins);

    hbox = gtk_hbox_new(FALSE,6);
    gtk_container_add(GTK_CONTAINER(vbox),hbox);

    fprintf(stderr,"current_step : %d\n",current_step);

    if(current_step==0)
    {
        text = gtk_label_new("Programme :");
        gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

        config_entry = gtk_entry_new();
        gtk_box_pack_start(GTK_BOX(hbox),config_entry,FALSE,FALSE,0);

        parcourir = gtk_button_new_with_label("...");
        gtk_signal_connect_object(GTK_OBJECT(parcourir), "clicked", config_parcourir, config_entry);
        gtk_box_pack_start(GTK_BOX(hbox),parcourir,FALSE,FALSE,0);

        list = g_slist_append(list,(gpointer)win);
        g_slist_append(list,(gpointer)vbox_plugins);
        g_slist_append(list,(gpointer)config_entry);
        g_slist_append(list,(gpointer)data);

        set = gtk_button_new_with_label(" + ");
        gtk_signal_connect_object(GTK_OBJECT(set), "clicked", add_one_item, list);
        gtk_box_pack_start (GTK_BOX (hbox), set, FALSE, FALSE, 0);

        valid = gtk_button_new_with_label("Valider");
        gtk_signal_connect_object(GTK_OBJECT(valid), "clicked", save_one_item, list);
        gtk_box_pack_start (GTK_BOX (vbox), valid, FALSE, FALSE, 0);

        load_file_one_item(list);
    }

    if(current_step==1)
    {
        text = gtk_label_new("Programme :");
        gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

        config_entry = gtk_entry_new();
        gtk_box_pack_start(GTK_BOX(hbox),config_entry,FALSE,FALSE,0);

        parcourir = gtk_button_new_with_label("...");
        gtk_signal_connect_object(GTK_OBJECT(parcourir), "clicked", config_parcourir, config_entry);
        gtk_box_pack_start(GTK_BOX(hbox),parcourir,FALSE,FALSE,0);

        gtk_box_pack_start (GTK_BOX (hbox), gtk_label_new("Heure de départ :"), FALSE, FALSE, 0);
        h1 = gtk_spin_button_new_with_range      (0,23,1);
        gtk_box_pack_start(GTK_BOX(hbox),h1,FALSE,FALSE,0);
        m1 = gtk_spin_button_new_with_range      (0,59,1);
        gtk_box_pack_start(GTK_BOX(hbox),m1,FALSE,FALSE,0);
        s1 = gtk_spin_button_new_with_range      (0,59,1);
        gtk_box_pack_start(GTK_BOX(hbox),s1,FALSE,FALSE,0);
        gtk_box_pack_start (GTK_BOX (hbox), gtk_label_new("Heure de fin :"), FALSE, FALSE, 0);
        h2 = gtk_spin_button_new_with_range      (0,23,1);
        gtk_box_pack_start(GTK_BOX(hbox),h2,FALSE,FALSE,0);
        m2 = gtk_spin_button_new_with_range      (0,59,1);
        gtk_box_pack_start(GTK_BOX(hbox),m2,FALSE,FALSE,0);
        s2 = gtk_spin_button_new_with_range      (0,59,1);
        gtk_box_pack_start(GTK_BOX(hbox),s2,FALSE,FALSE,0);

        list = g_slist_append(list,(gpointer)win);
        g_slist_append(list,(gpointer)vbox_plugins);
        g_slist_append(list,(gpointer)config_entry);
        g_slist_append(list,(gpointer)h1);
        g_slist_append(list,(gpointer)m1);
        g_slist_append(list,(gpointer)s1);
        g_slist_append(list,(gpointer)h2);
        g_slist_append(list,(gpointer)m2);
        g_slist_append(list,(gpointer)s2);
        g_slist_append(list,(gpointer)data);

        set = gtk_button_new_with_label(" + ");
        gtk_signal_connect_object(GTK_OBJECT(set), "clicked", add_item_and_spins, list);
        gtk_box_pack_start (GTK_BOX (hbox), set, FALSE, FALSE, 0);

        valid = gtk_button_new_with_label("Valider");
        gtk_signal_connect_object(GTK_OBJECT(valid), "clicked", save_item_and_spins, list);
        gtk_box_pack_start (GTK_BOX (vbox), valid, FALSE, FALSE, 0);

        load_file_item_and_spins(list);
    }


    if((current_step==2))
    {
        text = gtk_label_new("Programme :");
        gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

        config_entry = gtk_entry_new();
        gtk_box_pack_start(GTK_BOX(hbox),config_entry,FALSE,FALSE,0);

        parcourir = gtk_button_new_with_label("...");
        gtk_signal_connect_object(GTK_OBJECT(parcourir), "clicked", config_parcourir, config_entry);
        gtk_box_pack_start(GTK_BOX(hbox),parcourir,FALSE,FALSE,0);

        list = g_slist_append(list,(gpointer)win);
        g_slist_append(list,(gpointer)vbox_plugins);
        g_slist_append(list,(gpointer)config_entry);
        g_slist_append(list,(gpointer)data);

        set = gtk_button_new_with_label(" + ");
        gtk_signal_connect_object(GTK_OBJECT(set), "clicked", add_calendar_item, list);
        gtk_box_pack_start (GTK_BOX (hbox), set, FALSE, FALSE, 0);

        valid = gtk_button_new_with_label("Valider");
        gtk_signal_connect_object(GTK_OBJECT(valid), "clicked", save_calendar_item, list);
        gtk_box_pack_start (GTK_BOX (vbox), valid, FALSE, FALSE, 0);

        load_file_calendar_item(list);
    }

    gtk_widget_show_all (win);
}

void step_one(GSList* list)
{
    GtkWidget *button = NULL;
    GtkWidget *win = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GString* profil = NULL;
    GString* win_name=NULL;
    GtkWidget* title=NULL;
    GtkWidget* label=NULL;
    GSList* list1=NULL;

    current_step=0;

    win=GTK_WIDGET(g_slist_nth_data(list,0));
    gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,1)));
    title=GTK_WIDGET(g_slist_nth_data(list,2));
    label=GTK_WIDGET(g_slist_nth_data(list,3));
    hbox=GTK_WIDGET(g_slist_nth_data(list,4));
    vbox=GTK_WIDGET(g_slist_nth_data(list,5));
    gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,6)));

    list1=g_slist_append(list1,(gpointer)win); // ADD TO GSLIST

    button = gtk_button_new_with_label ("Annuler");

    g_slist_append(list1,(gpointer)button);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)title);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)label);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)hbox);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)vbox);// ADD TO GSLIST

    g_signal_connect (button, "clicked", gtk_main_quit, NULL);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

    gtk_label_set_label(title, "<big><b>Étape 1 sur 3: Restrictions permanentes</b></big>");
    gtk_label_set_use_markup(title, TRUE);

    gtk_label_set_label(label,"Les logiciels que vous gérez via ce mode seront toujours interdits à cet utilisateur.\n\nExemple: /usr/bin/vlc interdira le programme vlc.\nIl est important de mettre le lien complet vers l'executable.");

    button = gtk_button_new_with_label("Étape suivante");
    g_slist_append(list1,(gpointer)button);// ADD TO GSLIST

    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(step_two),list1);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

    /* Enter the main loop */
    gtk_widget_show_all (win);
}

void step_two(GSList* list)
{
    GtkWidget *button = NULL;
    GtkWidget *win = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GString* profil = NULL;
    GString* win_name=NULL;
    GtkWidget* title=NULL;
    GtkWidget* label=NULL;
    GSList* list1=NULL;

    win=GTK_WIDGET(g_slist_nth_data(list,0));
    gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,1)));
    title=GTK_WIDGET(g_slist_nth_data(list,2));
    label=GTK_WIDGET(g_slist_nth_data(list,3));
    hbox=GTK_WIDGET(g_slist_nth_data(list,4));
    vbox=GTK_WIDGET(g_slist_nth_data(list,5));
    gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,6)));

    current_step=1;

    list1=g_slist_append(list1,(gpointer)win); // ADD TO GSLIST

    button = gtk_button_new_with_label ("Étape précédente");

    g_slist_append(list1,(gpointer)button);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)title);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)label);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)hbox);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)vbox);// ADD TO GSLIST

    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(step_one),list1);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

    gtk_label_set_label(title, "<big><b>Étape 2 sur 3: Restrictions temporelles</b></big>");
    gtk_label_set_use_markup(title, TRUE);

    gtk_label_set_label(label,"Vous pouvez appliquer une restriction temporelle simple, ne dépendant que de l'heure.\n\nExemple: /usr/bin/vlc interdira le programme vlc.\nIl est important de mettre le lien complet vers l'executable.");

    button = gtk_button_new_with_label("Étape suivante");
    g_slist_append(list1,(gpointer)button);// ADD TO GSLIST

    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(step_three),list1);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

    /* Enter the main loop */
    gtk_widget_show_all (win);
}

void step_three(GSList* list)
{
    GtkWidget *button = NULL;
    GtkWidget *win = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GString* profil = NULL;
    GString* win_name=NULL;
    GtkWidget* title=NULL;
    GtkWidget* label=NULL;
    GSList* list1=NULL;

    win=GTK_WIDGET(g_slist_nth_data(list,0));
    gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,1)));
    title=GTK_WIDGET(g_slist_nth_data(list,2));
    label=GTK_WIDGET(g_slist_nth_data(list,3));
    hbox=GTK_WIDGET(g_slist_nth_data(list,4));
    vbox=GTK_WIDGET(g_slist_nth_data(list,5));
    gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,6)));

    current_step=2;

    list1=g_slist_append(list1,(gpointer)win); // ADD TO GSLIST

    button = gtk_button_new_with_label ("Étape précédente");

    g_slist_append(list1,(gpointer)button);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)title);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)label);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)hbox);// ADD TO GSLIST
    g_slist_append(list1,(gpointer)vbox);// ADD TO GSLIST

    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(step_two),list1);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

    gtk_label_set_label(title, "<big><b>Étape 3 sur 3: Restrictions par calendrier</b></big>");
    gtk_label_set_use_markup(title, TRUE);

    gtk_label_set_label(label,"Vous pouvez établir un calendrier de restrictions pour chaque logiciel utilisé par ce profil.\n\nExemple: /usr/bin/vlc interdira le programme vlc.\nIl est important de mettre le lien complet vers l'executable.");

    button = gtk_button_new_with_label("Terminer");
    g_slist_append(list1,(gpointer)button);// ADD TO GSLIST

    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(finish),NULL);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

    /* Enter the main loop */
    gtk_widget_show_all (win);
}

void check_fcal()
{
    char cmd[1000];
    char filename[1000];
    FILE* f=NULL;
    FILE* f1=NULL;
    int nb=0,i,nb2,exist,j;
    char line[1000],line_base[1000];
    char line_tmp[1000];
    int k,l,comp;

    strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/tmp/lscheck");
    f=fopen(filename,"w+");
    fclose(f);

    strcpy(cmd,"ls /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(cmd,name);
    strcat(cmd,"/calendrier > /usr/share/schedio/plugin_ncy/restriction/tmp/lscheck");
    system(cmd);

    nb=get_nb_param(filename);
    printf("Nb lscheck:%d\n",nb);

    strcpy(cmd,"/usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(cmd,name);
    strcat(cmd,"/calendrier/calendrier.conf");

    i=0;
    f=fopen(filename,"r");
    while(i<nb)
    {
        fgets(line_base,1000,f);
        line_base[strlen(line_base)-1]='\0';
        nb2=0;
        f1=fopen(cmd,"r");
        if(f1!=NULL)
        {
            nb2=get_nb_param(cmd);
            j=0;
            while(j<nb2)
            {
                exist=0;
                fgets(line,1000,f1);
                k=0;
                l=0;
                while(line[k]!='\n')
                {
                    if(line[k]=='/') l=-1;
                    else line_tmp[l]=line[k];
                    l++;
                    k++;
                }
                line_tmp[l]='\0';
                if(strcmp(line_base,"calendrier.conf"))
                {
                    printf("%s vs %s\n",line_base,line_tmp);
                    comp=strcmp(line_base,line_tmp);
                    if(comp==0)
                    {
                        exist=0;
                        printf("Found at %d\n",j);
                        break;
                    }
                    else exist=1;
                }
                j++;
            }
        }
        else exist=1;

        // Traitement

        if(exist)
        {
            strcpy(cmd,"rm /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
            strcat(cmd,name);
            strcat(cmd,"/calendrier/");
            strcat(cmd,line_base);
            system(cmd);
        }

        i++;
    }
    fclose(f);

}

void finish()
{
    FILE* f=NULL;
    char cmd[1000];

    check_fcal();

    strcpy(cmd,"rm -r /usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(cmd,name);
    system(cmd);

    strcpy(cmd,"cp -r /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
    strcat(cmd,name);
    strcat(cmd," /usr/share/schedio/plugin_ncy/restriction/files/");
    system(cmd);

    strcpy(cmd,"/usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(cmd,name);
    strcat(cmd,"/on");
    f=fopen(cmd,"w+");
    fclose(f);

    gtk_main_quit();
}

void sup_restrictions()
{
    char cmd[1000];

    strcpy(cmd,"rm -r /usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(cmd,name);
    system(cmd);
}

void unactivate()
{
    char cmd[1000];

    strcpy(cmd,"rm /usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(cmd,name);
    strcat(cmd,"/on");
    system(cmd);
}

void activate(GSList* list)
{
    char cmd[1000];
    FILE* f=NULL;
    GtkWidget* button=NULL;
    GtkWidget* vbox=NULL;
    GtkWidget* label=NULL;
    GtkWidget* win=NULL;

    strcpy(cmd,"/usr/share/schedio/plugin_ncy/restriction/files/");
    strcat(cmd,name);
    strcat(cmd,"/on");
    f=fopen(cmd,"w+");
    if(f!=NULL)
    {
        fclose(f);
        gtk_main_quit();
    }
    else
    {
        win=GTK_WIDGET(g_slist_nth_data(list,0));
        gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,2)));
        gtk_widget_destroy(GTK_WIDGET(g_slist_nth_data(list,3)));
        vbox = gtk_vbox_new (FALSE, 6);
        gtk_container_add (GTK_CONTAINER (win), vbox);
        label=gtk_label_new("Erreur: le profil n'a pas encore été configuré.");
        gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
        button = gtk_button_new_with_label ("Fermer");
        g_signal_connect (button, "clicked", gtk_main_quit, NULL);
        gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 5);

        gtk_widget_show_all(win);
    }
}

void script_on()
{
    system("update-rc.d schedio.sh defaults");
}

void script_off()
{
    system("update-rc.d -f schedio.sh remove");
}
