// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "gtk/gtk.h"

void fct_licence()
{
    GtkWidget* window;
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* text;
    GtkWidget* text_view;
    GtkWidget* text_buffer;
    GtkTextIter iStart;
    GtkWidget* scroll;
    GtkWidget* close;
    GtkWidget* schedio_img2;

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (window),2);
    gtk_window_set_title (GTK_WINDOW (window), "Licence");
    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_signal_connect_object(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC(gtk_widget_destroy),window);
    gtk_window_set_icon(GTK_WINDOW(window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));

    schedio_img2 = gtk_image_new_from_file ("/usr/share/schedio/mini_schedio.png");

    vbox=gtk_vbox_new(FALSE,5);

    gtk_box_pack_start (GTK_BOX (vbox), schedio_img2, FALSE, FALSE, 0);

    scroll=gtk_scrolled_window_new(NULL,NULL);

    text_view=gtk_text_view_new();

    gtk_container_add(GTK_CONTAINER(scroll), text_view);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
            GTK_POLICY_NEVER,
            GTK_POLICY_AUTOMATIC);

    gtk_box_pack_start (GTK_BOX (vbox), scroll, TRUE, TRUE, 5);
    text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
    gtk_text_buffer_get_start_iter(text_buffer, &iStart);
    gtk_text_buffer_insert(text_buffer,&iStart,
            "Schedio est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier\n selon les termes de la Licence Publique Générale GNU,\n telle que publiée par la Free Software Foundation ;\n version 2 de la licence, ou (à votre discrétion) toute version ultérieure.\n\nSchedio est distribué dans l'espoir qu'il vous sera utile,\n mais SANS AUCUNE GARANTIE ; sans même la garantie implicite de\n VALEUR MARCHANDE ou D'ADÉQUATION À UN\n BESOIN PARTICULIER. Consultez la Licence\n Publique Générale GNU pour plus de détails.\n\nVous devez avoir reçu une copie de la Licence Publique Générale GNU\n en même temps que Schedio ; si ce n'est pas le cas, écrivez à la\n Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,\n Boston, MA 02110-1301 USA"
            ,762);
    gtk_text_view_set_editable(text_view,FALSE);
    gtk_text_view_set_cursor_visible(text_view,FALSE);

    close=gtk_button_new_with_label("Fermer");
    gtk_box_pack_start (GTK_BOX (vbox), close, FALSE, FALSE, 5);
    gtk_signal_connect_object(GTK_OBJECT(close),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),window);


    gtk_container_add(GTK_CONTAINER(window),vbox);
    gtk_window_resize(GTK_WINDOW(window),300,400);

    gtk_widget_show_all(window);
}


void about()
{
    // About
    GtkWidget* window;
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* hbox2;
    GtkWidget* label[4];
    GtkWidget* schedio_img;
    GtkWidget* gpl_img;
    GtkWidget* licence;
    GtkWidget* close;
    GSList* about_list_destroy=NULL;

    //About
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (window),2);
    gtk_window_set_title (GTK_WINDOW (window), "À propros de Schedio");
    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_window_set_icon(GTK_WINDOW(window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));

    schedio_img = gtk_image_new_from_file ("/usr/share/schedio/mini_schedio.png");
    vbox=gtk_vbox_new(FALSE,5);
    hbox=gtk_hbox_new(FALSE,5);

    gtk_box_pack_start (GTK_BOX (vbox), schedio_img, FALSE, FALSE, 0);

    label[0]=gtk_label_new("<b>Version 2.0</b>");
    gtk_label_set_use_markup(label[0], TRUE);
    gtk_box_pack_start (GTK_BOX (vbox), label[0], FALSE, FALSE, 5);

    label[1]=gtk_label_new("Schedio est un logiciel de gestion de scripts/plugins.");
    gtk_box_pack_start (GTK_BOX (vbox), label[1], FALSE, FALSE, 5);

    label[2]=gtk_label_new("Les scripts de base permettent de gérer ouverture/conflits de logiciels.");
    gtk_box_pack_start (GTK_BOX (vbox), label[2], FALSE, FALSE, 5);

    label[3]=gtk_label_new("Pour plus d'explications, se référer au pdf distribué avec Schedio.\n");
    gtk_box_pack_start (GTK_BOX (vbox), label[3], FALSE, FALSE, 5);

    gpl_img = gtk_image_new_from_file ("/usr/share/schedio/gpl.png");
    gtk_box_pack_start (GTK_BOX (hbox), gpl_img, FALSE, FALSE, 5);

    label[4]=gtk_label_new("\nCopyright © 2010 DELAYEN Julien, DELAYEN Florent");
    gtk_box_pack_start (GTK_BOX (hbox), label[4], FALSE, FALSE, 5);
    gtk_container_add (GTK_CONTAINER (vbox), hbox);

    hbox2=gtk_hbox_new(FALSE,20);

    licence = gtk_button_new_with_label("Licence");
    gtk_box_pack_start (GTK_BOX (hbox2), licence, TRUE, TRUE, 5);
    gtk_signal_connect_object(GTK_OBJECT(licence),"clicked",GTK_SIGNAL_FUNC(fct_licence),NULL);

    close = gtk_button_new_with_label("Fermer");
    gtk_box_pack_start (GTK_BOX (hbox2), close, TRUE, TRUE, 5);
    gtk_signal_connect_object(GTK_OBJECT(close),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),window);

    gtk_container_add (GTK_CONTAINER (vbox), hbox2);

    gtk_container_add (GTK_CONTAINER (window), vbox);

    gtk_widget_show_all(window);
}
