// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "schedio.h"
#include "plugin.h"
#include "file.h"
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <malloc.h>

void plugin_load(GSList* list)
{
    GtkWidget *combobox = g_slist_nth_data(list,0);
    GtkWidget *button_charger = g_slist_nth_data(list,1);
    GtkWidget *button_nouveau = g_slist_nth_data(list,2);
    GtkWidget *entry_charger = g_slist_nth_data(list,3);
    GtkWidget *entry_nouveau = g_slist_nth_data(list,4);
    GtkWidget *button_tmp = g_slist_nth_data(list,5);
    FILE* f=NULL;

    gint is_modifying = 0;

    GString *script_file = NULL;
    GString *plugin_file = NULL;
    GString *save_file = NULL;
    GString *visual_file=NULL;

    GString* dir=NULL;
    GString* visual_string=NULL;
    gint num=0;

    GString *mode;

    script_file = g_string_new("/usr/share/schedio/plugin/");
    g_string_append(script_file,gtk_combo_box_get_active_text (combobox));
    g_string_append(script_file,"/");
    g_string_append(script_file,gtk_combo_box_get_active_text (combobox));

    printf("%s\n",script_file->str);

    plugin_file = g_string_new("/usr/share/schedio/plugin/");
    g_string_append(plugin_file,gtk_combo_box_get_active_text (combobox));
    g_string_append(plugin_file,"/plugin.conf");

    printf("%s\n",plugin_file->str);

    if(gtk_toggle_button_get_active(button_charger))
    {
        mode = g_string_new("old");
        save_file = g_string_new(gtk_entry_get_text(entry_charger));
    }else{
        mode = g_string_new("new");
        if(gtk_toggle_button_get_active(button_nouveau)) save_file = g_string_new(gtk_entry_get_text(entry_nouveau));
        else
        {
            save_file=new_tmp_name();
            f=fopen(save_file->str,"w+");
            if(f!=NULL)fclose(f);
        }
    }
    if(g_slist_length(list)==6)
    {
        visual_string=new_visual_name();

        dir=g_string_new(pwd);
        g_string_append(dir,"/.schedio/liststore.tmp");
        add_line(dir->str,0,visual_string->str);
        free(g_string_free(dir,FALSE));

        f=fopen(visual_string->str,"w+");
        if(f!=NULL)fclose(f);
    }
    else
    {
        visual_string=g_string_new("none");
        is_modifying = 1;
    }
    printf("%s\n",visual_string->str);
    interface_load(script_file,plugin_file,mode,save_file,visual_string,is_modifying);
}

void plugin_ncy_load(GSList* list)
{
    GtkWidget *combobox = g_slist_nth_data(list,0);
    GtkWidget *button_charger = g_slist_nth_data(list,1);
    GtkWidget *button_nouveau = g_slist_nth_data(list,2);
    GtkWidget *entry_charger = g_slist_nth_data(list,3);
    GtkWidget *entry_nouveau = g_slist_nth_data(list,4);
    GtkWidget *button_tmp = g_slist_nth_data(list,5);
    FILE* f=NULL;

    gint is_modifying = 0;

    GString *script_file = NULL;
    GString *plugin_file = NULL;
    GString *save_file = NULL;
    GString* visual_string=NULL;

    gint num=0;

    GString *mode;

    script_file = g_string_new("/usr/share/schedio/plugin_ncy/");
    g_string_append(script_file,gtk_combo_box_get_active_text (combobox));
    g_string_append(script_file,"/");
    g_string_append(script_file,gtk_combo_box_get_active_text (combobox));

    plugin_file = g_string_new("/usr/share/schedio/plugin_ncy/");
    g_string_append(plugin_file,gtk_combo_box_get_active_text (combobox));
    g_string_append(plugin_file,"/plugin.conf");

    if(gtk_toggle_button_get_active(button_charger))
    {
        mode = g_string_new("old");
        save_file = g_string_new(gtk_entry_get_text(entry_charger));
    }else{
        mode = g_string_new("new");
        if(gtk_toggle_button_get_active(button_nouveau)) save_file = g_string_new(gtk_entry_get_text(entry_nouveau));
        else
        {
            save_file=new_tmp_name();
            f=fopen(save_file->str,"w+");
            if(f!=NULL)fclose(f);
        }
    }

    visual_string=new_visual_ncy_name();

    f=fopen(visual_string->str,"w+");
    if(f!=NULL)fclose(f);

    interface_load_ncy(script_file,plugin_file,mode,save_file,visual_string);
}

char* modifying_text(gint is_modifying)
{
    if(is_modifying)return "1";
    else return "0";
}

void interface_load(GString *script_file,GString *plugin_file,GString *mode,GString *save_file,GString* visual_string,gint is_modifying)
{
    pid_t child_pid;
    FILE* f=NULL;
    short end=0;
    char line[500];
    char extract[200];
    char extract_param[100];
    char name[200];
    char param[200];


    char *spawn[]={"Default_scheduler",plugin_file->str,save_file->str,mode->str,modifying_text(is_modifying),visual_string->str,script_file->str,NULL};
    char *spawn1[]={"Window_maker",plugin_file->str,save_file->str,mode->str,modifying_text(is_modifying),visual_string->str,script_file->str,NULL};

    printf("Plug-file:%s\n",plugin_file->str);
    f=fopen(plugin_file->str,"r");
    fgets(line,500,f);
    end=feof(f);

    fprintf(stderr,"spawn %s...\n",spawn[5]);
    fprintf(stderr,"spawn %s...\n",spawn[6]);

    strcpy(name,keep_name(line));
    strcpy(param,keep_param(line));
    strcpy(extract_param,param_extract(param,0));

    fprintf(stderr,"%s\n",extract_param);

    if((name[0]=='w' && name[1]=='i' && name[2]=='n' && name[3]=='d' && name[4]=='o' && name[5]=='w') && (g_string_equal(g_string_new(extract_param),g_string_new("name:default_scheduler"))))
    {
        fclose(f);
        child_pid = fork ();

        if (child_pid == 0)
        {
        execvp ("/usr/share/schedio/Default_scheduler",spawn);

        fprintf (stderr, "an error occurred in execvp\n");
        abort ();
        }
    }
    if((name[0]=='w' && name[1]=='i' && name[2]=='n' && name[3]=='d' && name[4]=='o' && name[5]=='w') && (!g_string_equal(g_string_new(extract_param),g_string_new("name:default_scheduler"))))
    {
        fclose(f);
        child_pid = fork ();

        if (child_pid == 0)
        {
        execvp ("/usr/share/schedio/window_maker",spawn1);

        fprintf (stderr, "an error occurred in execvp\n");
        abort ();
        }
    }
}

void interface_load_ncy(GString *script_file,GString *plugin_file,GString *mode,GString *save_file,GString* visual_file)
{
    pid_t child_pid;
    FILE* f=NULL;
    short end=0;
    char line[500];
    char extract[200];
    char extract_param[100];
    char name[200];
    char param[200];


    char *spawn[]={"Default_scheduler",plugin_file->str,save_file->str,mode->str,modifying_text(0),script_file->str,visual_file->str,NULL};
    char *spawn1[]={"Window_maker_ncy",plugin_file->str,save_file->str,mode->str,script_file->str,visual_file->str,NULL};

    f=fopen(plugin_file->str,"r");
    fgets(line,500,f);
    end=feof(f);

    fprintf(stderr,"spawn %s...\n",spawn[1]);
    fprintf(stderr,"spawn %s...\n",spawn[2]);
    fprintf(stderr,"spawn %s...\n",spawn[3]);
    fprintf(stderr,"spawn %s...\n",spawn[4]);
    fprintf(stderr,"spawn %s...\n",spawn[5]);

    strcpy(name,keep_name(line));
    strcpy(param,keep_param(line));
    strcpy(extract_param,param_extract(param,0));

    fprintf(stderr,"%s\n",extract_param);


    if((name[0]=='w' && name[1]=='i' && name[2]=='n' && name[3]=='d' && name[4]=='o' && name[5]=='w') && (g_string_equal(g_string_new(extract_param),g_string_new("name:default_scheduler"))))
    {
        fclose(f);
        child_pid = fork ();

        if (child_pid == 0)
        {
        execvp ("/usr/share/schedio/Default_scheduler",spawn);

        fprintf (stderr, "an error occurred in execvp\n");
        abort ();
        }
    }
    if((name[0]=='w' && name[1]=='i' && name[2]=='n' && name[3]=='d' && name[4]=='o' && name[5]=='w') && (!g_string_equal(g_string_new(extract_param),g_string_new("name:default_scheduler"))))
    {
        fclose(f);
        child_pid = fork ();

        if (child_pid == 0)
        {
        execvp ("/usr/share/schedio/window_maker_ncy",spawn1);

        fprintf (stderr, "an error occurred in execvp\n");
        abort ();
        }
    }
}

char* keep_name(char* line)
{
    int i=0;
    int j=0;
    char name[200];
    while((line[i]!='<') && (line[i]!='\n')) i++;
    if(line[i]!='\n')
    {
        i++;
        while(line[i]==' ')i++;
        while(line[i]!='>' && line[i]!=' ')
        {
            name[j]=line[i];
            i++;
            j++;
        }
        name[j]='\0';
    }
    else{
        name[0]='n';
        name[1]='o';
        name[2]='\0';
    }
    usleep(500);
    return name;
}

char* keep_param(char* line)
{
    int i=0;
    int j=0;
    char param[200];
    while((line[i]!='<') && (line[i]!='\n')) i++;
    if(line[i]!='\n')
    {
        i++;
        while(line[i]==' ')i++;
        while(line[i]!=' ' && line[i]!='>') i++;
        while(line[i]==' ')i++;
        if(line[i]!='>')
        {
            while(line[i]!='>' && line[i]!=' ')
            {
                param[j]=line[i];
                i++;
                j++;
            }
            param[j]='\0';
        }
        else
        {
            param[0]='n';
            param[1]='o';
            param[2]='\0';
        }
    }
    else{
        param[0]='n';
        param[1]='o';
        param[2]='\0';
    }
    usleep(500);
    return param;
}

char* param_extract(char* param,int num)
{
    int i=7,j=0;
    int count=0;
    char extract[100];
    int end=0;

    while(count<num && !end)
    {
        if(param[i]=='"' || param[i]=='\'') end=1;
        if(param[i]==';')
        {
            count++;
            if(param[i+1]=='"' || param[i+1]=='\'')
            {
                end=1;
            }
        }
        i++;
    }
    if(!end)
    {
        while(param[i]!='"' && param[i]!='\'' && param[i]!=';')
        {
            extract[j]=param[i];
            i++;
            j++;
        }
        extract[j]='\0';
    }
    else
    {
        extract[0]='n';
        extract[1]='o';
        extract[2]='\0';
    }
    usleep(500);
    return extract;
}
