// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SCHEDIO_H
#define SCHEDIO_H
#include <gtk/gtk.h>
#include <libappindicator-0.1/libappindicator/app-indicator.h>

char *pwd;

int schedio_visible;
int nb_liststore_line;

int Schedio_init(void);
void del(gpointer data);
static void togglestate(GtkAction* action,gpointer window);
void del_to_quit();
void clear(GtkListStore* liststore);
int schedio_startup(GtkListStore *liststore,GtkTreeIter *treeiter);
void schedio_destroy();
void List_Clicked(GtkTreeView *tree_view, GtkTreePath *path1, GtkTreeViewColumn *column, gpointer data);
void show_startup_configurator(GtkButton *button, gpointer user_data);

GdkPixbuf *create_pixbuf(const gchar * filename);

enum {
  COLUMN_PLUGIN,
  COLUMN_SAVE,
  N_COLUMNS
};

GSList *gslist_del;//liste utilisée pour le signal clicked de la liststore appelant del()

struct schedio_button{
    GtkWidget *add;
    GtkWidget *quit;
    GtkWidget *del;
    GtkWidget *clear;
    GtkWidget *about;
    GtkWidget *visualize;
    GtkWidget *startup;
    GtkWidget *non_cly;
    GtkWidget *modify;
    GtkWidget *visu_ncy;
    GSList *gslist_add;
    int state_add;
    int state_about;
};

struct schedio_list{
    GtkTreeView *treeview;
    GtkTreeIter treeiter;
    GtkCellRenderer *renderer;
    GtkTreeViewColumn *column;
    GtkListStore *liststore;
    GtkScrolledWindow* scroll;
};

struct schedio_container{
    GtkWidget *vbox1;
    GtkWidget *vbox2;
    GtkWidget *hbox;

    GtkWidget* group_cy;
    GtkWidget* hbox_cy;

    GtkWidget* group_ncy;
    GtkWidget* hbox_ncy;
};

struct schedio{
    GtkWidget *window;
    struct schedio_button button;
    struct schedio_list list;
    struct schedio_container container;
};


#endif
