// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <glib.h>
#include <malloc.h>
#include <unistd.h>
#include <time.h>

char* pwd;

int spawn (char* name)
{
    pid_t child_pid;

    /* Duplicate this process. */
    child_pid = fork ();

    if (child_pid != 0)
    {
        /* This is the parent process. */
        return child_pid;
    }
    else {
    /* Now execute PROGRAM, searching for it in the path. */
    system(name);
    /* The execvp function returns only if an error occurs. */
    fprintf (stderr, "Program is close, or an error occurred in execvp\n");
    abort ();
    }
}

int get_number_row(char* path)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;

    f=fopen(path,"r");
    fgets(line,1000,f);
    eof= feof(f);

    while(eof!=1)
    {
        i++;
        fgets(line,1000,f);
        eof= feof(f);
    }
    fclose(f);

    return i;
}

int get_param(char* file,int nb,char** param)
{
    int i=0,j=0;
    char test[1000];
    FILE* f=NULL;
    f=fopen(file,"r");
    if(f!=NULL)
    {
        fgets(test,1000,f);
        while(i<nb)
        {
            if(test[0]!='#' && test[0]!='[')
            {
                while(test[j]!='\n' && test[j]!='#')
                {
                    param[i][j]=test[j];
                    j++;
                }
                param[i][j]='\0';
                i++;
                j=0;
            }
            fgets(test,1000,f);
        }
        fclose(f);
    }
    usleep(500);
    return 0;
}

int main(int argc, char *argv[])
{
    FILE* f_visual=NULL;
    FILE* f_save=NULL;
    int nb_row=0;

    char** args=NULL;
    int i=0;
    int launch_check=0;
    int max_launch=0;
    int nb_launch=0;
    int close=0;
    int mode=0;
    int launch_now;

    long int nb_verifs=0;

    int hours=0,min=0,sec=0;
    int time_to_wait=0;
    int current_wait=0;

    time_t timestamp;
    char buffer[256];

    char path[1000];

    FILE* f_temp=NULL;

    /** INIT **/

    pwd = getenv ("HOME");

    /** FIRST TEST **/

    printf("ARGC=%d\n",argc);
    if(argc==3)
    {
        f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Actif\n");
        fprintf(f_visual,"Nombre de lancement:--/--\n");
        fprintf(f_visual,"Dernière vérification:-- -- --\n");
        fprintf(f_visual,"Période de vérification actuelle:---");

        fclose(f_visual);
        strcpy(path,argv[2]);
    }

    nb_row=get_number_row(path);
    printf("Nb_row:%d\n",nb_row);

    /** MAIN LOOP **/

    if(nb_row==8 && argc==3)
    {
        printf("Loop begin\n");

        /** Init **/
        timestamp = time(NULL);
        strftime(buffer, sizeof(buffer), "%d/%m/%y - %X", localtime(&timestamp));

        args=malloc(sizeof(char*)*8);
        i=0;
        while(i<8)
        {
            args[i]=malloc(1000*sizeof(char));
            i++;
        }

        get_param(path,7,args);

        printf("%s\n",args[0]);
        printf("%s\n",args[1]);
        printf("%s\n",args[2]);
        printf("%s\n",args[3]);
        printf("%s\n",args[4]);
        printf("%s\n",args[5]);

        sscanf(args[1],"%d",&hours);
        sscanf(args[2],"%d",&min);
        sscanf(args[3],"%d",&sec);
        sscanf(args[4],"%d",&max_launch);
        sscanf(args[5],"%d",&launch_check);
        sscanf(args[6],"%d",&launch_now);

        time_to_wait=hours*3600+min*60+sec;
        printf("Time to wait: %ds\n",time_to_wait);

        if(launch_now==1)
        {
            spawn(args[0]);
            nb_launch++;
        }

        if(launch_check==1 && nb_launch>=max_launch)
        {
            close=1;
        }

        while(!close)
        {
            /** FILE VERIF **/

            nb_row=get_number_row(path);

            get_param(path,6,args);

            sscanf(args[1],"%d",&hours);
            sscanf(args[2],"%d",&min);
            sscanf(args[3],"%d",&sec);
            sscanf(args[4],"%d",&max_launch);
            sscanf(args[5],"%d",&launch_check);

            time_to_wait=hours*3600+min*60+sec;


            /** VISUALISATION **/

            timestamp = time(NULL);

            strftime(buffer, sizeof(buffer), "%d/%m/%y - %X", localtime(&timestamp));

            f_visual=fopen(argv[1],"w+");

            fprintf(f_visual,"État:Actif\n");
            if(args[5][0]=='0')fprintf(f_visual,"Nombre de lancement:%d\n",nb_launch);
            else fprintf(f_visual,"Nombre de lancement:%d/%d\n",nb_launch,max_launch);
            fprintf(f_visual,"Dernière vérification:%s\n",buffer);
            if(mode==0)fprintf(f_visual,"Période de vérification actuelle:Encore inconnue...");
            else fprintf(f_visual,"Période de vérification actuelle:%ds",mode);

            fclose(f_visual);

            /** core **/

            if(nb_row==8)
            {
                if((time_to_wait-current_wait)<30)
                {
                    mode=1;
                    sleep(1);
                    current_wait++;
                }
                else if((time_to_wait-current_wait)<60)
                {
                    mode=10;
                    sleep(10);
                    current_wait+=10;
                }
                else if((time_to_wait-current_wait)<600)
                {
                    mode=30;
                    sleep(30);
                    current_wait+=30;
                }
                else if((time_to_wait-current_wait)<1800)
                {
                    mode=60;
                    sleep(60);
                    current_wait+=60;
                }
                else if((time_to_wait-current_wait)<3600)
                {
                    mode=120;
                    sleep(120);
                    current_wait+=120;
                }

                if((time_to_wait-current_wait)<=0)
                {
                    spawn(args[0]);
                    nb_launch++;
                    current_wait=0;
                    mode=0;
                }

                if(launch_check && nb_launch>=max_launch)
                {
                    close=1;
                }
            }
            else
            {
                break;
            }
        }

        f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Terminé\n");
        if(args[5][0]=='0')fprintf(f_visual,"Nombre de lancement:%d\n",nb_launch);
        else fprintf(f_visual,"Nombre de lancement:%d\n",nb_launch);
        fprintf(f_visual,"Dernière vérification:%s\n",buffer);
        fprintf(f_visual,"Période de vérification actuelle:Aucune");

        fclose(f_visual);

        i=0;
        while(i<7)
        {
            free(args[i]);
            i++;
        }
        free(args);
    }
    return 0;
}
