// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "plugin.h"
#include "export.h"
#include "file.h"
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <malloc.h>

GdkPixbuf *create_pixbuf(const gchar * filename)
{
   GdkPixbuf *pixbuf;
   GError *error = NULL;
   pixbuf = gdk_pixbuf_new_from_file(filename, &error);
   if(!pixbuf) {
      fprintf(stderr, "%s\n", error->message);
      g_error_free(error);
   }

   return pixbuf;
}

int interface_launch(char *plugin_file,char *save_file,char *mode,char *script_file,char* visual_file)
{
    printf("%s\n%s\n%s\n%s\n%s\n",plugin_file,save_file,mode,script_file,visual_file);
    GString *script_file1;
    GString *plugin_file1;
    GString *mode1;
    GString *save_file1;
    GString *visual_file1;

    script_file1=g_string_new(script_file);
    plugin_file1=g_string_new(plugin_file);
    mode1=g_string_new(mode);
    save_file1=g_string_new(save_file);
    visual_file1=g_string_new(visual_file);

    interface_load(script_file1,plugin_file1,mode1,save_file1,visual_file1);
}

void interface_load(GString *script_file,GString *plugin_file,GString *mode,GString *save_file,GString* visual_file)
{
    pid_t child_pid;
    FILE* f=NULL;
    short end=0;
    char line[500];
    char extract[200];
    char extract_param[100];
    char extract_temp[100];
    char name[200];
    char param[200];
    int widget=0;
    int with_label=0;
    int first_is_item=0;
    int radio_reference=0;
    int toggle_cpt=0;
    int window_declared=0;
    int count=0,i=0,j=0,k=0;
    int temp=0,temp1=0,temp2=0;

    int nb_entry=0,num_entry=0;
    int nb_spin=0,num_spin=0;
    int nb_check=0,num_check=0;
    int nb_combo=0,num_combo=0;
    int nb_scale=0,num_scale=0;
    int nb_radio=0,num_radio=0;
    int nb_toggle=0,num_toggle=0;
    int nb_box_toggle=0;

    int nb_param_load=0;
    char* name_load;
    char** param_load;
    int num_param_load=0;
    int buffer_load;

    char file[1000];
    GSList* list=NULL;
    type=NULL;
    nb_type=0;
    GString *comp=g_string_new("new");

    strcpy(file,plugin_file->str);

    if(!widget_count(file,&nb_entry,&nb_spin,&nb_check,&nb_combo,&nb_scale,&nb_radio,&nb_toggle,&nb_box_toggle))
    {
        if(nb_entry>0) plugin.entry=g_malloc(sizeof(GtkWidget*)*nb_entry);
        if(nb_spin>0) plugin.spin=g_malloc(sizeof(GtkWidget*)*nb_spin);
        if(nb_check>0) plugin.check=g_malloc(sizeof(GtkWidget*)*nb_check);
        if(nb_combo>0) plugin.combo=g_malloc(sizeof(GtkWidget*)*nb_combo);
        if(nb_scale>0) plugin.scale=g_malloc(sizeof(GtkWidget*)*nb_scale);
        if(nb_radio>0) plugin.radio=g_malloc(sizeof(GtkWidget*)*nb_radio);
        if(nb_toggle>0) plugin.toggle=g_malloc(sizeof(GtkWidget*)*nb_toggle);

        widget=1+nb_entry+nb_spin+nb_check+nb_combo+nb_scale+nb_radio+nb_toggle;
        if(widget>1) type=g_malloc(sizeof(int)*(widget+4));
        nb_type=0;

        f=fopen(file,"r");
        fgets(line,500,f);
        end=feof(f);

        while(end!=1)
        {
            strcpy(name,keep_name(line));
            strcpy(param,keep_param(line));
            strcpy(extract_param,param_extract(param,0));

            if((name[0]=='w' && name[1]=='i' && name[2]=='n' && name[3]=='d' && name[4]=='o' && name[5]=='w') && (!g_string_equal(g_string_new(extract_param),g_string_new("name:default_scheduler"))))
            {
                plugin.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
                gtk_container_set_border_width (GTK_CONTAINER (plugin.window),2);
                gtk_window_set_title (GTK_WINDOW (plugin.window), "Plugin");
                gtk_window_set_position (GTK_WINDOW (plugin.window), GTK_WIN_POS_NONE);
                gtk_window_set_icon(GTK_WINDOW(plugin.window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
                gtk_window_resize(GTK_WINDOW(plugin.window),300,200);
                g_signal_connect (plugin.window, "destroy", gtk_main_quit, NULL);

                plugin.container.VBox=gtk_vbox_new(FALSE,10);
                plugin.container.scroll = gtk_scrolled_window_new(NULL, NULL);
                gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(plugin.container.scroll),GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

                gtk_container_add(plugin.window,plugin.container.scroll);
                gtk_scrolled_window_add_with_viewport(plugin.container.scroll,plugin.container.VBox);

                list=g_slist_append (list, (gpointer) plugin.window);
                type[nb_type]=0;
                nb_type++;

                strcpy(param,keep_param(line));
                if(param[0]=='p' && param[1]=='a' && param[2]=='r' && param[3]=='a' && param[4]=='m' && param[5]=='=')
                {
                    count=param_count(param);
                    if(count>0)
                    {
                        while(i<count)
                        {
                            strcpy(extract_param,param_extract(param,i));
                            //traitement
                            if(extract_param[0]=='h' && extract_param[1]=='e' && extract_param[2]=='i' && extract_param[3]=='g' && extract_param[4]=='h' && extract_param[5]=='t' && extract_param[6]==':')
                            {
                                j=7;
                                k=0;
                                while(extract_param[j]!='\0')
                                {
                                    extract_temp[k]=extract_param[j];
                                    j++;
                                    k++;
                                }
                                extract_temp[k]='\0';
                                gtk_window_get_size(plugin.window, &temp, &temp1);
                                sscanf(extract_temp,"%d",&temp1);
                                gtk_window_resize(GTK_WINDOW(plugin.window),temp,temp1);
                            }
                            if(extract_param[0]=='w' && extract_param[1]=='i' && extract_param[2]=='d' && extract_param[3]=='t' && extract_param[4]=='h' && extract_param[5]==':')
                            {
                                j=6;
                                k=0;
                                while(extract_param[j]!='\0')
                                {
                                    extract_temp[k]=extract_param[j];
                                    j++;
                                    k++;
                                }
                                extract_temp[k]='\0';
                                gtk_window_get_size(plugin.window, &temp, &temp1);
                                sscanf(extract_temp,"%d",&temp);
                                gtk_window_resize(GTK_WINDOW(plugin.window),temp,temp1);
                            }
                            i++;
                        }
                    }
                }
                count=0;
                i=0;
                j=0;
                k=0;
                window_declared=1;
                if(!g_string_equal(mode,comp))
                {
                    if(fopen(save_file->str,"r")!=NULL)
                    {
                        nb_param_load=get_nb_param(save_file->str);

                        param_load=(char**)malloc(sizeof(char*)*nb_param_load);
                        while(i<nb_param_load)
                        {
                            param_load[i]=(char*)malloc(sizeof(char)*1000);
                            i++;
                        }

                        i=0;
                        get_param(save_file->str,nb_param_load,param_load);
                    }
                }
                g_free(g_string_free(comp,FALSE));
                g_free(g_string_free(mode,FALSE));
            }
            if(window_declared)
            {
                if(name[0]=='n' && name[1]=='a' && name[2]=='m' && name[3]=='e')
                {
                    strcpy(extract,simple_extract(line));
                    gtk_window_set_title (GTK_WINDOW (plugin.window), extract);
                }
                else if(name[0]=='l' && name[1]=='a' && name[2]=='b' && name[3]=='e' && name[4]=='l')
                {
                    strcpy(extract,simple_extract(line));

                    plugin.label=gtk_label_new(extract);

                    plugin.container.hbox=gtk_hbox_new(TRUE,10);

                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.label, TRUE, TRUE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.container.hbox, FALSE, FALSE, 0);

                }
                else if(name[0]=='e' && name[1]=='n' && name[2]=='t' && name[3]=='r' && name[4]=='y')
                {
                    strcpy(extract,simple_extract(line));

                    plugin.entry[num_entry]=g_malloc(sizeof(GtkWidget*));
                    plugin.entry[num_entry]=gtk_entry_new();

                    if(num_param_load<nb_param_load)
                    {
                        gtk_entry_set_text(plugin.entry[num_entry],param_load[num_param_load]);
                        num_param_load++;
                    }

                    plugin.container.hbox=gtk_hbox_new(TRUE,10);

                    plugin.widget_label=gtk_label_new(extract);

                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.widget_label, FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.entry[num_entry], TRUE, TRUE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.container.hbox, FALSE, FALSE, 0);

                    strcpy(param,keep_param(line));
                    if(param[0]=='p' && param[1]=='a' && param[2]=='r' && param[3]=='a' && param[4]=='m' && param[5]=='=')
                    {
                        i=0;
                        count=param_count(param);
                        if(count>0)
                        {
                            while(i<count)
                            {
                                strcpy(extract_param,param_extract(param,i));
                                if(extract_param[0]=='t' && extract_param[1]=='y' && extract_param[2]=='p' && extract_param[3]=='e')
                                {
                                    if(extract_param[5]=='p' && extract_param[6]=='a' && extract_param[7]=='s' && extract_param[8]=='s' && extract_param[9]=='w' && extract_param[10]=='o' && extract_param[11]=='r' && extract_param[12]=='d') gtk_entry_set_visibility(plugin.entry[num_entry], FALSE);
                                    if(extract_param[5]=='t' && extract_param[6]=='e' && extract_param[7]=='x' && extract_param[8]=='t' && extract_param[9]=='e') gtk_entry_set_visibility(plugin.entry[num_entry], TRUE);
                                }
                                else if(extract_param[0]=='l' && extract_param[1]=='e' && extract_param[2]=='n' && extract_param[3]=='g'  && extract_param[4]=='t' && extract_param[5]=='h')
                                {
                                    j=7;
                                    k=0;
                                    temp=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp);
                                    gtk_entry_set_max_length(plugin.entry[num_entry], temp);
                                }
                                i++;
                            }
                        }
                    }
                    type[nb_type]=3;
                    nb_type++;

                    num_entry++;
                }
                else if(name[0]=='s' && name[1]=='p' && name[2]=='i' && name[3]=='n')
                {
                    strcpy(extract,simple_extract(line));
                    i=0;
                    temp=0;
                    temp1=100;
                    temp2=1;
                    strcpy(param,keep_param(line));
                    if(param[0]=='p' && param[1]=='a' && param[2]=='r' && param[3]=='a' && param[4]=='m' && param[5]=='=')
                    {
                        count=param_count(param);
                        if(count>0)
                        {
                            while(i<count)
                            {
                                strcpy(extract_param,param_extract(param,i));
                                if(extract_param[0]=='m' && extract_param[1]=='i' && extract_param[2]=='n')
                                {
                                    j=4;
                                    k=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp);
                                }
                                else if(extract_param[0]=='m' && extract_param[1]=='a' && extract_param[2]=='x')
                                {
                                    j=4;
                                    k=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp1);
                                }
                                else if(extract_param[0]=='s' && extract_param[1]=='t' && extract_param[2]=='e' && extract_param[3]=='p')
                                {
                                    j=5;
                                    k=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp2);
                                }
                                i++;
                            }
                        }
                    }
                    plugin.spin[num_spin]=g_malloc(sizeof(GtkWidget*));
                    plugin.spin[num_spin]=gtk_spin_button_new_with_range (temp, temp1, temp2);

                    if(num_param_load<nb_param_load)
                    {
                        sscanf(param_load[num_param_load],"%d",&buffer_load);
                        gtk_spin_button_set_value(plugin.spin[num_spin],buffer_load);
                        num_param_load++;
                    }

                    plugin.container.hbox=gtk_hbox_new(TRUE,10);

                    plugin.widget_label=gtk_label_new(extract);

                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.widget_label, FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.spin[num_spin], TRUE, TRUE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.container.hbox, FALSE, FALSE, 0);

                    type[nb_type]=4;
                    nb_type++;

                    num_spin++;
                }
                else if(name[0]=='c' && name[1]=='h' && name[2]=='e' && name[3]=='c' && name[4]=='k')
                {
                    strcpy(extract,simple_extract(line));
                    plugin.check[num_check]=g_malloc(sizeof(GtkWidget*));
                    plugin.check[num_check]=gtk_check_button_new_with_label(extract);
                    gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.check[num_check], FALSE, FALSE, 0);
                    strcpy(param,keep_param(line));
                    if(param[0]=='p' && param[1]=='a' && param[2]=='r' && param[3]=='a' && param[4]=='m' && param[5]=='=')
                    {
                        count=param_count(param);
                        if(count>0)
                        {
                            strcpy(extract_param,param_extract(param,0));
                            if(extract_param[0]=='c' && extract_param[1]=='h' && extract_param[2]=='e' && extract_param[3]=='c' && extract_param[4]=='k' && extract_param[5]=='e' && extract_param[6]=='d')
                            {
                                if(extract_param[8]=='t' && extract_param[9]=='r' && extract_param[10]=='u' && extract_param[11]=='e') gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plugin.check[num_check]),TRUE);
                                if(extract_param[8]=='f' && extract_param[9]=='a' && extract_param[10]=='l' && extract_param[11]=='s' && extract_param[12]=='e') gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plugin.check[num_check]),FALSE);
                            }
                        }
                    }
                    if(num_param_load<nb_param_load)
                    {
                        if(param_load[num_param_load][0]=='1' && param_load[num_param_load][1]=='\0') gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plugin.check[num_check]),TRUE);
                        else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plugin.check[num_check]),FALSE);
                        num_param_load++;
                    }
                    type[nb_type]=5;
                    nb_type++;
                    num_check++;
                }
                else if(name[0]=='c' && name[1]=='o' && name[2]=='m' && name[3]=='b'  && name[4]=='o')
                {
                    fgets(line,500,f);
                    strcpy(name,keep_name(line));
                    plugin.combo[num_combo]=g_malloc(sizeof(GtkWidget*));
                    plugin.combo[num_combo]=gtk_combo_box_new_text();
                    while(!(name[0]=='/' && name[1]=='c' && name[2]=='o' && name[3]=='m' && name[4]=='b'  && name[5]=='o'))
                    {
                        if(name[0]=='l' && name[1]=='a' && name[2]=='b' && name[3]=='e' && name[4]=='l' && first_is_item==0)
                        {
                            strcpy(extract,simple_extract(line));
                            plugin.container.hbox=gtk_hbox_new(TRUE,10);

                            plugin.widget_label=gtk_label_new(extract);

                            gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.widget_label, FALSE, FALSE, 0);

                            with_label=1;
                        }
                        else if(name[0]=='i' && name[1]=='t' && name[2]=='e' && name[3]=='m')
                        {
                            first_is_item=1;
                            strcpy(extract,simple_extract(line));
                            gtk_combo_box_append_text(GTK_COMBO_BOX(plugin.combo[num_combo]),extract);
                        }
                        fgets(line,500,f);
                        strcpy(name,keep_name(line));
                    }
                    if(with_label==1)
                            {
                                gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.combo[num_combo], TRUE, TRUE, 0);
                                gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.container.hbox, FALSE, FALSE, 0);
                            }
                    else gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.combo[num_combo], FALSE, FALSE, 0);
                    gtk_combo_box_set_active(plugin.combo[num_combo],0);

                    if(num_param_load<nb_param_load)
                    {
                        sscanf(param_load[num_param_load],"%d",&buffer_load);
                        gtk_combo_box_set_active(plugin.combo[num_combo],buffer_load);
                        num_param_load++;
                    }

                    num_combo++;
                    with_label=0;
                    first_is_item=0;
                    type[nb_type]=6;
                    nb_type++;
                }
                else if(name[0]=='s' && name[1]=='c' && name[2]=='a' && name[3]=='l' && name[4]=='e')
                {
                    strcpy(extract,simple_extract(line));
                    i=0;
                    temp=0;
                    temp1=0;
                    temp2=0;
                    strcpy(param,keep_param(line));
                    if(param[0]=='p' && param[1]=='a' && param[2]=='r' && param[3]=='a' && param[4]=='m' && param[5]=='=')
                    {
                        count=param_count(param);
                        if(count>0)
                        {
                            while(i<count)
                            {
                                strcpy(extract_param,param_extract(param,i));
                                if(extract_param[0]=='m' && extract_param[1]=='i' && extract_param[2]=='n')
                                {
                                    j=4;
                                    k=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp);
                                }
                                else if(extract_param[0]=='m' && extract_param[1]=='a' && extract_param[2]=='x')
                                {
                                    j=4;
                                    k=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp1);
                                }
                                else if(extract_param[0]=='s' && extract_param[1]=='t' && extract_param[2]=='e' && extract_param[3]=='p')
                                {
                                    j=5;
                                    k=0;
                                    while(extract_param[j]!='\0')
                                    {
                                        extract_temp[k]=extract_param[j];
                                        j++;
                                        k++;
                                    }
                                    extract_temp[k]='\0';
                                    sscanf(extract_temp,"%d",&temp2);
                                }
                                i++;
                            }
                        }
                    }

                    plugin.scale[num_scale]=g_malloc(sizeof(GtkWidget*));
                    plugin.scale[num_scale]=gtk_hscale_new_with_range (temp,temp1,temp2);

                    if(num_param_load<nb_param_load)
                    {
                        sscanf(param_load[num_param_load],"%d",&buffer_load);
                        gtk_range_set_value(plugin.scale[num_scale],buffer_load);
                        num_param_load++;
                    }

                    plugin.container.hbox=gtk_hbox_new(TRUE,10);

                    plugin.widget_label=gtk_label_new(extract);

                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.widget_label, FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.scale[num_scale], TRUE, TRUE, 0);
                    gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.container.hbox, FALSE, FALSE, 0);

                    type[nb_type]=7;
                    nb_type++;
                    num_scale++;
                }
                else if(name[0]=='r' && name[1]=='a' && name[2]=='d' && name[3]=='i'  && name[4]=='o' && name[5]=='a' && name[6]=='r' && name[7]=='e' && name[8]=='a')
                {
                    fgets(line,500,f);
                    strcpy(name,keep_name(line));
                    first_is_item=0;
                    while(!(name[0]=='/' && name[1]=='r' && name[2]=='a' && name[3]=='d' && name[4]=='i'  && name[5]=='o' && name[6]=='a' && name[7]=='r' && name[8]=='e' && name[9]=='a'))
                    {
                        if(name[0]=='r' && name[1]=='a' && name[2]=='d' && name[3]=='i' && name[4]=='o' && strlen(name)==5 && first_is_item==0)
                        {
                            strcpy(extract,simple_extract(line));
                            radio_reference=num_radio;
                            plugin.radio[num_radio]=g_malloc(sizeof(GtkWidget*));
                            plugin.radio[num_radio]=gtk_radio_button_new_with_label(NULL,extract);
                            gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.radio[num_radio], FALSE, FALSE, 0);
                            first_is_item=1;
                            if(num_param_load<nb_param_load)
                            {
                                sscanf(param_load[num_param_load],"%d",&buffer_load);
                                gtk_toggle_button_set_active(plugin.radio[num_radio],buffer_load);
                                num_param_load++;
                            }
                            num_radio++;
                        }
                        else if(name[0]=='r' && name[1]=='a' && name[2]=='d' && name[3]=='i' && name[4]=='o' && strlen(name)==5 && first_is_item==1)
                        {
                            strcpy(extract,simple_extract(line));
                            plugin.radio[num_radio]=g_malloc(sizeof(GtkWidget*));
                            plugin.radio[num_radio]=gtk_radio_button_new_with_label_from_widget(plugin.radio[radio_reference],extract);
                            gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.radio[num_radio], FALSE, FALSE, 0);
                            if(num_param_load<nb_param_load)
                            {
                                sscanf(param_load[num_param_load],"%d",&buffer_load);
                                gtk_toggle_button_set_active(plugin.radio[num_radio],buffer_load);
                                num_param_load++;
                            }
                            num_radio++;
                        }
                        fgets(line,500,f);
                        strcpy(name,keep_name(line));
                        type[nb_type]=8;
                        nb_type++;
                    }
                    first_is_item=0;
                }
                else if(name[0]=='t' && name[1]=='o' && name[2]=='g' && name[3]=='g'  && name[4]=='l' && name[5]=='e' && name[6]=='a' && name[7]=='r' && name[8]=='e' && name[9]=='a')
                {
                    fgets(line,500,f);
                    strcpy(name,keep_name(line));
                    toggle_cpt=0;
                    while(!(name[0]=='/' && name[1]=='t' && name[2]=='o' && name[3]=='g' && name[4]=='g' && name[5]=='l' && name[6]=='e' && name[7]=='a' && name[8]=='r' && name[9]=='e' && name[10]=='a' && strlen(name)==11))
                    {
                        if(name[0]=='t' && name[1]=='o' && name[2]=='g' && name[3]=='g' && name[4]=='l' && name[5]=='e' && strlen(name)==6)
                        {
                            if(toggle_cpt==0)
                            {
                                strcpy(extract,simple_extract(line));

                                plugin.container.hbox=gtk_hbox_new(TRUE,10);

                                plugin.toggle[num_toggle]=g_malloc(sizeof(GtkWidget*));
                                plugin.toggle[num_toggle]=gtk_toggle_button_new_with_label(extract);

                                gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.toggle[num_toggle], FALSE, TRUE, 0);
                                gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.container.hbox, FALSE, FALSE, 0);
                                num_toggle++;
                                toggle_cpt++;
                            }
                            else if(toggle_cpt==1)
                            {
                                toggle_cpt=0;
                                strcpy(extract,simple_extract(line));

                                plugin.toggle[num_toggle]=g_malloc(sizeof(GtkWidget*));
                                plugin.toggle[num_toggle]=gtk_toggle_button_new_with_label(extract);

                                gtk_box_pack_start (GTK_BOX (plugin.container.hbox), plugin.toggle[num_toggle], FALSE, TRUE, 0);

                                num_toggle++;
                            }
                            strcpy(param,keep_param(line));
                            if(param[0]=='p' && param[1]=='a' && param[2]=='r' && param[3]=='a' && param[4]=='m' && param[5]=='=')
                            {
                                count=param_count(param);
                                if(count>0)
                                {
                                    strcpy(extract_param,param_extract(param,0));
                                    if(extract_param[0]=='a' && extract_param[1]=='c' && extract_param[2]=='t' && extract_param[3]=='i' && extract_param[4]=='v' && extract_param[5]=='e')
                                    {
                                        if(extract_param[7]=='t' && extract_param[8]=='r' && extract_param[9]=='u' && extract_param[10]=='e') gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plugin.toggle[num_toggle-1]),TRUE);
                                        if(extract_param[7]=='f' && extract_param[8]=='a' && extract_param[9]=='l' && extract_param[10]=='s' && extract_param[11]=='e') gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plugin.toggle[num_toggle-1]),FALSE);
                                    }
                                }
                            }
                        }
                        if(num_param_load<nb_param_load)
                        {
                            sscanf(param_load[num_param_load],"%d",&buffer_load);
                            gtk_toggle_button_set_active(plugin.toggle[num_toggle-1],buffer_load);
                            num_param_load++;
                        }
                        fgets(line,500,f);
                        strcpy(name,keep_name(line));
                        type[nb_type]=9;
                        nb_type++;
                    }
                    toggle_cpt=0;
                }
            }
            fgets(line,500,f);
            end=feof(f);
        }
        fclose(f);

        printf("Window is ok\n");
        if(window_declared)
        {
            i=0;
            num_entry=0;
            num_spin=0;
            num_check=0;
            num_combo=0;
            num_scale=0;
            num_radio=0;
            num_toggle=0;
            type[nb_type]=0;
            nb_type++;
            type[nb_type]=0;
            nb_type++;
            type[nb_type]=0;
            nb_type++;
            type[nb_type]=0;
            nb_type++;
            while(i<nb_type)
            {
                if(type[i]==3)
                {
                    g_slist_append (list, (gpointer) plugin.entry[num_entry]);
                    num_entry++;
                }
                if(type[i]==4)
                {
                    g_slist_append (list, (gpointer) plugin.spin[num_spin]);
                    num_spin++;
                }
                if(type[i]==5)
                {
                    g_slist_append (list, (gpointer) plugin.check[num_check]);
                    num_check++;
                }
                if(type[i]==6)
                {
                    g_slist_append (list, (gpointer) plugin.combo[num_combo]);
                    num_combo++;
                }
                if(type[i]==7)
                {
                    g_slist_append (list, (gpointer) plugin.scale[num_scale]);
                    num_scale++;
                }
                if(type[i]==8)
                {
                    g_slist_append (list, (gpointer) plugin.radio[num_radio]);
                    num_radio++;
                }
                if(type[i]==9)
                {
                    g_slist_append (list, (gpointer) plugin.toggle[num_toggle]);
                    num_toggle++;
                }
                i++;
            }

            g_slist_append (list,script_file);
            g_slist_append (list,save_file);
            g_slist_append (list,visual_file);

            printf("List is ok\n");

            plugin.confirm=gtk_button_new_with_label("Valider");
            gtk_box_pack_start (GTK_BOX (plugin.container.VBox), plugin.confirm, FALSE, FALSE, 20);
            gtk_signal_connect_object(GTK_OBJECT(plugin.confirm), "clicked", plugin_export, list);

            printf("No error Before_gwsa\n");

            if(plugin.window!=NULL)gtk_widget_show_all(plugin.window);

            printf("No error After_gwsa\n");
        }
    }
    else{
        printf("Fichier inexistant !\n");
    }
}

char* simple_extract(char* line)
{
    int i=0;
    int j=0;
    char extract[200];
    while(line[i]!='>') i++;
    i++;
    while(line[i]!='<')
    {
        extract[j]=line[i];
        i++;
        j++;
    }
    extract[j]='\0';
    return extract;
}

char* keep_name(char* line)
{
    int i=0;
    int j=0;
    char name[200];
    while((line[i]!='<') && (line[i]!='\n')) i++;
    if(line[i]!='\n')
    {
        i++;
        while(line[i]==' ')i++;
        while(line[i]!='>' && line[i]!=' ')
        {
            name[j]=line[i];
            i++;
            j++;
        }
        name[j]='\0';
    }
    else{
        name[0]='n';
        name[1]='o';
        name[2]='\0';
    }
    usleep(500);
    return name;
}

int widget_count(char* file,int* nb_entry,int* nb_spin, int* nb_check,int* nb_combo,int* nb_scale,int *nb_radio,int* nb_toggle,int* nb_box_toggle)
{
    short oef=0,end=0;
    int box_update=0;
    int toggle_in_area=0;
    char line[500],name[200];
    FILE* f=NULL;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        fgets(line,500,f);
        end=feof(f);

        *nb_entry=0;
        *nb_spin=0;
        *nb_check=0;
        *nb_combo=0;
        *nb_scale=0;
        *nb_radio=0;
        *nb_scale=0;
        *nb_radio=0;
        *nb_toggle=0;
        *nb_box_toggle=0;

        while(end!=1)
        {
            strcpy(name,keep_name(line));
            if(name[0]=='e' && name[1]=='n' && name[2]=='t' && name[3]=='r' && name[4]=='y') (*nb_entry)++;
            if(name[0]=='s' && name[1]=='p' && name[2]=='i' && name[3]=='n') (*nb_spin)++;
            if(name[0]=='c' && name[1]=='h' && name[2]=='e' && name[3]=='c' && name[4]=='k') (*nb_check)++;
            if(name[0]=='c' && name[1]=='o' && name[2]=='m' && name[3]=='b' && name[4]=='o') (*nb_combo)++;
            if(name[0]=='s' && name[1]=='c' && name[2]=='a' && name[3]=='l' && name[4]=='e') (*nb_scale)++;
            if(name[0]=='r' && name[1]=='a' && name[2]=='d' && name[3]=='i' && name[4]=='o' && strlen(name)==5) (*nb_radio)++;
            if(name[0]=='t' && name[1]=='o' && name[2]=='g' && name[3]=='g' && name[4]=='l' && name[5]=='e' && strlen(name)==6)
            {
                (*nb_toggle)++;
                toggle_in_area++;
            }
            if(name[0]=='/' && name[1]=='t' && name[2]=='o' && name[3]=='g' && name[4]=='g' && name[5]=='l' && name[6]=='e' && name[7]=='a' && name[8]=='r' && name[9]=='e' && name[10]=='a' && strlen(name)==11)
            {
                box_update=toggle_in_area%2;
                if(box_update==0)
                {
                    box_update=toggle_in_area/2;
                }
                else if(box_update==1)
                {
                    box_update=(toggle_in_area/2)+1;
                }
                toggle_in_area=0;
                *nb_box_toggle+=box_update;
            }
            fgets(line,500,f);
            end=feof(f);
        }
        fclose(f);
        printf("entry:%d spin:%d check:%d combo:%d scale:%d radio:%d toggle:%d box_toggle:%d\n",*nb_entry,*nb_spin,*nb_check,*nb_combo,*nb_scale,*nb_radio,*nb_toggle,*nb_box_toggle);
        return 0;
    }
    return 1;
}

char* keep_param(char* line)
{
    int i=0;
    int j=0;
    char param[200];
    while((line[i]!='<') && (line[i]!='\n')) i++;
    if(line[i]!='\n')
    {
        i++;
        while(line[i]==' ')i++;
        while(line[i]!=' ' && line[i]!='>') i++;
        while(line[i]==' ')i++;
        if(line[i]!='>')
        {
            while(line[i]!='>' && line[i]!=' ')
            {
                param[j]=line[i];
                i++;
                j++;
            }
            param[j]='\0';
        }
        else
        {
            param[0]='n';
            param[1]='o';
            param[2]='\0';
        }
    }
    else{
        param[0]='n';
        param[1]='o';
        param[2]='\0';
    }
    usleep(500);
    return param;
}

int param_count(char* param)
{
    int count=0;
    int i=0;
    while(param[i]!='\0')
    {
        if(param[i]==':') count++;
        i++;
    }
    return count;
}

char* param_extract(char* param,int num)
{
    int i=7,j=0;
    int count=0;
    char extract[100];
    int end=0;

    while(count<num && !end)
    {
        if(param[i]=='"' || param[i]=='\'') end=1;
        if(param[i]==';')
        {
            count++;
            if(param[i+1]=='"' || param[i+1]=='\'')
            {
                end=1;
            }
        }
        i++;
    }
    if(!end)
    {
        while(param[i]!='"' && param[i]!='\'' && param[i]!=';')
        {
            extract[j]=param[i];
            i++;
            j++;
        }
        extract[j]='\0';
    }
    else
    {
        extract[0]='n';
        extract[1]='o';
        extract[2]='\0';
    }
    usleep(500);
    return extract;
}
